SystemOrganization addCategory: #'Seaside-Platform'!
SystemOrganization addCategory: #'Seaside-Continuations'!
SystemOrganization addCategory: #'Seaside-Utilities'!
SystemOrganization addCategory: #'Seaside-Configuration'!
SystemOrganization addCategory: #'Seaside-Base'!
SystemOrganization addCategory: #'Seaside-HtmlBuilder'!
SystemOrganization addCategory: #'Seaside-Session'!
SystemOrganization addCategory: #'Seaside-StateRegistry'!
SystemOrganization addCategory: #'Seaside-Rendering'!
SystemOrganization addCategory: #'Seaside-RenderLoop'!
SystemOrganization addCategory: #'Seaside-Strings'!
SystemOrganization addCategory: #'Seaside-Component'!
SystemOrganization addCategory: #'Seaside-Components-Decorations'!
SystemOrganization addCategory: #'Seaside-Components-Frames'!
SystemOrganization addCategory: #'Seaside-Components-Dialogs'!
SystemOrganization addCategory: #'Seaside-Components-Widgets'!
SystemOrganization addCategory: #'Seaside-Components-Tools'!
SystemOrganization addCategory: #'Seaside-Components-Tools-Squeak'!
SystemOrganization addCategory: #'Seaside-Examples-Test'!
SystemOrganization addCategory: #'Seaside-Examples-Store-Model'!
SystemOrganization addCategory: #'Seaside-Examples-Store'!
SystemOrganization addCategory: #'Seaside-Contrib'!

ByteArray variableByteSubclass: #WAExternalID
	instanceVariableNames: ''
	classVariableNames: 'Generator GeneratorMutex'
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new
	^ self new: self defaultSize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:34'!
defaultSize
	^ 8! !

!WAExternalID methodsFor: 'private' stamp: 'ab 5/29/2003 00:00'!
printOn: stream
	self do: [:i | stream nextPut: (Character value: i)]! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:53'!
new: aNumber
	^ (super new: aNumber) initialize! !

!WAExternalID class methodsFor: 'as yet unclassified' stamp: 'ab 7/11/2003 00:09'!
fromString: aString
	| id |
	id _ super new: aString size.
	aString withIndexDo: [:ea :i | id at: i put: ea asInteger].
	^ id
! !

!WAExternalID methodsFor: 'private' stamp: 'jf 3/4/2004 00:34'!
initialize
	GeneratorMutex critical:
		[1 to: self size do: [:i | self at: i put: ((($a to: $z), ($A to: $Z)) atRandom: Generator) asInteger]]! !

!WAExternalID class methodsFor: 'class initialization' stamp: 'jf 3/4/2004 00:29'!
initialize
	"WAExternalID initialize"

	GeneratorMutex _ Semaphore forMutualExclusion.
	Generator _ Random new.! !

Object subclass: #WARenderLoop
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/2/2004 01:20'!
alwaysRedirect	
	^ self application preferenceAt: #alwaysRedirect! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:58'!
root: aComponent
	self basicRoot: ((self application preferenceAt: #deploymentMode)
					ifFalse: [WAToolFrame on: aComponent]
					ifTrue: [aComponent])! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 5/18/2004 16:16'!
redirect	
	self alwaysRedirect ifTrue:
		[self session respond:
			[:url |
			self updateUrl: url.
			WAResponse redirectTo: url asString]]! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:28'!
session
	^ WACurrentSession value! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 14:00'!
call: aComponent
	^ self call: aComponent withToolFrame: true! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:39'!
application
	^ self session application! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 4/13/2004 20:57'!
updateUrl: aUrl
	root visiblePresentersDo: [:c | c updateUrl: aUrl]! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/10/2004 16:08'!
withPageExpiredHandler: aBlock
	^ aBlock on: WAPageExpired do: [:n |]! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:58'!
basicRoot: aComponent
	root _ aComponent! !

!WARenderLoop methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:45'!
start: aRequest
	request _ aRequest.
	self run.! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/10/2004 16:03'!
run
	[self withPageExpiredHandler:
		[self withRenderNowHandler: [self render].
		self redirect]] repeat! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 2/10/2004 16:03'!
withRenderNowHandler: aBlock
	^ aBlock
		on: WARenderNotification do: [:n]! !

!WARenderLoop methodsFor: 'rendering' stamp: 'avi 5/18/2004 16:16'!
render
	|request context document |
	
	context _ WARenderingContext new request: self session currentRequest.
	request _ self session respond:
				[:url | |response|
				response _ WAResponse new.
				document _ WAHtmlStreamDocument new.
				self updateUrl: url.
				context actionUrl: url; document: document.
				root decorationChainDo: [:ea | ea renderWithContext: context].
				document writeOn: response stream.
				response]. 

	root decorationChainDo: [:ea | ea processRequestInputs: request context: context].
	root decorationChainDo: [:ea | ea processRequestActions: request context: context]! !

!WARenderLoop methodsFor: 'call' stamp: 'avi 5/8/2004 13:59'!
call: aComponent withToolFrame: aBoolean
	aBoolean ifTrue: [self root: aComponent] ifFalse: [self basicRoot: aComponent].
	aComponent onAnswer: [:v | ^ v].
	self run! !

Object subclass: #WAWebTreeImageProvider
	instanceVariableNames: ''
	classVariableNames: 'Images'
	poolDictionaries: ''
	category: 'Seaside-Contrib'!

!WAWebTreeImageProvider commentStamp: 'TBn 4/28/2004 17:49' prior: 0!
This class provides the image resources for the web tree.
To use custom images either use the #at:put: method
on the class side or override the #imageProvider method
in a subclass of WAWebTreeComponent!

!WAWebTreeImageProvider class methodsFor: 'image accessing' stamp: 'TBn 4/28/2004 17:42'!
plusImageBottom
	^self treeImages 
		at: #plusImageBottom 
		ifAbsentPut: [
			(ColorForm
				extent: 19@16
				depth: 2
				fromArray: #( 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4289374911 4227858432 4288535999 4227858432 4290197439 4227858432 4288486847 4227858432 4289725371 3087007744 4288486847 4227858432 4290197439 4227858432 4288535999 4227858432 4289374911 4227858432 4294967295 4227858432 4294967295 4227858432 4294967295 4227858432)
				offset: 0@0)
				colorsFromArray: #(#(0.0 0.0 0.004) #(1.0 1.0 1.0) #(0.501 0.501 0.501) #( ))]
	! !

!WAWebTreeImageProvider class methodsFor: 'image accessing' stamp: 'TBn 4/28/2004 17:42'!
branchImageBottom
	^self treeImages 
		at: #branchImageBottom 
		ifAbsentPut: [
			(ColorForm
				extent: 19@16
				depth: 2
				fromArray: #( 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294949819 3087007744 4294967295 4227858432 4294967295 4227858432 4294967295 4227858432 4294967295 4227858432 4294967295 4227858432 4294967295 4227858432 4294967295 4227858432)
				offset: 0@0)
				colorsFromArray: #(#(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.501 0.501 0.501) #( ))]! !

!WAWebTreeImageProvider class methodsFor: 'image accessing' stamp: 'TBn 4/28/2004 17:42'!
verticalImage
	^self treeImages 
		at: #verticalCenter 
		ifAbsentPut: [
			(ColorForm
				extent: 16@16
				depth: 1
				fromArray: #( 4286513152 4294901760 4286513152 4294901760 4286513152 4294901760 4286513152 4294901760 4286513152 4294901760 4286513152 4294901760 4286513152 4294901760 4286513152 4294901760)
				offset: 0@0)
				colorsFromArray: #(#(0.501 0.501 0.501) #( )  )]
	! !

!WAWebTreeImageProvider class methodsFor: 'image accessing' stamp: 'TBn 4/28/2004 17:42'!
minusImageCenter
	^self treeImages 
		at: #minusImageCenter 
		ifAbsentPut: [
		(ColorForm
			extent: 19@16
			depth: 2
			fromArray: #( 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4289374911 4227858432 4288535999 4227858432 4290213823 4227858432 4288535999 4227858432 4289725371 3087007744 4288535999 4227858432 4290213823 4227858432 4288535999 4227858432 4289374911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432)
			offset: 0@0)
			colorsFromArray: #(#(0.0 0.0 0.004) #(1.0 1.0 1.0) #(0.501 0.501 0.501) #( )  )]
	! !

!WAWebTreeImageProvider class methodsFor: 'image accessing' stamp: 'TBn 4/28/2004 17:42'!
minusImageBottom
	^self treeImages 
		at: #minusImageBottom 
		ifAbsentPut: [
			(ColorForm
				extent: 19@16
				depth: 2
				fromArray: #( 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4289374911 4227858432 4288535999 4227858432 4290213823 4227858432 4288535999 4227858432 4289725371 3087007744 4288535999 4227858432 4290213823 4227858432 4288535999 4227858432 4289374911 4227858432 4294967295 4227858432 4294967295 4227858432 4294967295 4227858432)
				offset: 0@0)
				colorsFromArray: #(#(0.0 0.0 0.0) #(1.0 1.0 1.0) #(0.501 0.501 0.501) #( ))]
	! !

!WAWebTreeImageProvider class methodsFor: 'image accessing' stamp: 'TBn 4/28/2004 17:42'!
plusImageCenter
	^self treeImages 
		at: #plusImageCenter 
		ifAbsentPut: [
			(ColorForm
				extent: 19@16
				depth: 2
				fromArray: #( 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4289374911 4227858432 4288535999 4227858432 4290197439 4227858432 4288486847 4227858432 4289725371 3087007744 4288486847 4227858432 4290197439 4227858432 4288535999 4227858432 4289374911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432)
				offset: 0@0)
				colorsFromArray: #(#(0.0 0.0 0.004) #(1.0 1.0 1.0) #(0.501 0.501 0.501) #( )  )]
	! !

!WAWebTreeImageProvider class methodsFor: 'image accessing' stamp: 'TBn 4/28/2004 17:42'!
branchImageCenter
	^self treeImages 
		at: #branchImageCenter 
		ifAbsentPut: [
		(ColorForm
			extent: 19@16
			depth: 2
			fromArray: #( 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294949819 3087007744 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432 4294950911 4227858432 4294967295 4227858432)
			offset: 0@0)
			colorsFromArray: #(#(0.0 0.0 0.004) #(1.0 1.0 1.0) #(0.501 0.501 0.501) #( ))]
	! !

!WAWebTreeImageProvider class methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:43'!
treeImages

	Images isNil ifTrue: [Images := Dictionary new].
	^Images! !

!WAWebTreeImageProvider class methodsFor: 'initialize-release' stamp: 'TBn 4/28/2004 17:43'!
release
	Images := nil! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|members|
	members _ self class allInstVarNames
					collect: [:ivar | ivar -> (self instVarNamed: ivar)].
						
	self class isVariable ifTrue:
		[members _ members, ((1 to: self size) collect: [:i | i -> (self at: i)])].
	^ members! !

Object subclass: #WAStringLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Strings'!

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 13:14'!
at: aSymbol put: aString
	| key |
	key _ (aSymbol asLegalSelector copyWithout: $:) asSymbol.
	self class compile: key, '^
', aString printString.
	(self keys includes: key) ifFalse: [self keys: (self keys copyWith: key)]! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 13:06'!
values
	^ self keys collect: [:ea | self at: ea]! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 13:06'!
at: aSymbol
	^ self perform: aSymbol asSymbol! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 13:11'!
keysAndValuesDo: aBlock
	self keys do: [:ea | aBlock value: ea value: (self perform: ea)]! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 13:16'!
keys: anArray
	self class compile: 'keys^
', anArray printString! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 13:11'!
do: aBlock
	self keysAndValuesDo: [:k :v | aBlock value: v]! !

!WAStringLibrary methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 13:14'!
keys
	^ #()! !

Object subclass: #WAResponse
	instanceVariableNames: 'contentType headers cookies status stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
cookies
	^ cookies ifNil: [#()]! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:26'!
redirectTo: aString
	self headerAt: 'Location' put: aString.
	self redirect.! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPutAll: aString
	aString do: [:ea | self nextPut: ea]! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:15'!
refreshWithMessage: aString location: locationString delay: aNumber
	^ self new nextPutAll:
		 ('<html>
			<head>
			<meta http-equiv="refresh" content="',aNumber asString,';URL=',locationString,'">
			<title>',aString,'</title>
			</head>
			<body>
			<h1>',aString,'</h1>
			You are being redirected to <a href="',locationString,'">',locationString,'</a>
			</body>
		</html>');
		yourself
	! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:15'!
notFound: locationString
	^ self new
		notFound;
		nextPutAll: '<h1> Error: "', locationString, '" not found. </h1>';
		yourself! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:50'!
status
	^ status! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
stream: aStream
	stream _ aStream! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/22/2004 15:24'!
initialize
	stream _ SeasidePlatformSupport readWriteStream.
	status _ '200'.
	contentType _ 'text/html; charset=utf-8'.
! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents: aStream
	stream _ aStream! !

!WAResponse methodsFor: 'convenience' stamp: 'avi 5/18/2004 14:25'!
basicAuthenticationRealm: aString
	self headerAt: 'WWW-Authenticate' put: ('Basic realm="',aString,'"').
	self authenticationFailed! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:15'!
redirectTo: locationString
	^ self new redirectTo: locationString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:28'!
headers
	^ headers ifNil: [#()]! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:27'!
headerAt: key put: value
	headers ifNil: [headers _ Dictionary new].
	headers at: key put: value! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:25'!
status: statusString
	status _ statusString asString! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:26'!
redirect
	self status: 302! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:27'!
addCookie: aCookie
	cookies ifNil: [cookies _ OrderedCollection new].
	cookies add: aCookie! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:14'!
new
	^ self basicNew initialize! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:21'!
contents
	^ stream reset! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:14'!
internalError: anError
	^ self new
		internalError;
		nextPutAll: '<h1> Internal Error</h1>';
		nextPutAll: '<h2>';
		nextPutAll: anError asString;
		nextPutAll: '</h2>';
		yourself! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:14'!
basicAuthWithRealm: aString
	^ self new basicAuthenticationRealm: aString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 2/6/2004 15:28'!
stream
	^ stream! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 15:57'!
internalError
	self status: 500! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
authenticationFailed
	self status: 401! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType
	^ contentType! !

!WAResponse methodsFor: 'status' stamp: 'avi 5/18/2004 14:25'!
notFound
	self status: 404! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/7/2003 11:12'!
nextPut: aCharacter
	stream nextPut: aCharacter asCharacter! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:23'!
cookieAt: key put: value
	self addCookie: (WACookie key: key value: value)! !

!WAResponse methodsFor: 'accessing' stamp: 'ab 7/3/2002 21:58'!
contentType: mimeTypeString
	contentType _ mimeTypeString! !

!WAResponse methodsFor: 'accessing' stamp: 'avi 5/18/2004 16:01'!
release
	stream _ cookies _ headers _ nil! !

!WAResponse class methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 22:49'!
document: anObject mimeType: mimeType
	|doc|
	doc _ anObject asMIMEDocument.
	^ self new
		contentType: (mimeType ifNil: [doc contentType]);
		headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT';
		nextPutAll: doc content! !

Object subclass: #WAConfigurationPool
	instanceVariableNames: 'configurations'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:01'!
remove: aConfiguration
	configurations remove: aConfiguration ifAbsent: []! !

!WAConfigurationPool class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:51'!
new
	^ self basicNew initialize! !

WAConfigurationPool subclass: #WASystemConfigurationPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WASystemConfigurationPool methodsFor: 'as yet unclassified' stamp: 'cwp 3/26/2004 21:37'!
configurations
	^ configurations copy addAll:
		 (WASystemConfiguration allSubclasses collect: [:ea | ea localConfiguration])! !

!WASystemConfigurationPool class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:55'!
default
	^ self named: #defaultSystemPool! !

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:51'!
add: aConfiguration
	configurations add: aConfiguration! !

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:52'!
configurations
	^ configurations! !

!WAConfigurationPool class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:04'!
initialize
	Registry _ Dictionary new! !

!WAConfigurationPool methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:51'!
initialize
	configurations _ Set new! !

!WAConfigurationPool class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:51'!
named: aSymbol
	^ Registry at: aSymbol ifAbsentPut: [self new]! !

Object subclass: #WAAbstractHtmlBuilder
	instanceVariableNames: 'attributeBuffer'
	classVariableNames: 'HtmlCharacters'
	poolDictionaries: ''
	category: 'Seaside-HtmlBuilder'!

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 11/24/2003 11:54'!
listItem: aBlock
	self tag: #li do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:04'!
table: aBlock
	self tag: 'table' do: aBlock! !

!WAAbstractHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'jf 2/27/2004 15:41'!
initialize
	"WAHtmlBuilder initialize"
	| collection |
	collection _ OrderedCollection ofSize: 256.
	
	0 to: 127 do: [:ea | collection at: ea + 1 put: ea asCharacter].
	
	#($" 'quot' $< 'lt' $& 'amp' $> 'gt') pairsDo:
		[:c :s | collection at: (c asInteger + 1) put: ('&',s,';') ].

	#('#128' '#129' '#130' 'fnof' '#132' 'hellip' 'dagger' 'Dagger' '#136' 'permil' 'Scaron' 'lsaquo' 'OElig' '#141' '#142' '#143' '#144' 'lsquo' 'rsquo' 'ldquo' 'rdquo' 'bull' 'ndash' 'mdash' 'tilde' 'trade' 'scaron' 'rsaquo' 'oelig' '#157' '#158' 'Yuml' 'nbsp' 'iexcl' 'cent' 'pound' 'curren' 'yen' 'brvbar' 'sect' 'uml' 'copy' 'ordf' 'laquo' 'not' 'shy' 'reg' 'hibar' 'deg' 'plusmn' 'sup2' 'sup3' 'acute' 'micro' 'para' 'middot' 'cedil' 'sup1' 'ordm' 'raquo' 'frac14' 'frac12' 'frac34' 'iquest' 'Agrave' 'Aacute' 'Acirc' 'Atilde' 'Auml' 'Aring' 'AElig' 'Ccedil' 'Egrave' 'Eacute' 'Ecirc' 'Euml' 'Igrave' 'Iacute' 'Icirc' 'Iuml' 'ETH' 'Ntilde' 'Ograve' 'Oacute' 'Ocirc' 'Otilde' 'Ouml' 'times' 'Oslash' 'Ugrave' 'Uacute' 'Ucirc' 'Uuml' 'Yacute' 'THORN' 'szlig' 'agrave' 'aacute' 'acirc' 'atilde' 'auml' 'aring' 'aelig' 'ccedil' 'egrave' 'eacute' 'ecirc' 'euml' 'igrave' 'iacute' 'icirc' 'iuml' 'eth' 'ntilde' 'ograve' 'oacute' 'ocirc' 'otilde' 'ouml' 'divide' 'oslash' 'ugrave' 'uacute' 'ucirc' 'uuml' 'yacute' 'thorn' 'yuml' ) withIndexDo:
		[:s :i | collection at: i + 128 put:  ('&',s,';')].
	
	HtmlCharacters _ collection asArray.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:49'!
anchorWithMailto: emailString
	self anchorWithUrl: 'mailto:', emailString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
bold: aBlock
	self tag: 'b' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/13/2004 22:42'!
image: urlString width: width height: height altText: altString
	self attributeAt: 'width' put: width.
	self attributeAt: 'height' put: height.
	self attributeAt: 'border' put: 0.
	
	self image: urlString altText: altString! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: x with: y with: z
	self tableRow: [ self tableData: x; tableData: y; tableData: z]! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'avi 2/7/2004 02:02'!
buttonWithType: typeString named: nameString value: valueString do: aBlock
	nameString ifNotNil:
		[self attributes
			at: 'name' put: nameString;
			at: 'id' ifAbsentPut: nameString].
	valueString ifNotNil: [self attributes value: valueString asString].
		
	self attributes type: typeString.
	
	self tag: 'button' do: aBlock.
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTable: aBlock
	self attributes
		border: 0;
		cellspacing: 0;
		cellpadding: 0.
	self table: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString
	self openTag: aString.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 11/20/2003 18:41'!
formWithMethod: methodString action: actionUrl do: aBlock
	self attributes method: methodString;
			action: actionUrl.
	self tag: 'form' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:10'!
tableRowWith: aBlock span: aNumber
	self tableRow: [ self tableData: aBlock span: aNumber]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:01'!
html: aString
	self document text: aString.! !

WAAbstractHtmlBuilder subclass: #WAHtmlBuilder
	instanceVariableNames: 'document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HtmlBuilder'!

!WAHtmlBuilder methodsFor: 'as yet unclassified' stamp: 'avi 2/18/2004 19:46'!
document
	^ document! !

!WAHtmlBuilder methodsFor: 'as yet unclassified' stamp: 'avi 2/18/2004 19:46'!
document: aDocument
	document _ aDocument! !

!WAHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'avi 2/18/2004 19:46'!
on: aDocument
	^ self new document: aDocument! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divClass: aString with: anObject
	self cssClass: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/1/2004 20:50'!
anchorWithMailto: emailString subject: subjectString
	self anchorWithUrl: 'mailto:', emailString, '?subject=', subjectString do: emailString! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
underline: aBlock
	self tag: 'u' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
title: aString
	self headTag: 'title' with: aString! !

!WAAbstractHtmlBuilder methodsFor: 'model' stamp: 'ac 9/22/2003 16:35'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
submitButton
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'jf 1/12/2004 16:41'!
inputWithType: type named: name value: value
	name ifNotNil:
		[self attributes
			at: 'name' put: name;
			at: 'id' ifAbsentPut: name].
	value ifNotNil: [self attributes value: value asString].
		
	self attributes type: type.
	
	self tag: 'input'.
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 01:08'!
acronym: titleString do: aBlock
	self attributes at: 'title' put: titleString.
	self tag: 'acronym' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:02'!
encodeText: anObject
	"deprecated"
	self text: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock with: anotherBlock
	self tableRow: [ self tableData: aBlock; tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 5/30/2003 00:29'!
spacerRow
	self tableRowWith: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:24'!
list: aCollection do: aBlock
	self unorderedList:
		[aCollection do:
			[:item |
			self listItem: [aBlock value: item]]]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableHeading: aBlock
	self tag: 'th' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:44'!
closeTag: aString
	self document closeTag: aString ! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:23'!
image: urlString width: width height: height
	self image: urlString width: width height: height altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:03'!
text: anObject
	self html: (self class encode: anObject)! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:33'!
divNamed: aString with: anObject
	self cssId: aString; div: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanNamed: aString with: anObject
	self cssId: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'jf 2/18/2004 15:03'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger asString, ';').  ! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph: aBlock
	self tag: 'p' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'ab 7/3/2003 14:56'!
buttonForUrl: urlString withText: labelString
	self buttonForUrl: urlString withText: labelString data: #()
! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 1/11/2003 12:44'!
attributes: aCollection
	aCollection associationsDo: [:x | self attributeAt: x key put: x value]! !

WAAbstractHtmlBuilder subclass: #WAHtmlRenderer
	instanceVariableNames: 'context callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/14/2004 23:22'!
openSelect
	| name |
	name _ self callbacks registerDispatchCallback.
	self attributes
		at: 'name' put: name;
		at: 'id' ifAbsentPut: name.
	self openTag: 'select'.	! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:47'!
context
	^ context! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 3/13/2004 22:49'!
dateInputWithValue: aDate callback: aBlock
	| values |
	aBlock fixTemps.
	
	values _ Array new: 3.
	self
		selectFromList: (1 to: 12)
		selected: aDate monthIndex 
		callback: [ :month | values at: 2 put: month ]
		labels: [:ea | Date nameOfMonth: ea].
	self space.
	self
		textInputWithValue: aDate dayOfMonth 
		callback: [ :day | values at: 1 put: day ]
		maxLength: 2.
	self space.
	self 
		textInputWithValue: aDate year
		callback: [ :year | values at: 3 put: year]
		maxLength: 4.
	self hiddenInputWithCallback:
		[aBlock value: (Date
				newDay: (values first min: (Date daysInMonth: values second forYear: values third))
				monthNumber: values second
				year: values third)].
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:54'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock
	self openSelect.
	callbackBlock fixTemps.

	aCollection do:
		[:item |
		self
			optionWithLabel: (labelsBlock value: item)
			selected: (item = selectedObject)
			callback: [callbackBlock value: item]].
	self closeTag: 'select'.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 2/10/2004 20:47'!
submitButtonWithAction: actionBlock image: aForm
	self attributes
		src: (self urlForDocument: aForm);
		width: aForm width;
		height: aForm height.
	self inputWithType: 'image'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/22/2004 18:45'!
radioButtonInGroup: radioGroupKey withValue: value on: aSelector of: anObject
	self
		radioButtonInGroup: radioGroupKey
		selected: (value = (anObject perform: aSelector))
		callback: [anObject perform: aSelector asMutator with: value]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/21/2004 18:31'!
unorderedList: aCollection selected: anObject callback: aBlock labels: labelBlock
	aBlock fixTemps.
	self cssClass: 'options'.
	self unorderedList: [
		aCollection do:
			[:ea |
			self cssClass: 'option'.
			ea = anObject ifTrue: [self cssId: 'option-selected'].
			self listItem: [self anchorWithAction: [aBlock value: ea] text: (labelBlock value: ea)]].
	]! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
radioGroup
	^ self callbacks registerDispatchCallback.! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForList: aCollection on: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self
			selectFromList: aCollection
			selected: (anObject perform: aSymbol)
			callback: (self callbackForSelector: aSymbol of: anObject)]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
submitButtonWithAction: aBlock text: aString
	self attributeAt: 'value' put: aString.
	self submitButtonWithAction: aBlock! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForCheckboxOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self checkboxOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'jf 1/12/2004 14:35'!
checkboxOn: aSymbol of: anObject
	self
		checkboxWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 5/6/2003 18:37'!
booleanMenuWithValue: aBoolean callback: callbackBlock labels: labelArray
	self
		selectFromList: (Array with: true with: false)
		selected: aBoolean
		callback: callbackBlock
		labels: [:b | b ifTrue: [labelArray first] ifFalse: [labelArray second]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
submitButtonOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		submitButtonWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 3/22/2004 01:18'!
imageMapWithAction: aBlock form: aForm
	|point pointKey url |
	aBlock fixTemps.
	point _ ValueHolder new.
	pointKey _ self callbacks registerCallback:
								[:ptString |
								point contents: (self parseImageMap: ptString)].
	url _ self urlForAction: [aBlock value: point contents].
	
	self
		attributeAt: 'href'
		put: url, '&', pointKey, '='.
	self tag: 'a' do: [
		self attributeAt: 'border' put: 0; attributeAt: 'ismap' put: true.
		self imageWithForm: aForm.
	]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:15'!
textInputWithCallback: callbackBlock
	self textInputWithValue: '' callback: callbackBlock! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/21/2004 18:10'!
unorderedListOn: aSymbol of: anObject list: aCollection
	self
		unorderedList: aCollection
		selected: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:31'!
anchorWithAction: actionBlock do: linkBlock
	self openAnchorWithAction: actionBlock.
	self render: linkBlock.
	self closeTag: 'a'.

! !

!WAHtmlRenderer methodsFor: 'compound' stamp: 'avi 3/13/2004 14:19'!
timeInputWithValue: aTime callback: aBlock
	| values |
	aBlock fixTemps.
	values _ Array new: 2.
	self
		textInputWithValue: aTime hour
		callback: [:hour | values at: 1 put: hour]
		maxLength: 2.
	self space; text: ':'; space.
	self
		textInputWithValue: aTime minutes asTwoCharacterString
		callback: [:minute | values at: 2 put: minute asNumber]
		maxLength: 2.
	self hiddenInputWithCallback:
		[aBlock value:
			(Time
				hour: values first
				minute: (values second min: 59)
				second: 0)]
		
	
	! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 1/23/2004 01:31'!
anchorWithAction: actionBlock text: aString
	self anchorWithAction: actionBlock do: aString! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 5/18/2004 13:41'!
fileUploadWithCallback: aBlock
	aBlock fixTemps.
	self
		inputWithType: 'file'
		named: (self callbacks registerCallback: [:f | aBlock value: (f = '' ifFalse: [f])])
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 7/11/2003 00:09'!
parseImageMap: aString
	|s x y|
	('?*,*' match: aString) ifFalse: [^ nil].
	s _ aString readStream.
	s upTo: $?.
	x _ s upTo: $,.
	y _ s upToEnd.
	^ x asNumber @ y asNumber
	! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
textInputOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		textInputWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/22/2004 01:19'!
form: aBlock
	self
		formWithMethod: 'post'
		action: context actionUrl urlString
		do: 
			[context actionUrl parameters keysAndValuesDo:
				[:k :v |
				self inputWithType: 'hidden' named: k value: v].
		
			aBlock value].
! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 3/22/2004 01:21'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ (self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)) asString! !

!WAHtmlRenderer class methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 12:20'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/20/2003 18:43'!
anchorWithDocument: anObject mimeType: mimeType fileName: fileName text: aString
	self openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName.
	self text: aString.
	self closeTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 12/5/2003 00:51'!
hiddenInputWithCallback: callbackBlock
	self inputWithType: 'hidden' named: (self callbacks registerCallback: callbackBlock)
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:31'!
labelledRowForTextInputOn: aSymbol of: anObject
	self labelledRowForTextInputOn: aSymbol of: anObject size: nil! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:58'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: labelsBlock nilLabel: aString
	self selectFromList: (Array with: nil), aCollection asArray
		selected: selectedObject
		callback: callbackBlock
		labels: [:ea | ea ifNil: [aString] ifNotNil: [labelsBlock value: ea]]! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
textAreaOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		textAreaWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 2/7/2004 02:09'!
anchorWithAction: actionBlock image: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:01'!
response
	^ self context response! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:24'!
linkWithScript: jsString
	self scriptWithUrl: (self urlForDocument: jsString mimeType: 'text/javascript' fileName: nil)! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
callbackForSelector: aSymbol of: anObject
	^ MessageSend receiver: anObject selector: (aSymbol copyWith: $:) asSymbol! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
radioButtonInGroup: radioGroupKey selected: aBoolean callback: callbackBlock
	self attributeAt: 'checked' put: aBoolean.
	
	self inputWithType: 'radio' named: radioGroupKey value: (self callbacks registerCallback: callbackBlock)! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
submitButtonWithAction: actionBlock
	self inputWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
valueInputOfType: typeString value: anObject callback: callbackBlock
	|updateKey callback value|
	value _ anObject.
	callback _ callbackBlock.
	anObject isNumber ifTrue:
		[anObject isFraction
			ifTrue:
				[value _ anObject asFloat asString.
				callback _ [:v | callbackBlock value:
									(v = value ifTrue: [anObject] ifFalse: [v asNumber])]]
			ifFalse:
				[callback _ [:v | callbackBlock value: v asNumber]]].
	anObject isNil ifTrue:
		[value _ ''.
		callback _ [:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]].
					
	updateKey _ self callbacks registerCallback: callback.
	self inputWithType: typeString named: updateKey value: value.
	^ updateKey
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:46'!
document
	^ context document! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
textInputWithValue: anObject callback: callbackBlock
	self
		valueInputOfType: 'text'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
labelledRowForTextAreaOn: aSymbol of: anObject
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[self textAreaOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'IP 10/31/2003 12:26'!
openAnchorWithDocument: anObject mimeType: mimeType fileName: fileName
	self attributeAt: 'href' put: (self urlForDocument: anObject mimeType: mimeType fileName: fileName).
	self openTag: #a.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 2/12/2003 17:21'!
booleanMenuWithValue: aBoolean callback: callbackBlock
	self booleanMenuWithValue: aBoolean callback: callbackBlock labels: #(Yes No)! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 2/12/2003 19:41'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
selectFromList: aCollection selected: selectedObject callback: callbackBlock
	self selectFromList: aCollection selected: selectedObject callback: callbackBlock labels: [:i | i asString]! !

WAHtmlRenderer subclass: #WAWebTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Contrib'!

!WAWebTreeRenderer commentStamp: 'TBn 4/28/2004 20:15' prior: 0!
This is a special render subclass providing additional support for
html rendering!

!WAWebTreeRenderer methodsFor: 'anchors' stamp: 'TBn 4/28/2004 19:05'!
anchorWithAction: actionBlock actionForm: aForm
	self anchorWithAction: actionBlock do: [self actionImageWithForm: aForm]! !

!WAWebTreeRenderer methodsFor: 'image-handling' stamp: 'TBn 4/28/2004 17:48'!
imageCellFor: image actionBlock: aBlock

	self 
		attributeAt: 'width' put: image width; 
		tableData: [self anchorWithAction: aBlock actionForm: image]! !

!WAWebTreeRenderer methodsFor: 'image-handling' stamp: 'TBn 4/28/2004 17:48'!
imageCellFor: aForm  
	
	self 
		attributeAt: 'width' put: aForm width;
		tableData: [self imageWithForm: aForm]! !

!WAWebTreeRenderer methodsFor: 'image-handling' stamp: 'TBn 4/28/2004 19:09'!
actionImageWithForm: aForm
	self 
		image: (self urlForDocument: aForm) 
		width: aForm width 
		height: aForm height
		borderSize: 0! !

!WAWebTreeRenderer methodsFor: 'image-handling' stamp: 'TBn 4/28/2004 19:09'!
image: urlString width: width height: height borderSize: borderSize
	self attributeAt: 'width' put: width.
	self attributeAt: 'height' put: height.
	self attributeAt: 'border' put: borderSize.
	self image: urlString! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ self context request! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/13/2004 14:17'!
textInputWithValue: anObject callback: callbackBlock maxLength: aNumber
	self attributes
		at: 'size' put: aNumber;
		at: 'maxlength' put: aNumber.
	self textInputWithValue: anObject callback: callbackBlock.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'jf 11/21/2003 17:47'!
checkboxWithValue: aBoolean callback: callbackBlock
	| value |
	value _ ValueHolder new.
	self hiddenInputWithCallback: [value contents: false].

	self attributeAt: 'checked' put: aBoolean.
	self 
		valueInputOfType: 'checkbox'
		value: 'true'
		callback: [value contents: true]. 
		
	callbackBlock fixTemps.
	self hiddenInputWithCallback: [callbackBlock value: value contents].
! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:49'!
defaultAction: actionBlock
	self
		inputWithType: 'hidden'
		named: (self callbacks registerActionCallback: actionBlock)
! !

!WAHtmlRenderer methodsFor: 'javascript' stamp: 'avi 2/19/2004 12:06'!
anchorWithPopupAction: aBlock extent: aPoint text: aString
	self
		anchorWithPopupUrl: (self urlForAction: aBlock)
		extent: aPoint
		text: aString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'avi 11/3/2003 12:25'!
anchorWithDocument: anObject mimeType: mimeType text: aString
	self anchorWithDocument: anObject mimeType: mimeType fileName: nil text: aString! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/24/2003 16:14'!
passwordInputWithCallback: callbackBlock
	self
		valueInputOfType: 'password'
		value: ''
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 5/21/2004 18:09'!
unorderedList: aCollection selected: anObject callback: aBlock
	self unorderedList: aCollection selected: anObject  callback: aBlock labels: [:ea | ea asString]! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 6/25/2003 23:03'!
selectInputOn: selectedSymbol of: anObject list: aCollection
	self
		selectFromList: aCollection
		selected: (anObject perform: selectedSymbol)
		callback: (self callbackForSelector: selectedSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 4/8/2003 14:26'!
anchorWithAction: actionBlock form: aForm
	self anchorWithAction: actionBlock do: [self imageWithForm: aForm.]
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'JF 6/2/2003 13:30'!
labelledRowForTextInputOn: aSymbol of: anObject size: sizeIntegerOrNil
	self tableRowWithLabel: (self labelForSelector: aSymbol) column: 
		[sizeIntegerOrNil ifNotNil: [self attributeAt: #size put: sizeIntegerOrNil].
		self textInputOn: aSymbol of: anObject]! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:29'!
callbacks
	^ callbacks! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 1/11/2003 13:28'!
anchorWithDocument: anObject text: aString
	self anchorWithDocument: anObject mimeType: nil text: aString! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'JF 5/27/2003 15:18'!
imageWithForm: aForm
	self image: (self urlForDocument: aForm) width: aForm width height: aForm height! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'ab 1/11/2003 13:28'!
hiddenInputWithValue: anObject callback: callbackBlock
	self valueInputOfType: 'hidden'
		value: anObject
		callback: callbackBlock
! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 4/13/2004 19:48'!
registry
	^ WACurrentSession value application ! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 2/7/2004 02:07'!
submitButtonWithAction: actionBlock do: aBlock
	self buttonWithType: 'submit'
		named: (self callbacks registerActionCallback: actionBlock)
		value: nil
		do: aBlock
! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 1/11/2003 13:28'!
anchorOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		anchorWithAction: (MessageSend receiver: anObject selector: aSymbol)
		text: (self labelForSelector: aSymbol)! !

!WAHtmlRenderer methodsFor: 'accessing' stamp: 'avi 3/22/2004 12:20'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context _ aRenderingContext.
	callbacks _ aCallbackStore.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 3/22/2004 01:15'!
urlForAction: actionBlock
	| url |
	url _ context actionUrl withParameter:  (self callbacks registerActionCallback: actionBlock).
	^ url asString! !

!WAHtmlRenderer methodsFor: 'model' stamp: 'ab 2/12/2003 17:21'!
booleanMenuOn: aSymbol of: anObject
	self
		cssId: aSymbol;
		booleanMenuWithValue: (anObject perform: aSymbol)
		callback: (self callbackForSelector: aSymbol of: anObject)! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/21/2004 00:03'!
openAnchorWithAction: actionBlock
	self
		attributeAt: 'href'
		put: (self urlForAction: actionBlock).
	self openTag: 'a'.! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 1/14/2004 23:23'!
textAreaWithValue: value callback: callbackBlock
	|callback name |
	callback _ value
					ifNil: [[:v | callbackBlock value: (v = '' ifTrue: [nil] ifFalse: [v])]]
					ifNotNil: [callbackBlock].
	name _ self callbacks registerCallback: callback.
	self attributes
		at: 'name' put: name;
		at: 'id' ifAbsentPut: name.
	
	self tag: 'textarea' do: value.! !

!WAHtmlRenderer methodsFor: 'documents' stamp: 'ab 2/12/2003 19:40'!
linkWithStyle: cssString
	self styleLinkWithUrl: (self urlForDocument: cssString mimeType: 'text/css')! !

!WAHtmlRenderer methodsFor: 'core' stamp: 'avi 11/20/2003 18:48'!
optionWithLabel: labelString selected: aBoolean callback: callbackBlock
	self 
		attributeAt: 'selected' put: aBoolean;
		attributeAt: 'value' put: (self callbacks registerCallback: callbackBlock).
	
	self tag: 'option' do: labelString.! !

!WAHtmlRenderer methodsFor: 'convenience' stamp: 'avi 3/16/2004 01:07'!
autofocus: aBlock
	| id |
	id _ 1000 atRandom.
	self cssId: id.
	aBlock value.
	self script: 'document.getElementById("', id asString, '").focus()'! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:48'!
styleLinkWithUrl: urlString
	self attributes
		at: 'rel' put: 'stylesheet';
		at: 'type' put: 'text/css';
		at: 'href' put: urlString.
	self headTag: 'link'! !

!WAAbstractHtmlBuilder methodsFor: 'javascript' stamp: 'avi 3/13/2004 01:37'!
anchorWithPopupUrl: urlString extent: aPoint text: aString
	self attributes
		at: 'target' put: 'new';
		at: 'onClick' put: 'window.open(''',
	urlString, 
	''','''',''width=',
	aPoint x asString,
	',height=',
	aPoint y asString,
	',scrollbars=yes,resizable=yes,menubar=yes''); return false'.
	
	self anchorWithUrl: urlString do: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:26'!
inputWithType: type
	self inputWithType: type named: nil
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 4/15/2004 12:06'!
anchorWithName: aString
	self attributes name: aString.
	self tag: #a.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
div: aBlock
	self tag: 'div' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ab 5/12/2003 11:27'!
attributes
	^ attributeBuffer ifNil: [attributeBuffer _ WAHtmlAttributes new]! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
metaTagNamed: nameString content: contentString
	self attributes
		at: 'name' put: nameString;
		at: 'content' put: contentString.
	self headTag: 'meta'.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
paragraph
	self tag: 'p'! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRow: aBlock
	self tag: 'tr' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/17/2004 12:32'!
shouldCloseTag: aString
	^ #(#hr #br #input #img #link)! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
list: aCollection
	self list: aCollection do: [:x | self text: x]! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:51'!
openTag: aString
	self document openTag: aString attributes: self attributes.
	attributeBuffer _ nil.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
heading: anObject level: aNumber
	self tag: 'h', aNumber asString do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
span: aBlock
	self tag: 'span' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableRowWith: aBlock
	self tableRow: [ self tableData: aBlock ]! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/16/2003 00:35'!
spanClass: aString with: anObject
		self cssClass: aString; span: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString
	self image: urlString altText: ''! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'ac 5/16/2003 16:11'!
render: anObject
	anObject renderOn: self! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
heading: aString
	self heading: aString level: 1! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:16'!
formWithAction: actionUrl do: aBlock
	self formWithMethod: 'post' action: actionUrl do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:41'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self tag: aMessage selector].
	argCount = 1 ifTrue: [^ self tag: aMessage selector allButLast do: aMessage argument].
	^ super doesNotUnderstand: aMessage
! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 4/24/2004 13:05'!
attributeAt: aString put: anObject
	self attributes at: aString put: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 2/19/2004 18:20'!
space: aNumber
	aNumber timesRepeat: [self space]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'avi 3/15/2004 16:23'!
unorderedList: aBlock
	self tag: 'ul' do: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'basic markup' stamp: 'avi 11/20/2003 18:40'!
tag: aString do: anObject
	self openTag: aString.
	self render: anObject.
	self closeTag: aString.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/13/2003 00:07'!
emphasis: aBlock
	self tag: 'em' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 2/18/2004 15:04'!
space
	self html: '&nbsp;'! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:25'!
inputWithType: type named: name	
	self inputWithType: type named: name value: nil.
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'rbb 6/11/2003 17:01'!
italic: aBlock
	self tag: 'i' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:02'!
break
	self tag: 'br'! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:19'!
submitButtonWithText: aString
	self attributes value: aString.
	self inputWithType: 'submit'
! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssId: aString
	self attributeAt: 'id' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'css' stamp: 'ab 2/12/2003 21:04'!
cssClass: aString
	self attributeAt: 'class' put: aString! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:29'!
tableRowWithLabel: anObject column: aBlock column: anotherBlock
	self tableRow: [
		self cssClass: 'label'.
		self tableData: anObject.
		self tableData: aBlock; tableData: anotherBlock]! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/12/2003 21:03'!
horizontalRule
	self tag: 'hr'! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/12/2003 21:05'!
tableData: aBlock
	self tag: 'td' do: aBlock! !

!WAAbstractHtmlBuilder class methodsFor: 'as yet unclassified' stamp: 'avi 4/24/2004 13:03'!
encode: anObject
	| charOrString |
	^ String streamContents:
		[:s |
		anObject asString do:
			[:char |
			charOrString _ HtmlCharacters at: char asInteger + 1.
			charOrString isString
				ifTrue: [s nextPutAll: charOrString]
				ifFalse: [s nextPut: charOrString]]]! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'ab 2/16/2003 00:26'!
tableHeadings: aCollection
	self tableRow: [aCollection do: [:ea | self tableHeading: ea]]! !

!WAAbstractHtmlBuilder methodsFor: 'accessing' stamp: 'avi 11/20/2003 18:45'!
document
	self subclassResponsibility ! !

!WAAbstractHtmlBuilder methodsFor: 'forms' stamp: 'JF 6/2/2003 19:53'!
buttonForUrl: urlString withText: labelString data: assocCollection
	self formWithMethod: 'GET' action: urlString do:
		[assocCollection do: 
			[:each | self
				inputWithType: 'hidden'
				named: each key asString
				value: each value].
		self submitButtonWithText: labelString]
! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'JF 6/10/2003 18:12'!
layoutTableOfWidth: width do: aBlock
	self attributes width: width.
	self layoutTable: aBlock! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'ab 2/16/2003 00:24'!
preformatted: anObject
	self tag: 'pre' do: anObject! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'jf 1/12/2004 16:21'!
image: urlString altText: altString
	self attributeAt: 'alt' put: altString.
	self attributeAt: 'src' put: urlString.
	
	self tag: #img.! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:19'!
anchorWithUrl: urlString title: titleString do: aBlock
	self attributes	title: titleString.
	self anchorWithUrl: urlString do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'tables' stamp: 'avi 2/19/2004 18:11'!
tableData: aBlock span: aNumber
	aNumber > 0 ifTrue:
		[self attributes at: 'colspan' put: aNumber.
		self tableData: aBlock]
! !

!WAAbstractHtmlBuilder methodsFor: 'html' stamp: 'JF 6/10/2003 19:20'!
anchorWithUrl: urlString do: aBlock
	self attributes href: urlString.
	self tag: 'a' do: aBlock.! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'avi 11/20/2003 18:39'!
headTag: aString
	self document headTag: aString attributes: self attributes.
	attributeBuffer _ nil.! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'avi 11/20/2003 18:39'!
headTag: aString with: child
	self document headTag: aString attributes: self attributes content: child.
	attributeBuffer _ nil.! !

!WAAbstractHtmlBuilder methodsFor: 'head' stamp: 'ab 6/13/2003 17:50'!
scriptWithUrl: urlString
	self attributes
		at: 'language' put: 'javascript';
		at: 'src' put: urlString.
	self headTag: 'script'.! !

Object subclass: #WAStoreAddress
	instanceVariableNames: 'name street city country'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreAddress commentStamp: 'avi 1/1/2004 07:36' prior: 0!
A simple model of a billing or shipping address.  Stores strings for a person's name, street, city, and country.  Apart from accessors for these, the only behavior this provides is a #validate method which will throw errors if street, city, or country is nil.!

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
city
	^ city! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
country
	^ country! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
name: aString
	name _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
city: aString
	city _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:05'!
validate
	street ifNil: [self error: 'You must provide a street address.'].
	city ifNil: [self error: 'You must provide a city.'].
	country ifNil: [self error: 'You must provide a country.'].! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:52'!
street: aString
	street _ aString! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
name
	^ name! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
street
	^ street! !

!WAStoreAddress methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:53'!
country: aString
	country _ aString! !

Object subclass: #WAUrl
	instanceVariableNames: 'host port scheme path params fragment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme
	^ scheme! !

!WAUrl methodsFor: 'private' stamp: 'avi 3/22/2004 00:47'!
defaultPortForScheme: aSymbol
	^ aSymbol = #http
		ifTrue: [80]
		ifFalse: [aSymbol = #https
					ifTrue: [443]]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
port
	^ port ifNil: [self defaultPortForScheme: scheme]! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString value: valueString
	^ self copy
		addParameter: aString value: valueString;
		yourself! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/18/2004 16:07'!
port: aNumber
	port _ aNumber! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:35'!
fragmentString
	^ fragment ifNil: [''] ifNotNil: ['#', fragment]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addToPath: aString
	path addAll: (aString findTokens: '/')! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment
	^ fragment! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 13:11'!
parameters
	^ params! !

!WAUrl methodsFor: 'printing' stamp: 'avi 3/19/2004 14:27'!
pathString
	^ String streamContents: [:s | path do: [:ea | s nextPut: $/; nextPutAll: ea]]! !

!WAUrl methodsFor: 'printing' stamp: 'avi 3/22/2004 00:48'!
serverString
	host ifNil: [^ ''].
	
	^ String streamContents:
		[:stream |
		stream nextPutAll: scheme.
		stream nextPutAll: '://'.
		stream nextPutAll: host.
		
		((self defaultPortForScheme: scheme) = port)
			ifFalse: [stream nextPutAll: ':', port asString]]! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 4/15/2004 11:35'!
fragment: aString
	fragment _ aString! !

!WAUrl methodsFor: 'printing' stamp: 'avi 3/22/2004 00:42'!
asString
	^ self urlWithQueryString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname
	^ host! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:46'!
path
	^ path! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:47'!
scheme: aSymbol
	scheme _ aSymbol! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:36'!
urlString
	^ self serverString, self pathString, self fragmentString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:52'!
with: pathString
	^ self copy
		addToPath: pathString;
		yourself! !

!WAUrl methodsFor: 'copying' stamp: 'avi 4/15/2004 11:35'!
copy
	| copy |
	copy _ self class new.
	copy hostname: host; port: port; scheme: scheme; fragment: fragment.
	copy addToPath: self pathString.
	params keysAndValuesDo: [:k :v | copy addParameter: k value: v].
	^ copy! !

!WAUrl methodsFor: 'printing' stamp: 'avi 4/15/2004 11:34'!
urlWithQueryString
	^ String streamContents:
		[:s |
		s nextPutAll: self serverString.
		s nextPutAll: self pathString.
		params isEmpty ifFalse:
			[s nextPut: $?.
			params keysAndValuesDo: 
				[:k :v |
				s nextPutAll: k encodeForHTTP.
				v ifNotNil: [s nextPut: $=; nextPutAll: v encodeForHTTP].
				s nextPut: $&].
			s skip: -1].
		s nextPutAll: self fragmentString]! !

!WAUrl methodsFor: 'initialize-release' stamp: 'avi 3/22/2004 00:48'!
initialize
	path _ OrderedCollection new.
	params _ Dictionary new.
	scheme _ #http! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:46'!
addParameter: keyString value: valueString
	params at: keyString put: valueString! !

!WAUrl methodsFor: 'copying' stamp: 'avi 3/22/2004 00:51'!
withParameter: aString
	^ self copy
		addParameter: aString;
		yourself! !

!WAUrl class methodsFor: 'as yet unclassified' stamp: 'avi 3/18/2004 16:07'!
new
	^ self basicNew initialize! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/19/2004 14:37'!
hostname: aString
	host _ aString! !

!WAUrl methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:45'!
addParameter: aString
	self addParameter: aString value: nil
! !

Object subclass: #WAStoreCart
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCart commentStamp: 'avi 1/1/2004 07:44' prior: 0!
A shopping cart.  This is essentially a specialized Bag: you can #add: or #remove: WAStoreItems to it, and calculate their #totalPrice.  You can also use #countsAndItems to get a collection of associations between the items and the number of times they appear in the cart, useful for summary displays.!

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
remove: anObject
	items remove: anObject ifAbsent: []! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:01'!
hasItems
	^ items notNil and: [items isEmpty not]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:21'!
items
	^ items! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:41'!
totalPrice
	^ items detectSum: [:ea | ea price]! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
countsAndItems
	^ items sortedCounts! !

!WAStoreCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:36'!
add: anObject
	items ifNil: [items _ Bag new].
	items add: anObject! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl count callbacks document mode request response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ request! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 3/22/2004 12:14'!
nextKey
	^ count asString! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'avi 3/22/2004 12:43'!
initialize
	count _ 1.
	callbacks _ Dictionary new.! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode _ #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response
	^ response! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl: anObject
	"Set the value of actionUrl"

	actionUrl _ anObject! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response: aResponse
	response _ aResponse! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 3/22/2004 12:14'!
increaseKey
	count _ count + 1! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 3/22/2004 12:44'!
callbacksFor: anObject
	^ callbacks at: anObject ifAbsentPut: [WACallbackStore context: self]! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode _ nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document _ anObject! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext class methodsFor: 'as yet unclassified' stamp: 'avi 3/25/2004 02:21'!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request: aRequest
	request _ aRequest! !

Object subclass: #WAReportColumn
	instanceVariableNames: 'clickBlock formatBlock hasTotal title sortBlock valueBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 21:50'!
new
	^ super new initialize! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
initialize
	formatBlock _ [:x | x asString].
	sortBlock _ [:a :b | a <= b].
	valueBlock _ [:row | nil].
	clickBlock _ nil.
	title _ 'Untitled'.
	hasTotal _ false.! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/28/2002 14:02'!
clickBlock: aBlock
	clickBlock _ aBlock! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol
	^ self selector: aSymbol title: aSymbol capitalized! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
index: aNumber
	valueBlock _ [:row | row at: aNumber]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:29'!
hasTotal: aBoolean
	hasTotal _ aBoolean ! !

!WAReportColumn methodsFor: 'public' stamp: 'avi 9/18/2003 16:43'!
sortRows: anArray
	|assocs|
	assocs _ anArray collect: [:ea | ea -> (self valueForRow: ea)].
	assocs _ assocs asSortedCollection: [:a :b | sortBlock value: a value value: b value].
	^ assocs collect: [:ea | ea key]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
valueForRow: row
	^ valueBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
sortBlock: anObject
	sortBlock := anObject! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString onClick: aBlock
	^ self new
		title: aString;
		selector: aSymbol;
		clickBlock: aBlock! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
title: aString
	title _ aString! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:50'!
title
	^title! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:08'!
canSort
	^ sortBlock notNil! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/26/2002 21:51'!
textForRow: row
	^ formatBlock value: (self valueForRow: row)! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
valueBlock: aBlock
	valueBlock _ aBlock! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 1/16/2003 16:06'!
chooseRow: row
	^ clickBlock value: row! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 11/12/2002 14:03'!
columnClickBlock: aBlock
	self clickBlock: [:r | aBlock value: (self valueForRow: r)]! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 11/12/2002 14:31'!
totalForRows: aCollection
	^ hasTotal
		ifFalse: ['']
		ifTrue: [formatBlock value: (aCollection detectSum: [:r | self valueForRow: r])]! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:52'!
selector: aSymbol
	valueBlock _ [:row | row perform: aSymbol]! !

!WAReportColumn class methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:26'!
selector: aSymbol title: aString
	^ self selector: aSymbol title: aString onClick: nil! !

!WAReportColumn methodsFor: 'accessing' stamp: 'ab 10/26/2002 21:50'!
formatBlock: anObject
	formatBlock := anObject! !

!WAReportColumn methodsFor: 'public' stamp: 'ab 10/27/2002 00:05'!
canChoose
	^ clickBlock notNil! !

Object subclass: #WAStateRegistry
	instanceVariableNames: 'lastSnapshot objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 15:32'!
snapshot
	lastSnapshot := SeasidePlatformSupport weakDictionaryOfSize: objects size.
	objects keysAndValuesDo:
		[:obj :copy|
		(self snapshot: copy isIdenticalTo: obj)
			ifTrue: [lastSnapshot at: obj put: copy]
			ifFalse: [lastSnapshot at: obj put: obj shallowCopy]].
	^ lastSnapshot
! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:28'!
restoreLastSnapshot
	lastSnapshot ifNotNil: [self restoreSnapshot: lastSnapshot]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:11'!
restoreObject: object fromSnapshot: copy
	1 to: object class instSize do: [:i | object instVarAt: i put: (copy instVarAt: i)].
	object class isVariable ifTrue: [1 to: object size do: [:i | object at: i put: (copy at: i)]].
	objects at: object put: copy.! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:55'!
calculateFootprint
	^ (objects detectSum: [:ea | 2 + ea class instSize + (ea class isVariable ifTrue: [ea size + 1] ifFalse: [0])]) * 4! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:02'!
registerObject: anObject
	objects at: anObject put: anObject shallowCopy! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
size
	^ objects size! !

!WAStateRegistry class methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:38'!
new
	^ super new initialize! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:11'!
snapshot: copy isIdenticalTo: object
	1 to: object class instSize do: [:i | (copy instVarAt: i) == (object instVarAt: i) ifFalse: [^ false]].
	object class isVariable ifTrue:
		[1 to: object size do: [:i | (copy at: i) == (object at: i) ifFalse: [^ false]]].
	^ true! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:03'!
restoreSnapshot: aDictionary
	aDictionary keysAndValuesDo:
		[:k :v |
		self restoreObject: k fromSnapshot: v]! !

!WAStateRegistry methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:02'!
initialize
	objects _ SeasidePlatformSupport weakDictionaryOfSize: 10.! !

!Object methodsFor: '*seaside2' stamp: 'ab 10/26/2002 20:05'!
renderOn: aRenderer
	aRenderer text: self! !

Object subclass: #WAKom
	instanceVariableNames: 'entryPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

WAKom class
	instanceVariableNames: 'port service'!

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
stop
	self pause.
	port _ nil.
! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryComponent: aClass path: aString
	^ self dispatcher: (aClass applicationWithPath: aString)! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
startOn: aPort
	self stop.
	port _ aPort.
	service _ self createService.
	service start.
! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 14:11'!
validateForStack: anArray! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 10:57'!
convertRequest: aKomRequest
	| request |
	self processMultipartFields: aKomRequest.

	request _ WARequest
		method: aKomRequest method
		url: aKomRequest url unescapePercents 
		headers: aKomRequest header
		fields: (aKomRequest method = 'POST'
					ifTrue: [aKomRequest postFields]
					ifFalse: [aKomRequest getFields])
		cookies: aKomRequest cookies
		nativeRequest: aKomRequest.

	aKomRequest method = 'PUT'
		ifTrue: [request fields
					at: 'PUTData'
					put: (aKomRequest stream next: aKomRequest contentLength)].
	^ request! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setDebugMode
	service setDebugMode.! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:52'!
convertResponse: aResponse
	| komResponse |
	aResponse ifNil: [^ HttpResponse fromString: 'Request handling aborted; reload to retry'].

	komResponse _  HttpResponse new.

	aResponse cookies do:
		[:assoc | komResponse setCookieName: assoc key value: assoc valueWithExpiry path: assoc path].
		
	aResponse headers associationsDo: [:assoc | komResponse fieldAt: assoc key put: assoc value].
	(HttpResponse classPool at: #StatusCodes) associationsDo:
		[:assoc |
		assoc value key = aResponse status ifTrue: [komResponse status: assoc key]].
	komResponse contents: aResponse contents.
	komResponse contentType: aResponse contentType.

	^ komResponse
! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:54'!
createService
	Smalltalk at: #HttpService ifPresent:
		[:hs |
		^ (hs on: port named: 'seaside') plug: self default].
	Smalltalk at: #ComancheNetService ifPresent:
		[:cns |
		^ (cns named: 'seaside' onPort: port) module: self default]! !

!WAKom class methodsFor: 'service' stamp: 'avi 9/26/2003 23:52'!
pause
	service ifNotNil:
		[service unregister.
		service _ nil]! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 20:09'!
process: komRequest
	|request response komResponse |
	self log: komRequest.
	request _ self convertRequest: komRequest.

	response _ self handleRequest: request.
	komResponse _ self convertResponse: response.

	response release.
	^ komResponse! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:33'!
setDeploymentMode
	service setDeploymentMode.! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 13:53'!
processHttp
	HttpResponse current: (self process: HttpRequest current).
	^ true! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
initialize
		Smalltalk addToStartUpList: self after: AutoStart.
		Smalltalk addToShutDownList: self! !

!WAKom methodsFor: 'kom 6.1' stamp: 'ab 5/18/2003 11:24'!
processHttpRequest: aRequest
	^ self process: aRequest! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:42'!
shutdown
	self pause! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	entryPoint _ anEntryPoint! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'cwp 3/26/2004 23:03'!
handleRequest: aRequest
	^ (entryPoint handlerForRequest: aRequest) handleRequest: aRequest! !

!WAKom class methodsFor: 'service' stamp: 'ac 12/2/2003 12:32'!
setVerboseMode
	service setVerboseMode.! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:44'!
default
	^ self entryPoint: WADispatcher default! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 00:43'!
log: aRequest
	Transcript cr; show: aRequest url! !

!WAKom class methodsFor: 'as yet unclassified' stamp: 'avi 11/20/2003 01:13'!
entryPoint: anEntryPoint
	^ self new entryPoint: anEntryPoint! !

!WAKom methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:14'!
processMultipartFields: aRequest
	aRequest multipartFormFieldsDo:
		[:chunk |
		chunk fileName isEmptyOrNil ifFalse:
			[|stream file|
			stream _ WriteStream on: String new.
			chunk saveToStream: stream.
			file _ WAFile new fileName: chunk fileName; contents: stream contents; contentType: chunk contentType.
			aRequest postFields at: chunk fieldName put: file]].! !

!WAKom class methodsFor: 'service' stamp: 'ab 10/10/2002 11:41'!
startUp
	port ifNotNil: [self startOn: port]! !

Object subclass: #WAStateHolder
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:05'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	contents printOn: aStream.
	aStream nextPut: $).! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents
	^ contents! !

!WAStateHolder methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 01:04'!
contents: anObject
	contents _ anObject! !

!WAStateHolder class methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 19:48'!
new
	|inst|
	inst _ super new.
	WACurrentSession value registerObjectForBacktracking: inst.
	^ inst! !

Object subclass: #WAMain
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:31'!
session
	^ WACurrentSession value! !

WAMain subclass: #WARenderLoopMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:09'!
call: aComponent
	^ WARenderLoop new call: aComponent! !

WARenderLoopMain subclass: #WAAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthMain methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:16'!
createRoot
	| root |
	root _ super createRoot.
	root addDecoration: (WABasicAuthentication new authenticator: self).
	^ root! !

!WAAuthMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:12'!
verifyPassword: password forUser: username
	^ (self application preferenceAt: #login) = username and: [(self application preferenceAt: #password) = password]! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:59'!
start: aRequest
	(WARenderLoop new root: self createRoot) start: aRequest! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 17:45'!
rootClass
	^ self application preferenceAt: #rootComponent! !

!WARenderLoopMain methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:59'!
createRoot
	^ self rootClass new! !

!WAMain methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:37'!
application
	^ self session application! !

!WAMain methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 01:25'!
start: aRequest
	self subclassResponsibility! !

Object subclass: #WAFile
	instanceVariableNames: 'contents contentType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WAFile methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:13'!
contentType: aString
	contentType _ aString! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName: aString
	fileName _ aString! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:13'!
contentType
	^ contentType! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
fileName
	"compensate for windows explorer behavior"
	^ ('#:\*' match: fileName)
		ifTrue: [fileName copyAfterLast: $\]
		ifFalse: [fileName]! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents
	^ contents! !

!WAFile methodsFor: 'as yet unclassified' stamp: 'ab 10/31/2002 10:39'!
contents: aStream
	contents _ aStream! !

Object subclass: #WAStoreCreditCard
	instanceVariableNames: 'name number expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreCreditCard commentStamp: 'avi 1/1/2004 07:47' prior: 0!
Models credit card information - it has accessors for #name and #number (both strings), and #expiry date.  #validate throws an error if anything is missing, or if the expiry date is in the past.

This is intended to be an abstract class - the subclasses WAStoreMasterCard and WAStoreVisaCard provide further validation.!

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:03'!
expiry: aDate
	expiry _ aDate! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
number
	^ number! !

WAStoreCreditCard subclass: #WAStoreMasterCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreMasterCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds MasterCard-specific validation to WAStoreCreditCard.!

!WAStoreMasterCard methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 15:01'!
validate
	super validate.
	number first = $5 ifFalse: [self error: 'Mastercard numbers must start with "5"'].
! !

!WAStoreMasterCard class methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'MC'! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:01'!
name: aString
	name _ aString! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
number: aString
	number _ aString! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
expiry
	! !

WAStoreCreditCard subclass: #WAStoreVisaCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreVisaCard commentStamp: 'avi 1/1/2004 09:35' prior: 0!
Adds VISA-specific validation to WAStoreCreditCard.!

!WAStoreVisaCard class methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:04'!
abbreviation
	^ 'VISA'! !

!WAStoreVisaCard methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 15:00'!
validate
	super validate.
	number first = $4 ifFalse: [self error: 'Visa card numbers must start with "4"'].
! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:03'!
validate
	name ifNil: [self error: 'You must provide the name of the credit card owner.'].
	number ifNil: [self error: 'You must provide a credit card number.'].
	expiry ifNil: [self error: 'You must provide an expiry date.'].
	expiry < Date today ifTrue: [self error: 'The expiry date must not be in the past'].
	! !

!WAStoreCreditCard methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:02'!
name
	^ name! !

Object subclass: #WAErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAErrorHandler class methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:23'!
handleWarning: aWarning
	^ self new handleWarning: aWarning! !

!WAErrorHandler class methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:22'!
handleError: anError
	^ self new handleError: anError! !

WAErrorHandler subclass: #WAWalkbackErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WAWalkbackErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:07'!
handleWarning: aWarning
	WARenderLoop new call: (WAFormDialog new addMessage: aWarning messageText).
	aWarning resume.! !

!WAWalkbackErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 14:00'!
handleError: anError
	WARenderLoop new call: (WAWalkback new exception: anError) withToolFrame: false.
	anError defaultAction! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 16:54'!
handleWarning: aWarning
	self handleError: aWarning! !

WAErrorHandler subclass: #WASimpleErrorHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASimpleErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:16'!
handleError: anError
	WACurrentSession value returnResponse: (WAResponse internalError: anError)! !

!WAErrorHandler methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 16:54'!
handleError: anError
	anError pass! !

Object subclass: #SeasidePlatformSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 3/11/2004 13:13'!
deliverMailFrom: fromAddress to: recipientList text: messageText
	SMTPClient
		deliverMailFrom: fromAddress
		to: recipientList
		text: messageText
		usingServer: self smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:18'!
profileSendsDuring: aBlock
	Processor activeProcess priority: 20.
	Smalltalk garbageCollectMost.	
	^ String streamContents: 
			[:stream | 
			(MessageTally new)
				spyEvery: 1
				on: [aBlock value. Smalltalk garbageCollectMost];
				report: stream]! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 14:57'!
vmStatisticsReportString
	^ Utilities vmStatisticsReportString ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:04'!
mimeDocumentClass
	^ MIMEDocument ! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 3/11/2004 13:10'!
smtpServer
	^ MailSender smtpServer! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:25'!
readWriteStream
	^ RWBinaryOrTextStream on: String new! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
base64Decode: aString
	^ (Base64MimeConverter mimeDecodeToChars: aString readStream) contents
		! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:40'!
ensureAuthorInitials: aBlock
	Utilities authorInitialsPerSe isEmpty
		ifTrue: [Utilities setAuthorInitials: aBlock value].
! !

!SeasidePlatformSupport class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 13:02'!
weakDictionaryOfSize: aNumber
	| dict |
	dict _ WeakIdentityKeyDictionary new: aNumber.
	WeakArray addWeakDependent: dict.
	^ dict! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: 'response docType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HtmlBuilder'!

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:55'!
initialize! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:47'!
xmlDeclaration
	^ '<?xml version="1.0" encoding="UTF-8"?>'! !

!WAHtmlDocument class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:55'!
new
	^ self basicNew initialize! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'headStream bodyStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HtmlBuilder'!

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 15:19'!
writeOn: aStream
	aStream
		nextPutAll: self docType; cr;
		nextPutAll: '<html><head>';
		nextPutAll: headStream contents;
		nextPutAll: '</head><body>';
		nextPutAll: bodyStream contents;
		nextPutAll: '</body></html>'! !

!WAHtmlStreamDocument class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:31'!
new
	^ self basicNew initialize! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:31'!
writeOpenTag: aString attributes: anAttributes on: aStream
	aStream
		nextPut: $<;
		nextPutAll: aString.
	anAttributes writeOn: aStream.
	(self shouldPrintCloseTagFor: aString) ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:31'!
openTag: aString attributes: anAttributes
	self writeOpenTag: aString attributes: anAttributes on: bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:31'!
headTag: aString attributes: anAttributes
	self writeOpenTag: aString attributes: anAttributes on: headStream.
	self writeCloseTag: aString on: headStream.! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:52'!
writeCloseTag: aString on: aStream
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [aStream nextPutAll: '</'; nextPutAll: aString; nextPut: $>]! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:31'!
text: aString
	bodyStream nextPutAll: aString! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:30'!
closeTag: aString
	self writeCloseTag: aString on: bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:31'!
headTag: aString attributes: anAttributes content: contentString
	self writeOpenTag: aString attributes: anAttributes on: headStream.
	headStream nextPutAll: contentString.
	self writeCloseTag: aString on: headStream.! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:56'!
initialize
	headStream _ String new writeStream.
	bodyStream _ String new writeStream.! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:28'!
headTag: aString attributes: anAttributes content: contentString
	self subclassResponsibility ! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:59'!
writeOn: aStream
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:34'!
docType
	^ docType ifNil: ['<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">']! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:29'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:52'!
shouldPrintCloseTagFor: aString
	^(#('hr' 'br' 'input' 'img' 'link') includes: aString) not! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:29'!
response
	^ response! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:28'!
headTag: aString attributes: anAttributes
	self subclassResponsibility ! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:35'!
docType: aString
	docType _ aString! !

WAHtmlDocument subclass: #WAHtmlTreeDocument
	instanceVariableNames: 'head stack body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HtmlBuilder'!

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 11/20/2003 18:50'!
text: aString
	self addElement: aString! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 5/18/2004 13:50'!
headTag: aString attributes: anAttributes
	self head add:
		(WAHtmlElement named: aString attributes: anAttributes)
		notClosed;
		yourself! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'avi 11/20/2003 18:36'!
popElement
	^ stack removeLast! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 5/18/2004 13:51'!
openTag: aString attributes: anAttributes
	| element |
	element _ WAHtmlElement named: aString attributes: anAttributes.
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [element beClosed]
		ifFalse: [element notClosed].
	self pushElement: element! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:57'!
pushElement: anObject
	self addElement: anObject.
	stack add: anObject.! !

!WAHtmlTreeDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 15:18'!
writeOn: aStream
	aStream nextPutAll: self docType; cr.
	aStream nextPutAll: '<html>'.
	head writeOn: aStream.
	body writeOn: aStream.
	aStream nextPutAll: '</html>'.! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 11/20/2003 18:36'!
closeTag: aString
	self popElement name = aString ifFalse: [self error: 'Mismatched tags']! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:46'!
addElement: anObject
	stack last add: anObject! !

!WAHtmlTreeDocument methodsFor: 'markup' stamp: 'avi 5/18/2004 13:51'!
headTag: aString attributes: anAttributes content: contentString
	self head add:
		((WAHtmlElement named: aString attributes: anAttributes)
			add: contentString;
			beClosed;
			yourself)! !

!WAHtmlTreeDocument class methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 12:27'!
new
	^ super new initialize! !

!WAHtmlTreeDocument methodsFor: 'accessing' stamp: 'ab 1/11/2003 12:29'!
head
	^ head! !

!WAHtmlTreeDocument methodsFor: 'accessing' stamp: 'ab 1/11/2003 12:29'!
body
	^ body! !

!WAHtmlTreeDocument methodsFor: 'stack operations' stamp: 'ab 2/12/2003 21:58'!
withElement: anElement do: aBlock
	self pushElement: anElement.
	aBlock value.
	self popElement.! !

!WAHtmlTreeDocument methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:56'!
initialize
	head _ WAHtmlElement named: 'head'.
	body _ WAHtmlElement named: 'body'.
	stack _ OrderedCollection with: body! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:28'!
openTag: aString attributes: anAttributes
	self subclassResponsibility! !

WAHtmlDocument subclass: #WAPrettyPrintedDocument
	instanceVariableNames: 'html indentLevel indentCloseTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
openTag: aString attributes: anAttributes
	html break.
	indentLevel timesRepeat: [html space].
	
	html text: '<'.
	html spanClass: (self cssClassFor: aString) with: [html text: aString].
	
	self attributes: anAttributes.
	
	(self shouldPrintCloseTagFor: aString)
		ifFalse: [html space; text: '/'].
	html text: '>'.
	
	indentLevel _ indentLevel + 1.
	indentCloseTags removeLast; addLast: true; addLast: false.! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
text: aString
	html text: aString! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
attribute: anAssociation
	| attr value |
	attr _ anAssociation key asLowercase.
	value _ anAssociation value.
	
	value = false ifFalse:
		[html space.
		html spanClass: (self cssClassForAttribute: attr) with:
			[html text: attr].
		html text: '='.
		html spanClass: 'attribute-value' with:
			[html text: '"'.
			attr = 'href'
				ifTrue: [html anchorWithUrl: value do: (value size > 8 ifTrue: ['...', (value last: 8)] ifFalse: [value])]
				ifFalse:
					[value = true
						ifFalse: [html text: value asString]
						ifTrue: [html text: attr]].
			html text: '"']]! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
attributes: anAttributes
	anAttributes associations do: [:ea | self attribute: ea]
! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
headTag: aString attributes: anAttributes
	! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
cssClassForAttribute: aString
	^ (self isKnownAttribute: aString) ifTrue: ['attribute-known'] ifFalse: ['attribute-unknown']! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
headTag: aString attributes: anAttributes content: contentString
! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
closeTag: aString
	indentLevel _ indentLevel - 1.
	indentCloseTags removeLast ifTrue:
		[html break.
		indentLevel timesRepeat: [html space]].

	(self shouldPrintCloseTagFor: aString) ifTrue:
		[html text: '</'.
		html spanClass: (self cssClassFor: aString) with: [html text: aString].
		html text: '>'].
! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
isKnownTag: aString
	^ self knownTags includes: aString! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
cssClassFor: aString
	^ (self isKnownTag: aString) ifTrue: ['tag-known'] ifFalse: ['tag-unknown']! !

!WAPrettyPrintedDocument class methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
renderer: aRenderer
	^ self basicNew initializeWithRenderer: aRenderer! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
knownTags
	^ #(?xml
!!doctype
!!dt
a
abbr
acronym
address
applet
area
attach
b
base
basefont
bdo
big
blink
blockquote
body
br
button
caption
center
cite
code
col
colgroup
comment
component
dd
del
dfn
dir
div
dl
dt
em
fieldset
font
form
frame
frameset
h
h1
h2
h3
h4
h5
h6
head
hr
html
i
iframe
img
input
ins
isindex
kbd
label
legend
li
link
listing
map
menu
meta
multicol
nextid
nobr
noframes
noscript
object
ol
optgroup
option
p
param
plaintext
pre
q
s
samp
script
select
small
span
strike
strong
style
sub
sup
table
tbody
td
textarea
textflow
tfoot
th
thead
title
tr
tt
u
ul
var
wbr
xmp)! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:45'!
initializeWithRenderer: aRenderer.
	html _ aRenderer.
	indentCloseTags _ OrderedCollection with: false.
	indentLevel _ 0.! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
knownAttributes
	^ #(abbr
accept-charset
accept
accesskey
action
align
alink
alt
archive
axis
background
bgcolor
bgproperties
border
cellpadding
cellspacing
char
charoff
charset
checked
cite
class
classid
clear
code
codebase
codetype
color
cols
colspan
compact
content
coords
data
datetime
declare
defer
dir
direction
disabled
encoding
enctype
face
for
frame
frameborder
framespacing
gutter
headers
height
href
hreflang
hspace
http-equiv
id
ismap
label
lang
leftmargin
link
longdesc
loop
lowsrc
marginheight
marginwidth
maxlength
media
method
methods
multiple
name
nohref
noresize
noshade
nowrap
object
onabort
onblur
onchange
onclick
ondblclick
onerror
onfocus
onkeydown
onkeypress
onkeyup
onload
onmousedown
onmousemove
onmouseout
onmouseover
onmouseup
onreset
onselect
onsubmit
onunload
prompt
PUBLIC
readonly
rel
rev
rows
rowspan
rules
scheme
scope
scrolling
selected
shape
size
span
src
standby
style
summary
tabindex
target
text
title
type
urn
usemap
valign
value
valuetype
version
vlink
vspace
width
wrap
xml:lang
xmlns)! !

!WAPrettyPrintedDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:40'!
isKnownAttribute: aString
	^ self knownAttributes includes: aString asLowercase! !

Object subclass: #WAPresenter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAPresenter methodsFor: 'tree' stamp: 'avi 4/22/2004 14:51'!
nextPresentersDo: aBlock
	self childrenDo: [:ea | ea decorationChainDo: aBlock].
! !

WAPresenter subclass: #WAComponent
	instanceVariableNames: 'decoration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/29/2004 19:07'!
inform: aString
	self call: (WAFormDialog new addMessage: aString)
! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:36'!
decoration
	decoration ifNil: [decoration _ WAStateHolder new contents: self].
	^ decoration contents! !

WAComponent subclass: #WAHalo
	instanceVariableNames: 'target mode'
	classVariableNames: 'Halos'
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 18:06'!
initialize
	mode _ WAStateHolder new contents: #render:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:47'!
source: html
	| context |
	html linkWithStyle: self sourceStyle.

	context _ html context copy.
	context clearMode.
	context document: (WAPrettyPrintedDocument renderer: html).
	target renderWithContext: context! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:54'!
render: html
	target renderAllOn: html! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 13:22'!
renderHalo: iconKey withAction: aBlock on: html
	html
		anchorWithAction: aBlock
		text:  [html imageWithForm: (ScriptingSystem formAtKey: iconKey)].
! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 13:02'!
target: aComponent
	target _ aComponent! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 4/16/2004 17:33'!
renderMode
	mode contents: #render:! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:46'!
sourceStyle
	^'
.html-source {
	font-family: courier, serif;
	font-size: 9pt;
}

.xmlDeclaration {
	color: limegreen;
	font-style: italic;
}

.doctype {
	color: skyblue;
	font-style: italic;
}

.tag-known {
	color: purple;
	font-weight: bold;
}

.attribute-known {
	font-weight: bold;
}

.attribute-value {
	color: blue;
}

.template {
	color: blue;
	font-weight: bold;
}

'! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:31'!
renderContentOn: html
	html divClass: 'halo' with: [
		html divClass: 'halo-header' with: [
			html divClass: 'halo-icons' with: [
			html divClass: 'halo-mode' with: [
			html text: '['.
			html anchorWithAction: [self renderMode] text: 'R'.
			html text: ' | '.
			html anchorWithAction: [self sourceMode] text: 'S'.
			html text: ']'].
			html text: target class name.
			html space.
			self
				renderHalo: 'Halo-Debug'
				withPopup: [WABrowser fullOnClass: target class]
				on: html.
			self
				renderHalo: 'Halo-View'
				withPopup: [WAInspector on: target]
				on: html.
			self renderHalo: 'Halo-Paint'
				withPopup: [WAViewer on: target]
				on: html.
			].
		].
		html divClass: 'halo-contents' with: [self perform: mode contents with: html].
	]

! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:29'!
renderHalo: iconKey withPopup: componentBlock on: html
	html
		anchorWithPopupAction: [WARenderLoop new call: componentBlock value. self session closePopup]
		extent: 825@560
		text:  [html imageWithForm: (ScriptingSystem formAtKey: iconKey)].
! !

!WAHalo methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 18:07'!
sourceMode
	mode contents: #source:! !

!WAHalo class methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:26'!
for: aComponent
	Halos ifNil: [Halos _ SeasidePlatformSupport weakDictionaryOfSize: 20].
	^ Halos at: aComponent ifAbsentPut: [self new target: aComponent]! !

WAComponent subclass: #WAPath
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:09'!
initialize
	stack _ #().
	self session registerObjectForBacktracking: self.! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:09'!
renderContentOn: html
	stack isEmpty ifTrue: [^ self].
	
	html divNamed: 'path' with: [
		stack allButLast do:
			[:assoc |
			html anchorWithAction: [self choose: assoc] text: assoc key.
			html text: ' >> '].
		
		html bold: stack last key].! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:06'!
currentSegment
	^ stack isEmpty
		ifTrue: [nil]
		ifFalse: [stack last value]! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:06'!
pushSegment: anObject name: aString
	stack _ stack, (Array with: aString -> anObject)! !

!WAPath methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:16'!
choose: anAssociation
	| newStack |
	newStack _ Array new writeStream.
	stack do:
		[:ea |
		newStack nextPut: ea.
		ea == anAssociation
			ifTrue: [stack _ newStack contents. ^ self]]
! !

WAComponent subclass: #WAEncodingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAEncodingTest methodsFor: 'as yet unclassified' stamp: 'jf 2/18/2004 15:15'!
renderContentOn: html
	| w allChars r |

	w := WriteStream on: String new.
	32 to: 255 do: [ :c |  w nextPut: c asCharacter ].
	allChars := w contents.

	html code: [ 
		html text: 'Start'; break.
		r := ReadStream on: allChars.

		[ r atEnd ] whileFalse: [ 
			html text: (r next: 14);
			break.
		].
		html text: 'End'; 
			  break.
	].
	html text: 'Characters Encoded: '.
	'Hello World' do: [ :c | html encodeCharacter: c ]. 
	html break.
! !

WAComponent subclass: #WAReport
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:29'!
initialize
	rows _ #().
! !

!WAReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:03'!
rows: anArray
	rows _ anArray! !

WAReport subclass: #WATableReport
	instanceVariableNames: 'sortColumn isReversed columns rowPeriod rowColors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATableReport methodsFor: 'rendering' stamp: 'JF 2/3/2003 00:01'!
renderHeaderForColumn: aColumn on: html
	html tableHeading: [
		aColumn canSort
			ifTrue: [
				html anchorWithAction: [self sortColumn: aColumn] text: aColumn title]
			ifFalse: [
				html text: aColumn title]
	]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:29'!
columns: anArray
	columns _ anArray! !

!WATableReport methodsFor: 'state variables' stamp: 'AC 1/31/2003 11:46'!
sortColumn: anObject 
	anObject = self sortColumn
		ifTrue: [isReversed _ isReversed not]
		ifFalse: [isReversed _ false].
	sortColumn contents: anObject! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:46'!
rows
	| r |
	self sortColumn ifNil: [^ rows].
	r _ self sortColumn sortRows: rows.
	^ self isReversed ifTrue: [r reversed] ifFalse: [r]! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableHeaderOn: html
	html tableRow: [ columns do: [ :ea | self renderHeaderForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowPeriod: aNumber
	rowPeriod _ aNumber! !

!WATableReport methodsFor: 'rendering' stamp: 'AC 1/31/2003 11:26'!
renderRowsOn: html
	self rows withIndexDo: [:row :i | self renderRowNumber: i item: row on: html ]! !

!WATableReport methodsFor: 'state variables' stamp: 'ab 1/16/2003 17:47'!
sortColumn
	^ sortColumn contents! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'AC 1/31/2003 11:24'!
isReversed
	^ isReversed! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:45'!
renderTableFooterOn: html
	html tableRow: [ columns do: [ :ea | self renderFooterForColumn: ea on: html] ]! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 22:01'!
colorForRowNumber: aNumber
	^ rowColors at: ((aNumber-1 // rowPeriod) \\ rowColors size) + 1 ifAbsent: ['white']! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderContentOn: html
	html attributeAt: 'cellspacing' put: 0; attributeAt: 'cellpadding' put: 5.
	html table: [
		self renderTableHeaderOn: html.
		self renderRowsOn: html.
		self renderTableFooterOn: html.
	]! !

!WATableReport methodsFor: 'rendering' stamp: 'jf 2/18/2004 15:45'!
renderColumn: aColumn row: aRow on: html
	|text|
	text _ aColumn textForRow: aRow.
	text isEmpty ifTrue: [text _ ' '].
	html tableData: [
		aColumn canChoose
			ifFalse: [html text: text]
			ifTrue: [html anchorWithAction: [self chooseRow: aRow column: aColumn] text: text]
	]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 10/26/2002 22:04'!
rowColors: colorArray
	rowColors _ colorArray! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 5/6/2003 18:31'!
renderRowNumber: index item: row on: html
	html attributeAt: 'bgcolor' put: (self colorForRowNumber: index).
	html tableRow: [ columns do: [:ea | self renderColumn: ea row: row on: html] ]! !

!WATableReport methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:06'!
initialize
	super initialize.
	isReversed := false.
	columns := #().
	sortColumn := WAStateHolder new.
	rowColors := #('white' 'lightyellow').
	rowPeriod := 3! !

!WATableReport methodsFor: 'as yet unclassified' stamp: 'ab 11/11/2002 19:04'!
chooseRow: aRow column: aColumn	
	aColumn chooseRow: aRow! !

!WATableReport methodsFor: 'rendering' stamp: 'ab 11/12/2002 14:32'!
renderFooterForColumn: aColumn on: html
	html tableHeading: [ html text: (aColumn totalForRows: rows)]
! !

WAComponent subclass: #WAMiniCalendar
	instanceVariableNames: 'month date canSelectBlock selectBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 15:25'!
date
	^ date contents! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/25/2003 13:14'!
renderCellForDate: aDate on: html
	html tableData: [
		aDate month = self month ifTrue:
			[html cssClass: (self date = aDate ifTrue: ['calendarArchiveDate']).
			html span: [
			(self canSelect: aDate)
				ifTrue: [html anchorWithAction: [self select: aDate] text: aDate dayOfMonth]
				ifFalse: [html text: aDate dayOfMonth]
			]]
	]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 22:56'!
month: aMonth
	^ month contents: aMonth! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/25/2003 13:14'!
renderMonthNavigationOn: html
	html spanClass: 'calendarPrevious' with: [
		html
			anchorWithAction: [self month: self month previous]
			text: (self month previous name first: 3).
	].
	html space.
	html spanClass: 'calendarNext' with: [
		html
			anchorWithAction: [self month: self month next]
			text: (self month next name first: 3).
	]
	! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 22:56'!
initialize
	month _ WAStateHolder new contents: Date today month.
	date _ WAStateHolder new.! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 14:25'!
weekDays
	^ (1 to: 7) collect: [:i | (Date nameOfDay: i) first: 3]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 17:40'!
select: aDate
	self date: aDate.
	selectBlock ifNotNil: [selectBlock value: aDate]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 14:23'!
renderRowForWeek: aWeek on: html
	html tableRow: [
		aWeek do: [:ea | self renderCellForDate: ea on: html].
	]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 22:56'!
month
	^ month contents! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 22:56'!
monthHeading
	^ self month name, ' ', self month year asString! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 17:40'!
date: aDate
	date contents: aDate! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/24/2003 14:38'!
canSelect: aDate
	^ canSelectBlock notNil and: [canSelectBlock value: aDate]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 15:16'!
canSelectBlock: aBlock
	canSelectBlock _ aBlock! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/24/2003 11:35'!
renderContentOn: html
	html divClass: 'calendar' with: [
	html spanClass: 'calendarCaption' with:  self monthHeading.
	html table: [
		html cssClass: 'calendarTitle'; tableRow: [
			self weekDays do: [:ea | html tableData: ea].
		].
		self month eachWeekDo: [:week | self renderRowForWeek: week on: html].
	].
	self renderMonthNavigationOn: html.
	]! !

!WAMiniCalendar methodsFor: 'as yet unclassified' stamp: 'avi 10/23/2003 17:39'!
selectBlock: aBlock
	selectBlock _ aBlock! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString
	^ self request: requestString label: labelString default: ''! !

WAComponent subclass: #WAChangePassword
	instanceVariableNames: 'username password confirmation authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 22:37'!
authenticator: anAuthenticator
	authenticator _ anAuthenticator! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 23:10'!
cancel
	self answer: false! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 23:09'!
changePassword
	password = confirmation
		ifFalse: [^ self inform: 'Sorry, the password and confirmation did not match.'].
	authenticator setPassword: password forUser: username.
	self answer: true
	! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 23:10'!
renderContentOn: html

	html form: [
		html table: [
			html
				tableRowWithLabel: 'Username'
				column: username.
			html
				tableRowWithLabel: 'Password'
				column: [html passwordInputWithCallback: [:v | password _ v]].
			html
				tableRowWithLabel: 'Confirm Password'
				column: [html passwordInputWithCallback: [:v | confirmation _ v]].
			html spacerRow.
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #changePassword of: self.
				html space.
				html submitButtonOn: #cancel of: self
			] span: 2.
		]
	]! !

!WAChangePassword methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 22:37'!
username: aString
	username _ aString! !

WAComponent subclass: #WATask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WATask subclass: #WATransactionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATransactionTest methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 15:16'!
go
	self inform: 'Before parent txn'.
	self isolate: 
			[self inform: 'Inside parent txn'.
			self isolate: [self inform: 'Inside child txn'].
			self inform: 'Outside child txn'].
	self inform: 'Outside parent txn'! !

!WATask methodsFor: 'as yet unclassified' stamp: 'jf 11/10/2003 16:13'!
go
	self subclassResponsibility! !

WATask subclass: #WATool
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

WATool subclass: #WAProfilerTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
linkText
	^ 'Profile'! !

!WAProfilerTool methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:13'!
go
	self call: (WAProfiler new contents: root)! !

!WAProfilerTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 14:10'!
title
	^ 'Profiler'! !

!WATool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:42'!
root: aComponent
	root _ aComponent! !

WATool subclass: #WAMemoryUseTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
title
	^ 'Memory Use'! !

!WAMemoryUseTool methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:44'!
go
	self call: (WAMemoryUse new root: self session)! !

!WAMemoryUseTool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:54'!
linkText
	^ 'Memory Use'! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
linkText
	^ self name! !

!WATool class methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:43'!
title
	^ self name! !

WATask subclass: #WAStoreTask
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreTask commentStamp: 'avi 1/1/2004 10:19' prior: 0!
This task models the main application flow of the store example.  Most of the other components in the example are called from here.  The flow is defined by the #go method.  After creating a WAStoreCart instance, this calls WAStoreFillCart to allow the user to add items to it.  It then calls WAStoreCartConfirmation, WAStoreAddressEditor, and WAStorePaymentEditor in succession for the checkout process.  Many of the components it calls are wrapped with informative messages (#withMessage:) and validation (#validateWith:).  It also makes use of WASession>>isolate: to ensure that once the checkout process starts, backtracking to modify the cart is forbidden.  Used by WAStore.!

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:28'!
displayConfirmation
	self inform: 'Your fish is on its way.'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:51'!
fillCart
	self call: (WAStoreFillCart new cart: cart)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:37'!
confirmContentsOfCart
	^ self call:
		((WAStoreCartConfirmation new cart: cart)
			addMessage: 'Please verify your order:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 21:58'!
go
	| shipping billing creditCard |
	cart _ WAStoreCart new.
	self isolate:
		[[self fillCart.
		self confirmContentsOfCart]
			whileFalse].

	self isolate:
		[shipping _ self getShippingAddress.
		billing _ (self useAsBillingAddress: shipping)
					ifFalse: [self getBillingAddress]
					ifTrue: [shipping].
		creditCard _ self getPaymentInfo.
		self shipTo: shipping billTo: billing payWith: creditCard].

	self displayConfirmation.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 14:04'!
shipTo: shippingAddress billTo: billingAddress payWith: aCreditCard
	"no-op"! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:37'!
getAddressWithMessage: aString
	^ self call:
		((WAStoreAddressEditor new
			validateWith: [:a | a validate])
				addMessage: aString)! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:37'!
getPaymentInfo
	^ self call:
		((WAStorePaymentEditor new
			validateWith: [:p | p validate])
				addMessage: 'Please enter your payment information:')! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:44'!
useAsBillingAddress: anAddress
	^ self confirm: 'Do you wish to use ', anAddress street printString, ' as your billing address?'! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:43'!
getBillingAddress
	^ self getAddressWithMessage: 'Please enter your billing address:'.! !

!WAStoreTask methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:43'!
getShippingAddress
	^ self getAddressWithMessage: 'Please enter your shipping address:'.! !

!WATask methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:50'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isLocal and: [newDecoration isDelegation]]! !

WATask subclass: #WAExceptionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExceptionTest methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 11:14'!
go
	[(self confirm: 'Raise an exception?')
		ifTrue: [self error: 'foo']]
			on: Error
			do: [:e | self inform: 'Caught: ', e asString]! !

!WATask methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 12:36'!
renderWithContext: aContext
	[self answer: self go] repeat! !

WATask subclass: #WAOnceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAOnceTest methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 22:01'!
go
	1 to: 3 do: [:i | self inform: i asString].
! !

!WAOnceTest methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 23:41'!
initialize
	self addDecoration: WAOnce new! !

WATask subclass: #WACookieTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACookieTest methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:14'!
go
	[self session checkForCookies]
		whileFalse: [self inform: 'You must have cookies enabled to proceed.'].
	self session redirectWithCookie:
		(WACookie new
			key: 'cookietest';
			value: 1000 atRandom asString;
			expireIn: (Duration seconds: 60);
			yourself).
	self inform: self session currentRequest cookies asString.! !

!WATask methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:22'!
renderContentOn: html
	self session redirectTo: (html urlForAction: [self go])! !

WAComponent subclass: #WAInputTest
	instanceVariableNames: 'nilString integer emptyString fraction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:39'!
renderContentOn: html
	html form: [
		html table: [
			html	
				tableHeadings: #(Name Value PrintString);
				tableRowWithLabel: 'Nil String'
					column: [html textInputOn: #nilString of: self]
					column: [html text: nilString printString];
				tableRowWithLabel: 'Empty String'
					column: [html textInputOn: #emptyString of: self]
					column: [html text: emptyString printString];
				tableRowWithLabel: 'Integer'
					column: [html textInputOn: #integer of: self]
					column: [html text: integer printString];
				tableRowWithLabel: 'Fraction'
					column: [html textInputOn: #fraction of: self]
					column: [html text: fraction printString].
		].
		html submitButton.
	]
! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer
	^integer! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
integer: anObject
	integer := anObject! !

!WAInputTest methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 23:04'!
initialize
	nilString _ nil.
	emptyString _ ''.
	integer _ 42.
	fraction _ 1/3.! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString: anObject
	emptyString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString: anObject
	nilString := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
nilString
	^nilString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
emptyString
	^emptyString! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction: anObject
	fraction := anObject! !

!WAInputTest methodsFor: 'accessing' stamp: 'ab 10/28/2002 23:01'!
fraction
	^fraction! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 5/19/2004 14:18'!
activeComponent
	self visiblePresentersDo: [:ea | ea isDecoration ifFalse: [^ ea]]! !

WAComponent subclass: #WABrowser
	instanceVariableNames: 'contents model message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
selectionInterval
	^ 1 to: 1! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 01:45'!
initialize
	self model: Browser new.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 12/12/2002 00:39'!
renderContentPaneOn: html
	html form: [
		html
			textAreaOn: #contents of: self;
			break;
			submitButtonOn: #accept of: self.
	]! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:50'!
contents
	^contents! !

!WABrowser methodsFor: 'rendering' stamp: 'JF 5/26/2003 13:30'!
style

	^ '

	#contents {width: 80%; height: 200px; font-family: serif; font-size: 12pt}

	'! !

!WABrowser methodsFor: 'actions' stamp: 'avi 4/28/2004 11:40'!
accept
	|save|
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message _ nil.
	save _ contents.
	model contents: contents notifying: self.
	contents _ save.
! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:36'!
notify: aString at: location in: sourceStream
	message _ aString allButLast: 3! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/10/2002 23:44'!
text
	^ Text fromString: ''! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:42'!
showHelp
	self model plusButtonHit! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:09'!
renderModeButtonsOn: html
	html form: [
		html
			submitButtonWithAction: [ self showInstance ] text: 'instance';
			submitButtonWithAction: [ self showHelp ] text: 'help';
			submitButtonWithAction: [ self showClass ] text: 'class' ]! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
select! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:38'!
showClass
	self model indicateClassMessages! !

!WABrowser methodsFor: 'accessing' stamp: 'LR 9/13/2002 20:39'!
showInstance
	self model indicateInstanceMessages! !

!WABrowser class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:35'!
fullOnClass: aClass
	^ self new model: (Browser new setClass: aClass selector: nil)! !

!WABrowser methodsFor: 'notifying' stamp: 'ab 10/11/2002 00:00'!
selectFrom: aPos to: anotherPos
! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/8/2002 22:13'!
model
	^model 
! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 2/16/2003 00:26'!
renderMessageOn: html
	message ifNotNil: [html bold: message]! !

!WABrowser methodsFor: 'actions' stamp: 'ab 10/10/2002 01:45'!
update: aSymbol
	contents _ model contents! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 2/18/2003 19:07'!
model: aBrowserModel
	model _ aBrowserModel.
	model addDependent: self.
	self session registerObjectForBacktracking: model.
	contents _ model contents.! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	self
		renderColumnsOn: html;
		renderModeButtonsOn: html;
		renderMessageOn: html;
		renderContentPaneOn: html
	! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 10/8/2002 19:41'!
columnView: columnName
	^WAPluggableSelectBox
		on: model
		list: (columnName, 'List') asSymbol
		selected: (columnName, 'ListIndex') asSymbol
		changeSelected: (columnName, 'ListIndex:') asSymbol! !

!WABrowser methodsFor: 'accessing' stamp: 'ab 10/10/2002 23:54'!
contents: aString
	contents _ aString! !

!WABrowser methodsFor: 'rendering' stamp: 'ab 11/26/2002 14:08'!
renderColumnsOn: html
	|cols|
	cols _ #(systemCategory class messageCategory message)
				collect: [:sel | self columnView: sel].

	html table: [
		html tableRow: [
			cols do: [:ea | html tableData: [html render: ea]].
		]
	]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString
	^ self request: aString default: ''! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 16:08'!
call: aComponent
	^ Continuation currentDo: [:cc | self show: aComponent onAnswer: cc]! !

WAComponent subclass: #WALoginDialog
	instanceVariableNames: 'username password authenticator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 16:56'!
cancel
	self answer: nil! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 16:55'!
authenticator: anAuthenticator
	authenticator _ anAuthenticator! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 16:56'!
login
	(authenticator verifyPassword: password forUser: username) ifTrue: [self answer: username]! !

!WALoginDialog methodsFor: 'as yet unclassified' stamp: 'avi 10/25/2003 14:24'!
renderContentOn: html
	html form: [
		html table: [
			html tableRowWithLabel: 'Username:' column: [html textInputWithValue: username callback: [:v | username _ v]].
			html tableRowWithLabel: 'Password:' column: [html passwordInputWithCallback: [:v | password _ v]].
			html attributes alignCenter.
			html tableRowWith: [
				html submitButtonOn: #login of: self.
				html space.
				html submitButtonOn: #cancel of: self] span: 2.
		]
	]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:50'!
decorationChainDo: aBlock
	aBlock value: self decoration! !

WAComponent subclass: #WAHtmlTest
	instanceVariableNames: 'booleanList message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderCheckboxesOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc |
			html text: assoc key; space.
			html checkboxWithValue: assoc value callback: [:b | assoc value: b].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 20:06'!
renderTextInputOn: html
		html form: [
			html text: message.
			html paragraph.
			html textInputWithValue: message callback: [:v | message _ v].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderContentOn: html
	self allSelectors pairsDo:
		[:selA :selB |
		html divClass: 'row' with: [
			html divClass: 'left' with: [self perform: selA with: html].
			html divClass: 'left' with: [self perform: selB with: html]
		]]
! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderSelectsOn: html
		html text: number.
		html paragraph.
		html form: [
			html selectFromList: (1 to: 10) selected: number callback: [:i | number _ i].
			html submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 20:07'!
renderZ: html
	html space! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderRadioButtonsOn: html
		html text: booleanList.
		html paragraph.
		html form: [
		booleanList do:
			[:assoc | |group|
			group _ html radioGroup.
			html text: assoc key; space.
			html radioButtonInGroup: group selected: assoc value callback: [assoc value: true].
			html radioButtonInGroup: group selected: assoc value not callback: [assoc value: false].
			html break].
		html submitButton]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 11/23/2002 12:19'!
style
^ '
	div.row {clear: both}
	div.left {float: left; width: 45%; margin: 1%}
'! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:58'!
renderSubmitButtonsOn: html
		html text: number.
		html paragraph.
		html form: [
			(1 to: 10) do:
				[:i |
				html submitButtonWithAction: [number _ i] text: i.
				html space]
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 10/8/2002 19:59'!
renderTextAreaOn: html
		html form: [
			html text: message.
			html paragraph.
			html textAreaWithValue: message callback: [:v | message _ v].
			html break; submitButton.
		]! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 00:42'!
allSelectors
	^ (self class selectors asSortedCollection select: [:s | s beginsWith: 'render'])
		remove: #renderContentOn:;
		yourself! !

!WAHtmlTest methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:43'!
initialize
	message _ 'Hello world!!'.
	booleanList _ #(a b c d) collect: [:k | k -> ((Array with: true with: false) atRandom)].
	number _ 10 atRandom.! !

WAComponent subclass: #WATaskTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WATaskTest methodsFor: 'as yet unclassified' stamp: 'avi 5/12/2004 13:42'!
renderContentOn: html
	html anchorWithAction: [self call: WAExceptionTest new] text: 'go'! !

WAComponent subclass: #WAFormDialog
	instanceVariableNames: 'validationError form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:35'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase ! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 16:59'!
removeForm
	form ifNotNil: [self removeDecoration: form]! !

WAFormDialog subclass: #WANoteDialog
	instanceVariableNames: 'note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:50'!
style
	^ ' 
	#dialog-note {width: 80%; height: 200px}
	'! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:48'!
cancel
	self answer: nil! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:45'!
renderDialogOn: html
	html cssId: 'dialog-note'.
	html textAreaWithValue: note callback: [:v | note _ v].! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:48'!
buttons
	^ #(ok cancel)! !

!WANoteDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:46'!
ok
	self answer: note! !

WAFormDialog subclass: #WALabelledFormDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:06'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector _ self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: html]
		ifFalse: [self renderDefaultFieldForSelector: aSymbol on: html]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:06'!
renderRowForSelector: aSymbol on: html
	html cssClass: 'dialog-row'.
	html divNamed: aSymbol with: 
		[html spanClass: 'dialog-form-label' with: [self renderLabelForSelector: aSymbol on: html].
		html spanClass: 'dialog-form-field' with: [self renderFieldForSelector: aSymbol on: html]].
! !

WALabelledFormDialog subclass: #WAStoreAddressEditor
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreAddressEditor commentStamp: 'avi 1/1/2004 09:56' prior: 0!
A component for editing WAStoreAddress instances.  When called, it will create a new address instance, present a form for the user to modify it, and then answer the instance on submit.  Used by WAStoreTask>>getBillingAddress and getShippingAddress.!

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:11'!
rows
	^ #(name street city country)
! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:38'!
model
	^ address! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:39'!
initialize
	address _ WAStoreAddress new.
	super initialize.! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:04'!
ok
	self answer: address! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 13:55'!
countries
	^ #(Canada USA)! !

!WAStoreAddressEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:40'!
renderCountryOn: html
	html
		selectFromList: self countries
		selected: address country
		callback: [:v | address country: v]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 16:29'!
style
	^ '
.dialog-row {
	clear: both;
	/*set position: relative to handle the ie disappearing text bug*/
	position: relative;
	margin-top: 3px;
}

.dialog-form-label {
	width: 100px;
	float: left;
	text-align: right;
	padding: 2px 6px;
	margin-right: 4px;
	margin-top: 2px;
}

.dialog-form-field {
	text-align: left;
	padding: 2px;
	margin-top: 2px;
	float: left;
}

.dialog-buttons {
	clear: both;
	padding: 10px;
	text-align: center
}

.dialog-spacer {
	clear: both;
	height: 10px;
}
	'! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:07'!
renderDefaultFieldForSelector: aSymbol on: html
	html textInputOn: aSymbol of: self model! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:41'!
renderLabelForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

WALabelledFormDialog subclass: #WAEditDialog
	instanceVariableNames: 'model snapshot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:49'!
snapshot
	snapshot _ model clone! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 14:10'!
buttons
	^ #(save cancel)! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:46'!
cancel
	self rollback.
	self answer: false! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 14:10'!
validate
	! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:49'!
model
	^ model! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:49'!
rollback
	model copyFrom: snapshot! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:46'!
save
	self validate.
	self isValid ifTrue: [self answer: true]! !

!WAEditDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:46'!
model: anObject
	model _ anObject.
	self snapshot.! !

!WAEditDialog class methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 14:21'!
model: anObject
	^ self new model: anObject! !

WALabelledFormDialog subclass: #WAStorePaymentEditor
	instanceVariableNames: 'name cardType cardNumber month year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStorePaymentEditor commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for editing WAStoreCreditCard instances.  When called, it presents a form for the user to choose credit card type, and enter name, number, and expiry date.  On submit, it will create and answer an instance of the appropiate credit card subclass.  Note the difference with WAStoreAddressEditor, where the form modifies the address instance directly.  Used by WAStoreTask>>getPaymentInfo.!

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:59'!
months
	^ (1 to: 12)! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:27'!
ok
	self answer:
		(cardType new
			name: name;
			number: cardNumber;
			expiry: (Date newDay: 1 monthNumber: month year: year))! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 14:06'!
cardTypes
	^ WAStoreCreditCard subclasses! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:14'!
renderNameOn: html
	html textInputWithValue: name callback: [:v | name _ v]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:14'!
renderCardTypeOn: html
	html
		selectFromList: self cardTypes
		selected: cardType
		callback: [:v | cardType _ v]
		labels: [:ea | ea abbreviation]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:15'!
renderExpirationDateOn: html 
	html selectFromList: self months selected: month callback: [:m | month _ m].
	html selectFromList: self years selected: year callback: [:y | year _ y]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:14'!
rows
	^ #(cardType name cardNumber expirationDate)! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 5/1/2004 14:15'!
renderCardNumberOn: html
	html textInputWithValue: cardNumber callback: [:v | cardNumber _ v]! !

!WAStorePaymentEditor methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:45'!
years
	^ (Date today year to: Date today year + 5)! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:39'!
renderTableRowsOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html
	self rows do:
		[:ea |
		ea = #-
			ifTrue: [self renderSpacerRowOn: html]
			ifFalse: [self renderRowForSelector: ea on: html]].
! !

WALabelledFormDialog subclass: #WAViewer
	instanceVariableNames: 'presenter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:22'!
script
	^ 'self.opener.location=self.opener.location'! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:17'!
renderContentOn: html
	html heading: presenter asString level: 3.
	super renderContentOn: html! !

!WAViewer class methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:13'!
on: aPresenter
	^ self new presenter: aPresenter! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:23'!
save
	! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:13'!
presenter: aPresenter
	presenter _ aPresenter! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:14'!
buttons
	^ #(save)! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:14'!
rows
	^ #(css)! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:14'!
model
	^ presenter! !

!WAViewer methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 01:17'!
renderCssOn: html
	html attributes rows: 20; cols: 80.
	html textAreaWithValue: presenter style callback:
		[:css |
		presenter class compile: 'style ^ ', css printString]! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:37'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!WALabelledFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 18:00'!
rows
	^ #()! !

WAFormDialog subclass: #WAYesOrNoDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:40'!
no
	self answer: false! !

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:40'!
yes
	self answer: true! !

!WAYesOrNoDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:40'!
buttons
	^ #(yes no)! !

WAFormDialog subclass: #WAGridDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:02'!
renderDialogOn: html
	html table: [
		self renderHeadingsOn: html.
		self items do:
			[:ea | 
			self renderRowForItem: ea on: html].
	]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:47'!
columns
	^ #()! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/17/2004 15:05'!
cssClassForItem: anObject
	^ 'dialog-row'! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:59'!
renderColumn: aSymbol for: anObject on: html
	| renderSelector |
	renderSelector _ self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [self perform: renderSelector with: anObject with: html]
		ifFalse: [self renderDefaultColumn: aSymbol for: anObject on: html]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:51'!
renderHeadingForSelector: aSymbol on: html
	html text: (self labelForSelector: aSymbol)! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/17/2004 15:04'!
renderRowForItem: anObject on: html
	html cssClass: (self cssClassForItem: anObject).
	html tableRow: [
		self columns do:
			[:ea |
			html cssClass: ea.
			html tableData: [self renderColumn: ea for: anObject on: html]]
	]! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 21:03'!
style
	^ '
	.dialog-buttons {text-align: center}
	'! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:47'!
items
	^ #()! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:59'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'For:on:') asSymbol! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 17:00'!
renderDefaultColumn: aSymbol for: anObject on: html
	html text: (anObject perform: aSymbol)! !

!WAGridDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:51'!
renderHeadingsOn: html
	self columns do: [:ea |
		html cssClass: ea.
		html tableHeading: [self renderHeadingForSelector: ea on: html]]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:35'!
renderContentOn: html
	html hiddenInputWithCallback: [validationError _ nil].
	validationError ifNotNil:
		[self renderValidationError: validationError on: html].
	html divClass: self divClass with: [self renderDialogOn: html].! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:37'!
buttons
	^ #(ok)! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:37'!
renderDialogOn: html! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:35'!
model
	^ self! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:45'!
addForm
	form _ WAFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:28'!
renderValidationError: aString on: html
	html spanClass: 'dialog-validation' with: aString! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 14:06'!
initialize
	self addFormByDefault ifTrue: [self addForm]! !

WAFormDialog subclass: #WAChoiceDialog
	instanceVariableNames: 'options selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
buttons
	^ #(ok cancel)! !

!WAChoiceDialog class methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	^ self new options: aCollection! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
renderContentOn: html
	html selectFromList: options selected: nil  callback: [:v | selection _ v]! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 00:59'!
options
	^ options! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 00:59'!
options: aCollection
	options _ aCollection! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
cancel
	self answer: nil! !

!WAChoiceDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/21/2004 01:00'!
ok
	self answer: selection! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 14:05'!
addFormByDefault
	^ true! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:35'!
validationError: aString
	validationError _ aString! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:41'!
divClass
	^ self class name! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 21:20'!
renderSpacerRowOn: html
	html divClass: 'dialog-spacer' with: [html space]! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:37'!
ok
	self answer! !

!WAFormDialog methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 16:35'!
isValid
	^ validationError isNil! !

WAComponent subclass: #WAMultiCounter
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
renderContentOn: html
	counters 
		do: [:ea | html render: ea]
		separatedBy: [html horizontalRule]! !

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:08'!
initialize
	self registerAsApplication: 'multi'! !

!WAMultiCounter class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^true! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 21:50'!
children
	^ counters! !

!WAMultiCounter methodsFor: 'as yet unclassified' stamp: 'avi 9/4/2003 17:07'!
initialize
	counters _ (1 to: 5) collect: [:i | WACounter new]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:21'!
addDecoration: newDecoration
	| prev decoration |
	prev _ nil.
	decoration _ self decoration.
	[decoration ~~ self and: [self decoration: decoration shouldWrap: newDecoration]] whileTrue:
		[prev _ decoration.
		decoration _ decoration owner].
	newDecoration owner: decoration.
	prev
		ifNil: [self decoration: newDecoration]
		ifNotNil: [prev owner: newDecoration]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:55'!
answer: anObject
	WAAnswerNotification answer: anObject! !

WAComponent subclass: #WAWebTreeComponent
	instanceVariableNames: 'backgroundColor rootNodes eventHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Contrib'!

!WAWebTreeComponent commentStamp: 'TBn 4/28/2004 20:11' prior: 0!
This class represents a component for providing html table based
web tree views. You can set the background color and add root
nodes (typically instances of WAWebTreeNode) using #addRootNode:
to it.

It is also possible to set an event handler to receive #onCollapseNode: 
and #onExpandNode: messages when the user clicks in the tree.

!

!WAWebTreeComponent methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:17'!
eventHandler
	^eventHandler! !

!WAWebTreeComponent methodsFor: 'node rendering' stamp: 'TBn 4/28/2004 19:55'!
renderInnerNode: aNode on: html 
	html
		tableRow: [self renderImageForInnerNode: aNode on: html.
			html tableData: aNode wrappedObject].
	aNode isExpanded
		ifTrue: [html
				tableRow: [html
						attributeAt: 'background'
						put: (html urlForDocument: self webTreeImageProvider verticalImage);
						 tableData: '';
						
						tableData: [self renderNodes: aNode subnodes on: html]]]! !

!WAWebTreeComponent methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:13'!
backgroundColor 

	backgroundColor isNil ifTrue: [backgroundColor := self defaultBackgroundColor].
	^backgroundColor! !

!WAWebTreeComponent methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:13'!
backgroundColor: aColor
	backgroundColor := aColor! !

!WAWebTreeComponent methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:17'!
eventHandler: anObject
	eventHandler := anObject
	! !

!WAWebTreeComponent methodsFor: 'attributes' stamp: 'TBn 4/28/2004 19:54'!
webTreeImageProvider
	"Returns an object providing the images for the tree. Subclasses  
	may override this method to provide custom images."
	^ WAWebTreeImageProvider! !

!WAWebTreeComponent methodsFor: 'rendering' stamp: 'TBn 4/28/2004 17:25'!
renderNodes: nodes on: html
	"Renders the given collection of nodes on the renderer.
	 Leading nodes have a different appearance than the last node"

	nodes isEmpty ifTrue: [^self].
 	html
		attributeAt: 'cellspacing' put: 0;
		attributeAt: 'cellpadding' put: 0;
		attributeAt: 'border' put: 0;
		table: [	
			nodes size > 1 ifTrue: [
				(1 to: nodes size - 1) do: [:index | self renderInnerNode: (nodes at: index) on: html]].
			self renderLastNode: nodes last on: html].
	! !

!WAWebTreeComponent methodsFor: 'attributes' stamp: 'TBn 4/28/2004 19:24'!
style
	"returns the receivers styles"

	^'
	body { margin:0; scroll=auto; background-color=',self backgroundColor asHTMLColor ,'}
    td    {font-size: 10pt; font-family: arial}	
	'
! !

!WAWebTreeComponent methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:13'!
rootNodes: aCollection

	rootNodes := aCollection! !

!WAWebTreeComponent methodsFor: 'node rendering' stamp: 'TBn 4/28/2004 19:55'!
renderImageForLastNode: aNode on: html 
	aNode hasSubnodes
		ifFalse: [^ html imageCellFor: self webTreeImageProvider branchImageBottom].
	aNode isExpanded
		ifTrue: [html
				imageCellFor: self webTreeImageProvider minusImageBottom
				actionBlock: [self onCollapseNode: aNode]]
		ifFalse: [html
				imageCellFor: self webTreeImageProvider plusImageBottom
				actionBlock: [self onExpandNode: aNode]]! !

!WAWebTreeComponent methodsFor: 'events' stamp: 'TBn 4/28/2004 17:21'!
onCollapseNode: aNode 
	aNode collapse.
	eventHandler notNil
		ifTrue: [eventHandler onCollapseNode: aNode]! !

!WAWebTreeComponent methodsFor: 'defaults' stamp: 'TBn 4/28/2004 17:15'!
defaultBackgroundColor

	^Color white! !

!WAWebTreeComponent methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:13'!
rootNodes

	rootNodes isNil ifTrue: [rootNodes := OrderedCollection new].
	^rootNodes! !

!WAWebTreeComponent methodsFor: 'rendering' stamp: 'TBn 4/28/2004 17:25'!
renderContentOn: html	
	| nodes |
	nodes := self rootNodes.
	self renderNodes: nodes on: html

 ! !

!WAWebTreeComponent methodsFor: 'operations' stamp: 'TBn 4/28/2004 17:22'!
addRootNode: aTreeNode

	self rootNodes add: aTreeNode! !

!WAWebTreeComponent methodsFor: 'node rendering' stamp: 'TBn 4/28/2004 17:24'!
renderLastNode: aNode on: html

	html tableRow: [
		self renderImageForLastNode: aNode on: html.
		html
			tableData: aNode wrappedObject 
	].
	aNode isExpanded ifTrue: [	 
		html tableRow: [
				 		 
		html 
			tableData: '';
			tableData: [self renderNodes: aNode subnodes on: html]
		].
	 ]! !

!WAWebTreeComponent methodsFor: 'attributes' stamp: 'TBn 4/28/2004 17:14'!
rendererClass
	"returns the receivers render class"

	^WAWebTreeRenderer! !

!WAWebTreeComponent methodsFor: 'node rendering' stamp: 'TBn 4/28/2004 19:55'!
renderImageForInnerNode: aNode on: html 
	aNode hasSubnodes
		ifFalse: [^ html imageCellFor: self webTreeImageProvider branchImageCenter].
	aNode isExpanded
		ifTrue: [html
				imageCellFor: self webTreeImageProvider minusImageCenter
				actionBlock: [self onCollapseNode: aNode]]
		ifFalse: [html
				imageCellFor: self webTreeImageProvider plusImageCenter
				actionBlock: [self onExpandNode: aNode]]! !

!WAWebTreeComponent methodsFor: 'events' stamp: 'TBn 4/28/2004 17:22'!
onExpandNode: aNode 
	aNode expand.
	eventHandler notNil
		ifTrue: [eventHandler onExpandNode: aNode]
	 ! !

WAComponent subclass: #WAStoreFillCart
	instanceVariableNames: 'cart cartView main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreFillCart commentStamp: 'avi 1/1/2004 10:10' prior: 0!
This component provides the main UI for browsing the store inventory and filling the cart.  The caller must provide a shopping cart instance with #cart:.  The component presents a navigation bar with options to browse and search on the left, and embeds a WACartView showing the cart contents on the right.  In the middle is initially embedded a WAStoreInfo.  Browsing and searching will replace this with a stock WABatchSelection component for listing items (see #displatItems:), or a WAStoreItemView for displaying individual items.  This answers back to the caller when the user chooses "checkout" from the nav bar.!

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:10'!
cart: aCart
	cart _ aCart.
	cartView cart: aCart.! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:10'!
displayItem: anItem
	main call: (WAStoreItemView new item: anItem; cart: cart)! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:53'!
initialize
	main _ WAStoreInfo new.
	cartView _ WAStoreCartView new! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
inventory
	^ WAStoreInventory default! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:11'!
checkout
	self answer.! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:25'!
displayItems: aCollection
	| list |
	aCollection size = 1 ifTrue: [^ self displayItem: aCollection first].
	list _ WABatchSelection
			 items: aCollection
			 link: #title
			 text: #subtitle.
	[self displayItem: (main call: list)] repeat
	! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: cartView with: main! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:14'!
renderNavBarOn: html
	html form: [
		html bold: 'Search:'.
		html space.
		html textInputWithValue: '' callback: [:v | self search: v].
	].
	html anchorWithAction: [self browse] text: 'Browse'.
	cart hasItems ifTrue: 
		[html break.
		html anchorWithAction: [self checkout] text: 'Checkout']! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
browse
	self displayItems: self inventory allItems! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:13'!
search: aString
	| results |
	results _ self inventory findItem: aString.
	results isEmpty
		ifTrue: [main inform: 'No items match ', aString printString]
		ifFalse: [self displayItems: results].! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 15:33'!
style
^ '
	#search {vertical-align: bottom}
	#main {width: 50%; padding: 10px}
	#side {vertical-align: top; }
	#cart {border-style: dashed; border-width: 1; padding: 5px}
	#nav {background-color: lightgrey; vertical-align: top; padding: 5px; border-width: 1; width: 15%; font-size: 12pt}
	#batch {font-size: 10pt}
'! !

!WAStoreFillCart methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:00'!
renderContentOn: html
	html table: [
"		html tableRowWith: trail span: 3."
		html tableRow: [
			html cssId: 'nav'; tableData: [self renderNavBarOn: html].
			html cssId: 'main'; tableData: main.
			html cssId: 'side'; tableData: cartView.
		]
	]! !

WAComponent subclass: #WADateTable
	instanceVariableNames: 'rows startDate endDate datesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
endDate: aDate
	endDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 15:12'!
renderContentOn: html
	html attributes border: 1.
	html cssClass: 'DateTable'; table: [
		html tableRow: [self renderMonthHeadingsOn: html].
		html tableRow: [self renderDayHeadingsOn: html].
		rows withIndexDo:
			[:ea :i|
			html tableRow: [self renderRow: ea index: i on: html]].
	]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:22'!
renderHeadingSpacerOn: html
	html tableData: []! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:51'!
renderRow: anObject index: aNumber on: html
	self renderHeadingForRow: anObject on: html.
	self
		datesDo: [:date | self renderCellForDate: date row: anObject index: aNumber on: html]	
		separatedBy: [	self renderHeadingSpacerOn: html ]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:14'!
renderMonthHeadingsOn: html
	self monthsAndLengthsDo:
		[:month :length |
		self renderHeadingSpacerOn: html.
		html
			cssClass: 'MonthHeading';
			attributeAt: 'colspan' put: length;
			tableHeading: [html text: month name; space; text: month year]]! !

WADateTable subclass: #WASelectionDateTable
	instanceVariableNames: 'cellBlock dateSelectionStart dateSelectionEnd rowSelectionStart rowSelectionEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:05'!
selectDate: aDate rowIndex: rowIndex
	self hasSelection
		ifFalse: [dateSelectionStart _ dateSelectionEnd _ aDate. rowSelectionStart _ rowSelectionEnd _ rowIndex]
		ifTrue: [dateSelectionEnd _ aDate. rowSelectionEnd _ rowIndex]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
startRow
	^ rowSelectionStart min: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:04'!
selectAll
	dateSelectionStart _ startDate.
	dateSelectionEnd _ endDate.
	rowSelectionStart _ 1.
	rowSelectionEnd _ rows size.! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:23'!
clearSelection
	dateSelectionStart _ dateSelectionEnd _ rowSelectionStart _ rowSelectionEnd _ nil! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
startDate: aDate
	self clearSelection.
	super startDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
endRow
	^ rowSelectionStart max: rowSelectionEnd! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:40'!
selectedRows
	^ rows copyFrom: self startRow to: self endRow! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
startRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart min: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
rows: aCollection
	self clearSelection.
	super rows: aCollection! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
endDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart max: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:18'!
selectionContainsDate: aDate rowIndex: aNumber
	^ ((aDate between: dateSelectionStart and: dateSelectionEnd) or: [aDate between: dateSelectionEnd and: dateSelectionStart])
		and: [(aNumber between: rowSelectionStart and: rowSelectionEnd) or: [aNumber between: rowSelectionEnd and: rowSelectionStart]]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:22'!
startDateSelection
	^ dateSelectionStart ifNotNil: [dateSelectionStart min: dateSelectionEnd]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:43'!
style
	^ 'td a {text-decoration: none}'! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:27'!
endRowSelection
	^ rowSelectionStart ifNotNil: [rows at: (rowSelectionStart max: rowSelectionEnd)]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:48'!
rowsAndDatesDisplay: aBlock
	cellBlock _ aBlock! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:19'!
colorForDate: aDate rowIndex: aNumber
	^ (self hasSelection
		and: [self selectionContainsDate: aDate rowIndex: aNumber])
			ifTrue: ['lightgrey']
			ifFalse: ['white']! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 22:41'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	|text|
	html attributeAt: 'bgcolor' put: (self colorForDate: aDate rowIndex: aNumber).
	html attributeAt: 'align' put: 'center'.
	html tableData: [
		text _ cellBlock value: anObject value: aDate.
		html anchorWithAction: [self selectDate: aDate rowIndex: aNumber] text: text.
	]! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 19:56'!
endDate: aDate
	self clearSelection.
	super endDate: aDate! !

!WASelectionDateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 17:02'!
hasSelection
	^ dateSelectionStart notNil! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 14:52'!
datesDo: aBlock separatedBy: monthlyBlock
	| month|
	month _ datesCache first monthIndex.
	datesCache do:
		[:date |
		date monthIndex = month ifFalse: [month _ date monthIndex. monthlyBlock value].
		aBlock value: date].
	monthlyBlock value.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:56'!
startDate: aDate
	startDate _ aDate.
	self updateDatesCache.! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:20'!
renderDayHeadingsOn: html
	self renderHeadingSpacerOn: html.
	self
		datesDo: [:date | html cssClass: 'DayHeading'; tableHeading: [html text: date dayOfMonth]]
		separatedBy: [self renderHeadingSpacerOn: html]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:11'!
rows: aCollection
	rows _ aCollection! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 14:50'!
renderHeadingForRow: anObject on: html
	html cssClass: 'RowHeading'; tableHeading: [html text: anObject]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:19'!
monthsAndLengthsDo: aBlock
	|count last|
	count _ 0.
	self
		datesDo: [:ea | count _ count + 1. last _ ea]
		separatedBy: [aBlock value: last month value: count.
						count _ 0]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 20:58'!
updateDatesCache
	| date |
	(startDate isNil or: [endDate isNil]) ifTrue: [^ self].
	
	datesCache _ OrderedCollection new.
	date _ startDate.
	[date > endDate] whileFalse:
		[datesCache add: date.
		date _ date next]! !

!WADateTable methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 16:59'!
renderCellForDate: aDate row: anObject index: aNumber on: html
	html tableData: [html space]! !

WAComponent subclass: #WAEmailConfirmation
	instanceVariableNames: 'from to subject body notice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
subject: aString
	subject _ aString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
from: fromString
	from _ fromString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
to: toString
	to _ toString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
body: aString
	body _ aString! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/11/2004 13:09'!
sendMessageWithUrl: urlString
	SeasidePlatformSupport
		deliverMailFrom: from
		to: (Array with: to)
		text: (urlString, '
		
', body)! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:41'!
renderContentOn: html
	| url |
	url _ html urlForAction: [self answer].
	self sendMessageWithUrl: url.
	html divClass: 'notice' with: notice! !

!WAEmailConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 3/10/2004 15:40'!
notice: aString
	notice _ aString! !

WAComponent subclass: #WAErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAErrorTest methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:24'!
renderContentOn: html
	html anchorWithAction: [1/0] text: 'Raise error'.
	html break.
	html anchorWithAction: [self notify: 'Really?'. self inform: 'Ok!!'] text: 'Raise warning'.! !

WAComponent subclass: #WAVersionUploader
	instanceVariableNames: 'file url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 18:58'!
loadURL
	| stream version |
	stream _ url asUrl retrieveContents content asByteArray readStream .
	version _ (MCVersionReader readerClassForFileNamed: url) versionFromStream: stream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'ab 8/30/2003 20:55'!
saveImage
	Smalltalk snapshot: true andQuit: false! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 18:58'!
loadFile
	| reader version |
	reader _ MCVersionReader readerClassForFileNamed: file fileName.
	reader ifNil: [self inform: file fileName, ' is not in a known format'].
	version _ reader versionFromStream: file contents asByteArray readStream.
	version load.! !

!WAVersionUploader methodsFor: 'as yet unclassified' stamp: 'avi 8/30/2003 21:24'!
renderContentOn: html
	html bold: 'Loaded versions:'.
	html list: MCWorkingCopy allManagers do: [:ea | html text: ea description].
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html bold: 'Load version from file: '; break.
		html fileUploadWithCallback: [:f | file _ f].
		html space.
		html submitButtonWithAction: [self loadFile] text: 'Load'.
	].
	html form: [
		html bold: 'Load version from URL: '; break.
		html attributes size: 60.
		html textInputWithValue: 'http://' callback: [:u | url _ u].
		html space.
		html submitButtonWithAction: [self loadURL] text: 'Load'.
	].
	html anchorWithAction: [self saveImage] text: 'Save Image'. ! !

!WAVersionUploader class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

WAComponent subclass: #WANavigation
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 5/21/2004 18:31'!
style
	"this is from http://kalsey.com/tools/csstabs/ - would also be nice to do http://www.alistapart.com/articles/slidingdoors/"
	^ '
.kalsey .navigation-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}

.kalsey .navigation-options ul, .kalsey .navigation-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}

	
.kalsey .navigation-options a:link, .kalsey .navigation-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

.kalsey .navigation-options a:link.active, .kalsey .navigation-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-options ul a:hover	{
	color : #f00;
}

.kalsey .navigation-options #option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

.kalsey .navigation-content {
	background : #fff;
	border : 1px solid #ccc;
	border-top : none;
	clear : both;
	margin : 0px;
	padding : 15px;
}
'! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 16:13'!
renderSelectionOn: html! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 5/21/2004 18:17'!
renderOptionsOn: html
	html
		unorderedList: self options
		selected: self selection
		callback: [:v | self select: v]
		labels: [:ea | self labelForOption: ea]
! !

WANavigation subclass: #WASimpleNavigation
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WASimpleNavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 19:25'!
selectedComponent
	^ (components detect: [:ea | ea key = self selection] ifNone: [^ nil]) value! !

!WASimpleNavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 19:25'!
selectedController
	^ (controllers detect: [:ea | ea key = self selection] ifNone: [^ nil]) value! !

!WASimpleNavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 19:24'!
children
	^ Array with: self selectedComponent! !

!WASimpleNavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 19:25'!
renderSelectionOn: html
	html render: self selectedComponent! !

!WASimpleNavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 19:24'!
add: aComponent label: aString
	components add: aString -> aComponent! !

!WASimpleNavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 19:25'!
initialize
	super initialize.
	components _ OrderedCollection new! !

!WASimpleNavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 19:34'!
options
	^ components collect: [:ea | ea key]! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 16:28'!
labelForOption: anObject
	^ anObject asString! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 16:28'!
initialize
	selection _ WAStateHolder new! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 16:28'!
selection
	^ selection contents! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 20:01'!
renderOption: anObject on: html
	anObject = self selection
		ifTrue: [html anchorWithUrl: '#' do: (self labelForOption: anObject)]
		ifFalse: [html anchorWithAction: [self select: anObject] text: (self labelForOption: anObject)]! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 16:28'!
select: anObject
	selection contents: anObject.
	self selectionChanged! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 16:28'!
selectionChanged
	! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 3/15/2004 16:27'!
options
	^ #()! !

!WANavigation methodsFor: 'as yet unclassified' stamp: 'avi 5/21/2004 18:15'!
renderContentOn: html
	html divClass: 'kalsey' with: [
		html divClass: 'navigation-options' with: [self renderOptionsOn: html].
		html divClass: 'navigation-content' with: [self renderSelectionOn: html].
	]! !

WAComponent subclass: #WAStoreInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreInfo commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component that displays simple informative text about this example.  Used by WAStoreFillCart.!

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 22:00'!
renderContentOn: html
	html html: self text! !

!WAStoreInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:29'!
text
	^
'Welcome to the sushiNet online store.
<p>
This is a sample Seaside application.
<p>
Use the search box at the top left to find some results.
Good searches to try might be "tuna", "saba", or "fish".
'! !

WAComponent subclass: #WAParentTest
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:14'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'swap parent' ! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
parent: aComponent
	parent _ aComponent! !

!WAParentTest methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 22:13'!
go
	parent inform: 'foo'! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:25'!
show: aComponent onAnswer: aBlock
	| delegation |
	delegation _ WADelegation new delegate: aComponent; block: aBlock.
	self addDecoration: delegation.
	WARenderNotification raiseSignal! !

WAComponent subclass: #WAStore
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStore commentStamp: 'avi 1/1/2004 10:06' prior: 0!
This component is the entry point for the store example.  It provides the main stylesheet in its #style method, renders a simple banner at the top, and then embeds an instance of WAStoreTask, which is where the real action happens.!

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
subtitle
	^ 'fresh, raw fish delivered to your door'! !

!WAStore class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:11'!
style
	^ '
	body {margin: 0px; font-family: sans-serif}
	#banner {width: 100%}	
	#banner tr {background-color: lightblue; text-align: right; padding: 10px; vertical-align: bottom}
	#title {font-size: 18pt; font-weight: bold}
	#subtitle {font-size: 9pt; font-style: italic}
	#body {padding: 5px}
	.validation-error {color: red; font-size: 9pt; padding: 5px}
	'
! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 20:42'!
children
	^ Array with: task! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 22:50'!
renderContentOn: html
	html cssId: 'banner'.
	html table: [
		html tableRowWith: [
			html divNamed: 'title' with: self title.
			html divNamed: 'subtitle' with: self subtitle.
		]
	].
	html divNamed: 'body' with: task! !

!WAStore class methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
initialize
	self registerAsApplication: 'store'! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:59'!
initialize
	task _ WAStoreTask new.! !

!WAStore methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:58'!
title
	^ 'sushiNet'! !

WAComponent subclass: #WAStoreItemView
	instanceVariableNames: 'item cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreItemView commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for viewing an individual WAStoreItem.  The caller must provide #item: and also the current #cart:.  Shows the description and price info for the item, and presents two buttons: "Add to Cart", which will add the item to the cart, once, and "Done", which will answer back to the caller.  Used by WAStoreFillCart>>displayItem: and displayItems:.!

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:11'!
cart: aCart
	cart _ aCart! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:11'!
addToCart
	cart add: item! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 14:47'!
item: anItem
	item _ anItem! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 01:01'!
updateUrl: aUrl
	aUrl addToPath: item name! !

!WAStoreItemView methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 01:29'!
renderContentOn: html
	html heading: item title.
	html heading: item subtitle level: 3.
	html paragraph: item description.
	html italic: item price printStringAsCents.
	html form: [
		html submitButtonWithAction: [self addToCart] text: 'Add To Cart'.
		html space.
		html submitButtonWithAction: [self answer] text: 'Done'.
	]! !

WAComponent subclass: #WAInputDialog
	instanceVariableNames: 'label value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'ab 10/28/2002 11:41'!
default: aString
	value _ aString! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:12'!
renderContentOn: html
	html heading: message level: 3.
	html form: [
		html defaultAction: [self answer: value].
		html textInputWithValue: value callback: [:v | value _ v].
		html space.
		html submitButtonWithText: self label.
	]! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:12'!
label
	^ label ifNil: [label _ 'OK']! !

!WAInputDialog methodsFor: 'as yet unclassified' stamp: 'JF 6/4/2003 12:10'!
label: aString
	label _ aString! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:53'!
addMessage: aString
	self addDecoration: (WAMessageDecoration new message: aString)! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 22:05'!
validateWith: aBlock
	self addDecoration: (WAValidationDecoration new validateWith: aBlock)! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:24'!
applicationWithPath: aString
	| app |
	app _ WAApplication path: aString.
	app configuration addAncestor: WARenderLoopConfiguration localConfiguration.
	app preferenceAt: #rootComponent put: self.
	^ app! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:14'!
decoration: aDecoration
	decoration ifNil: [decoration _ WAStateHolder new].
	decoration contents: aDecoration! !

WAComponent subclass: #WABatchedList
	instanceVariableNames: 'items batchSize currentPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderNextOn: html
	html space.
	self isOnLastPage
		ifFalse: [ html anchorWithAction: [ self nextPage ] text: '>>' ]
		ifTrue: [ html text: '>>' ]		! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:31'!
renderPagesOn: html
	self pageRange
		do: [ :index |
			currentPage = index
				ifFalse: [html anchorWithAction: [self currentPage: index] text: index]
				ifTrue: [html bold: index ] ]
		separatedBy: [ html space ]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
items
	^ items! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
batchSize
	^ batchSize! !

!WABatchedList methodsFor: 'initialization' stamp: 'avi 12/9/2003 13:17'!
initialize
	batchSize _ 10.
	currentPage _ 1.
	self session registerObjectForBacktracking: self.! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:09'!
batchSize: aNumber
	batchSize _ aNumber! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:50'!
pageRangeEnd
	^ self maxPages min: self currentPage + 9! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
nextPage
	self isOnLastPage ifFalse: [currentPage _ currentPage + 1]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage
	^ currentPage! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:51'!
pageRangeStart
	^ 1 max: self currentPage - 9! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnFirstPage
	^ currentPage = 1! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'lr 9/3/2003 10:44'!
pageRange
	^ self pageRangeStart to: self pageRangeEnd! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:17'!
endIndex
	^ currentPage * batchSize min: items size! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 22:57'!
items: aCollection
	items _ aCollection! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:05'!
batch
	^ items copyFrom: self startIndex to: self endIndex! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:28'!
renderPreviousOn: html
	self isOnFirstPage
		ifFalse: [ html anchorWithAction: [ self previousPage ] text: '<<' ]
		ifTrue: [ html text: '<<' ].
	html space.! !

!WABatchedList methodsFor: 'testing' stamp: 'ab 5/25/2003 23:06'!
isOnLastPage
	^ currentPage = self maxPages! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/29/2003 16:39'!
maxPages
	^ (items size / batchSize) ceiling! !

!WABatchedList methodsFor: 'actions' stamp: 'ab 5/25/2003 23:06'!
previousPage
	self isOnFirstPage ifFalse: [currentPage _ currentPage - 1]! !

!WABatchedList methodsFor: 'accessing' stamp: 'ab 5/25/2003 23:12'!
currentPage: aNumber
	currentPage _ aNumber! !

!WABatchedList methodsFor: 'rendering' stamp: 'lr 9/3/2003 10:26'!
renderContentOn: html
	self maxPages > 0 ifTrue: [
		html divNamed: 'batch' with: [
			self renderPreviousOn: html.
			self renderPagesOn: html. 
			self renderNextOn: html ] ]! !

!WABatchedList methodsFor: 'accessing-calculated' stamp: 'ab 5/25/2003 23:09'!
startIndex
	^ (currentPage - 1) * batchSize + 1! !

WAComponent subclass: #WAStoreCartConfirmation
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartConfirmation commentStamp: 'avi 1/1/2004 09:58' prior: 0!
A component for confirming the contents of a WAStoreCart.  The caller must provide a cart instance with #cart: .  When called, it will display a summary of the items in the cart, along with two buttons: "Proceed with checkout" and "Modify cart".  Answers true if the user presses the first button, false if the user presses the seecond.  Used by WAStoreTask>>confirmContentsOfCart.!

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:35'!
cart: aCart
	cart _ aCart! !

!WAStoreCartConfirmation methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 13:03'!
renderContentOn: html
	html attributes border: 1.
	html table: [
		cart countsAndItems do:
			[:assoc | |count item|
			count _ assoc key.
			item _ assoc value.
			html tableHeadings: #(Item Price Count Total).
			html attributes align: #right.
			html tableRow: [
				html tableData: item title.
				html tableData: item price printStringAsCents.
				html tableData: count asString.
				html tableData: (item price * count) printStringAsCents.
			]].
		html attributes align: #right.
		html tableRowWith: [html bold: cart totalPrice printStringAsCents] span: 4.
	].
	html paragraph.
	html form: [
		html submitButtonWithAction: [self answer: true] text: 'Proceed with checkout'.
		html break.
		html submitButtonWithAction: [self answer: false] text: 'Modify my order'.
	]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:55'!
answer
	self answer: self! !

WAComponent subclass: #WAClosureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'ab 1/16/2003 15:59'!
go
	|i|
	i _ 1.
	#(a b c) do: [:each | self inform: each asString, ' ', i asString. i _ i + 1]! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 19:43'!
ensure
	[self go] ensure: [self inform: 'ensure']! !

!WAClosureTest methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 19:47'!
renderContentOn: html
	html anchorWithAction: [self go] text: 'go'.
	html space.
	html anchorWithAction: [self ensure] text: 'go with ensure'.! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
onAnswer: aBlock
	self addDecoration: (WAAnswerDecoration new block: aBlock)! !

WAComponent subclass: #WAConfigurationBrowser
	instanceVariableNames: 'pool editors selection trail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:00'!
initialize
	editors _ Dictionary new! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:40'!
select: aConfiguration
	selection _ self editorFor: aConfiguration.
	trail _ WATrail on: selection! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 15:06'!
editorFor: aConfiguration
	^ editors at: aConfiguration ifAbsentPut:
		[WAConfigurationEditor new
			configuration: aConfiguration;
			onAnswer: [:v | self answer];
			yourself]! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:00'!
addConfiguration: nameString
	| config |
	config _ WAUserConfiguration named: nameString.
	pool add: config.
	self select: config! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/25/2004 17:48'!
children
	^ Array with: trail with: selection! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:00'!
pool: aConfigurationPool
	pool _ aConfigurationPool! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:27'!
selectedConfiguration
	^ selection ifNotNil: [selection configuration]! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:00'!
renderContentOn: html
	html form: [
		html
			selectFromList: pool configurations
			selected: self selectedConfiguration
			callback: [:v | self select: v]
			labels: [:ea | ea name].
		html space.
		html submitButtonWithText: 'Go'.
	].
	html form: [
		html text: 'New configuration: '.
		html textInputWithValue: '' callback: [:v | self addConfiguration: v].
		html space.
		html submitButtonWithText: 'Add'.
	].
	selection ifNotNil:
		[html render: trail.
		html horizontalRule.
		self selectedConfiguration isDeletable ifTrue:
			[html paragraph: [html anchorWithAction: [self deleteConfiguration] text: 'Delete']].
		html render: selection]! !

!WAConfigurationBrowser methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:01'!
deleteConfiguration
	(self confirm: 'Are you sure you want to delete ', self selectedConfiguration name printString, '?')
		ifTrue: [pool remove: self selectedConfiguration].
	selection _ trail _ nil! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:15'!
processRequest: aRequest do: aBlock
	aBlock on: WAAnswerNotification do: [:n]! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 4/14/2004 16:40'!
container
	^ WAActiveContainer value! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 19:53'!
decorateWith: aDecoration during: aBlock
	| val |
	self addDecoration: aDecoration.
	val _ aBlock value.
	self removeDecoration: aDecoration.
	^ val! !

WAComponent subclass: #WABatchSelection
	instanceVariableNames: 'batcher linkSelector textSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Dialogs'!

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:17'!
choose: anItem
	self answer: anItem! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 20:43'!
children
	^ Array with: batcher! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:18'!
items: aCollection
	batcher _ WABatchedList new items: aCollection; batchSize: 8! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:22'!
textSelector: aSymbol
	textSelector _ aSymbol! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:22'!
linkSelector: aSymbol
	linkSelector _ aSymbol! !

!WABatchSelection methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:38'!
renderContentOn: html
	html list: batcher batch do:
		[:ea |
		html anchorWithAction: [self choose: ea] text: (ea perform: linkSelector).
		html break; text: (ea perform: textSelector).
		html paragraph].
	html attributes alignCenter.
	html div: batcher.! !

!WABatchSelection class methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:23'!
items: aCollection link: linkSelector text: textSelector
	^ self new
		items: aCollection;
		linkSelector: linkSelector;
		textSelector: textSelector! !

WAComponent subclass: #WADispatcherEditor
	instanceVariableNames: 'path dispatcher type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WADispatcherEditor methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:52'!
entryPointClasses
	^ WAEntryPoint concreteSubclasses! !

!WADispatcherEditor methodsFor: 'initialization' stamp: 'ab 8/26/2003 21:49'!
initialize
	dispatcher _ WADispatcher default.
	type _ WAApplication.
	path _ ''.! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'avi 3/24/2004 12:17'!
configure: anEntryPoint
	anEntryPoint configurationComponent ifNotNilDo: [:c | self call: c]! !

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:08'!
initialize
	self registerAsAuthenticatedApplication: 'config'! !

!WADispatcherEditor class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:56'!
canBeRoot 
	^ true! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'JF 9/22/2003 20:15'!
clearCaches
	WARegistry clearAllHandlers.
	Smalltalk garbageCollect! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'ab 8/26/2003 21:34'!
remove: anEntryPoint
	dispatcher removeEntryPoint: anEntryPoint! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'ab 8/26/2003 21:49'!
addEntryPoint
	| entryPoint |
	path isEmpty ifTrue: [^ self inform: 'You must enter a path.'].
	entryPoint _ type new.
	dispatcher registerEntryPoint: entryPoint at: path.
	self configure: entryPoint! !

!WADispatcherEditor methodsFor: 'actions' stamp: 'avi 3/16/2004 12:29'!
verifyPassword: pass forUser: user
	^ user = 'fooz' and: [pass = 'bar']! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'ab 8/26/2003 21:33'!
renderRowForEntryPoint: anEntryPoint named: aString on: html
	html
		tableRowWith: [html anchorWithUrl: anEntryPoint basePath do: aString]
		with: [
			html anchorWithAction: [self configure: anEntryPoint] text: 'configure'.
			html space; anchorWithAction: [self remove: anEntryPoint] text: 'remove'.
		].! !

!WADispatcherEditor methodsFor: 'rendering' stamp: 'jf 4/23/2004 15:59'!
renderContentOn: html
	html heading: 'Squeak Enterprise Aubergines Server'.
	
	html bold: dispatcher basePath.
	html form: [
		html table: [
			dispatcher entryPoints keysSortedSafely do:
				[:name |
				self
					renderRowForEntryPoint: (dispatcher entryPoints at: name)
					named: name
					on: html].
		]
	].
	html paragraph.
	
	html bold: 'add entry point: '.
	html form: [
		html table: [
			html tableRowWithLabel: 'Path:' column: [html textInputWithValue: '' callback: [:n | path _ n]].
			html tableRowWithLabel: 'Type:' column:
				[html selectFromList: self entryPointClasses selected: type callback: [:c | type _ c] labels: [:ea | ea description].
				html space.
				html submitButtonWithAction: [self addEntryPoint] text: 'Add']
		]
	].

	html anchorWithAction: [self call: (WAConfigurationBrowser new pool: WASystemConfigurationPool default)] text: 'Edit Configurations'.

	html preformatted: SeasidePlatformSupport vmStatisticsReportString.
	html anchorWithAction: [self clearCaches] text: 'Clear Caches'.
	! !

!WADispatcherEditor methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:13'!
dispatcher: aDispatcher
	dispatcher _ aDispatcher! !

WAComponent subclass: #WATrail
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WATrail class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
on: anObject
	^ self new root: anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 15:27'!
root: anObject
	root _ anObject! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 22:16'!
style
^'	ul.trail {
		margin-left: 0;
		padding-left: 0;
		display: inline;
		border: none;
	}
	ul.trail li {
        	margin-left: 0;
        	padding-left: 2px;
        	border: none;
        	list-style: none;
        	display: inline;
	}
	
	ul.trail  li:before {
        content: "\0020 \0020 \0020 \00BB \0020";
        }
        
	ul.trail li.first:before {
        content: " ";
        }
'! !

!WATrail methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 22:15'!
renderContentOn: html
	|last selected|
	html cssClass: 'trail'.
	html unorderedList: [
		root visiblePresentersDo: 
			[:ea |
			(ea isDecoration and: [ea isDelegation]) ifTrue:
				[(ea component respondsTo: #trailName) ifTrue:
					[last _ ea.
					html listItem: [
						html anchorWithAction: [ea remove] text: ea component trailName.
					]]]].
		selected _ last ifNil: [root] ifNotNil: [last delegate].
		(selected respondsTo: #trailName) ifTrue:
			[html listItem: selected trailName].
	]
! !

WAComponent subclass: #WAWebTreeExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Contrib'!

!WAWebTreeExample commentStamp: '<historical>' prior: 0!
This class represents an example for html based tree views.
see http://localhost:/seaside/webtree/ in Seaside!

!WAWebTreeExample methodsFor: 'interface creation' stamp: 'TBn 4/28/2004 19:02'!
createTreeView3
	^ self treeComponentClass new backgroundColor: Color yellow;
		 rootNodes: self testTreeProvider webTree3;
		 yourself! !

!WAWebTreeExample methodsFor: 'interface creation' stamp: 'TBn 4/28/2004 19:02'!
createTreeView2
	^ self treeComponentClass new backgroundColor: Color yellow;
		 rootNodes: self testTreeProvider webTree2;
		 yourself! !

!WAWebTreeExample methodsFor: 'rendering' stamp: 'TBn 4/28/2004 19:51'!
renderContentOn: html 
	html
		anchorWithAction: [self call: self createTreeView1] text: 'TreeView 1';
		break;
		anchorWithAction: [self call: self createTreeView2] text: 'TreeView 2';
		break;
		anchorWithAction: [self call: self createTreeView3] text: 'TreeView 3';
		break;
		anchorWithAction: [self call: self createTreeView4] text: 'TreeView 4';
		break;
		anchorWithAction: [self call: self createTreeView5]
			text: 'Smalltalk Hierarchy'! !

!WAWebTreeExample methodsFor: 'interface creation' stamp: 'TBn 4/28/2004 19:01'!
createTreeView4

	^self treeComponentClass new
		backgroundColor: Color yellow;
		rootNodes: self testTreeProvider webTree4;			
		yourself! !

!WAWebTreeExample class methodsFor: 'class initialization' stamp: 'TBn 4/28/2004 19:02'!
initialize
	self registerAsApplication: 'webtree' ! !

!WAWebTreeExample methodsFor: 'interface creation' stamp: 'TBn 4/28/2004 19:44'!
createTreeView5
	^ self treeComponentClass new backgroundColor: Color yellow;
		 rootNodes: self testTreeProvider webTree5;
		 yourself! !

!WAWebTreeExample methodsFor: 'interface creation' stamp: 'TBn 4/28/2004 19:02'!
createTreeView1
	^ self treeComponentClass new backgroundColor: Color yellow;
		 rootNodes: self testTreeProvider webTree1;
		 yourself! !

!WAWebTreeExample methodsFor: 'attributes' stamp: 'TBn 4/28/2004 19:51'!
testTreeProvider
	"Returns an object providing access to test examples for trees"
	^ WAWebTreeNodeTest! !

!WAWebTreeExample methodsFor: 'attributes' stamp: 'TBn 4/28/2004 19:52'!
treeComponentClass
	"Returns the component used for rendering trees"
	^ WAWebTreeComponent! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 12/6/2002 00:37'!
style
	^ nil! !

WAComponent subclass: #WAExampleBrowser
	instanceVariableNames: 'class selector component hasAnswer answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:40'!
renderContentOn: html
	html cssId: 'test-forms'; table: [
		html tableRowWith: [
			html form: [
				html selectFromList: self allClasses selected: class callback: [:c | self class: c].
				html submitButtonWithText: 'OK'.
			].
		] with: [
			html form: [
				html selectFromList: self allSelectors selected: selector callback: [:s | self selector: s].
			 	html submitButtonWithText: 'OK'.
			]
		].
	].
	html horizontalRule.
	html render: component.
	hasAnswer ifTrue:
		[html horizontalRule.
		html bold: 'Answer '; text: answer printString]! !

!WAExampleBrowser class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:01'!
allSelectors
	^ (class class selectors select: [:s | s beginsWith: self selectorPrefix])
		asSortedCollection! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:33'!
component: aComponent
	component _ aComponent.
	hasAnswer _ false.
	answer _ nil.
	component onAnswer: [:v | hasAnswer _ true. answer _ v].
! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
selectorPrefix
	^ 'example'! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:04'!
selector: aSymbol
	selector _ aSymbol.
	self component: (class perform: selector)! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:54'!
class: aClass
	class _ aClass.
	self selector: self allSelectors first! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 18:53'!
initialize
	self class: self allClasses first! !

!WAExampleBrowser methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:01'!
allClasses
	^ (WAComponent allSubclasses select: [:ea | ea class selectors anySatisfy: [:s | s beginsWith: self selectorPrefix]])
		asSortedCollection: [:a :b | a name < b name]! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:10'!
registerAsApplication: appName
	|app|
	app _ self applicationWithPath: appName.
	WADispatcher default registerEntryPoint: app at: appName.
	^ app! !

WAComponent subclass: #WACounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:59'!
count
	^ count! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 01:07'!
initialize
	(self registerAsApplication: 'counter')
! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'ab 2/20/2003 23:01'!
initialize
	self session registerObjectForBacktracking: self.
	count _ 0! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
renderContentOn: html
	html heading: count.
	html anchorWithAction: [self increase] text: '++'.
	html space.
	html anchorWithAction: [self decrease] text: '--'! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
increase
	count _ count + 1! !

!WACounter class methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 19:02'!
example
	^ self new! !

!WACounter methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
decrease
  count _ count - 1! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: requestString label: labelString default: initialString
	^ self call:
		((WAInputDialog new
			label: labelString;
			default: initialString)
				addMessage: requestString)! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:08'!
canBeRoot
	^ false! !

WAComponent subclass: #WADateSelector
	instanceVariableNames: 'day month year startYear endYear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:52'!
date: aDate
	day _ aDate dayOfMonth.
	month _ aDate monthIndex.
	year _ aDate year.! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:28'!
date
	^ Date newDay: day monthNumber: month year: year! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
labelForMonth: aNumber
	^ Date nameOfMonth: aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:41'!
endYear: anInteger
	endYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
months
	^ 1 to: 12! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
startYear
	^ startYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 16:32'!
renderValidationErrorOn: html
	html spanClass: 'error' with: 'invalid date'! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ab 2/17/2003 13:53'!
dateIsValid
	[self date] on: Error do: [:e | ^ false].
	^ true! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:33'!
renderContentOn: html
	html selectFromList: self months selected: month callback: [:i | month _ i] labels: [:ea | self labelForMonth: ea].
	html selectFromList: self days selected: day callback: [:i | day _ i] labels: [:ea | self labelForDay: ea].
	html selectFromList: self yearRange selected: year callback: [:i | year _ i] labels: [:ea | self labelForYear: ea].
	
	self dateIsValid ifFalse: [self renderValidationErrorOn: html].! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'avi 2/17/2004 14:52'!
initialize
	startYear _ Date today year - 1.
	endYear _ Date today year + 5.
	self date: Date today.! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:43'!
yearRange
	^ self startYear to: self endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:44'!
endYear
	^ endYear! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:06'!
days
	^ 1 to: 31! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForYear: aNumber
	^ aNumber! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'JF 8/14/2003 14:40'!
startYear: anInteger
	startYear _ anInteger! !

!WADateSelector methodsFor: 'as yet unclassified' stamp: 'ac 11/25/2003 12:34'!
labelForDay: aNumber
	^ aNumber! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
request: aString default: initialString
	^ self request: aString label: nil default: initialString! !

!WAComponent methodsFor: 'rendering' stamp: 'ab 6/13/2003 12:26'!
script
	^ nil! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/29/2004 19:07'!
confirm: aString
	^ self call: (WAYesOrNoDialog new addMessage: aString)! !

WAComponent subclass: #WANavigationBar
	instanceVariableNames: 'actionsSelector mOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Widgets'!

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actionsSelector: aSymbol
	actionsSelector _ aSymbol! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 23:33'!
target
	^ mOwner activeComponent! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:45'!
renderInput: aSymbol on: html
	html form: [
		html bold: aSymbol capitalized.
		html space.
		html textInputWithValue: '' callback: [:v | self target perform: aSymbol with: v].
	]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:44'!
renderLink: aSymbol on: html
	html anchorOn: aSymbol of: self target.
	html break! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 16:43'!
renderContentOn: html
	self actions do:
		[:symbol |
		symbol numArgs = 0
			ifTrue: [self renderLink: symbol on: html]
			ifFalse: [self renderInput: symbol on: html]]! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:13'!
initialize
	actionsSelector _ #actions! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'ab 5/30/2003 00:15'!
actions
	^ self target perform: actionsSelector! !

!WANavigationBar methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 23:33'!
owner: anObject
	mOwner _ anObject! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:53'!
addContainer
	self addDecoration: WAContainerDecoration new! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 16:07'!
show: aComponent
	self show: aComponent onAnswer: [:v]! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:49'!
decoration: oldDecoration shouldWrap: newDecoration
	^ (oldDecoration isGlobal and: [newDecoration isGlobal not])
		or: [oldDecoration isDelegation and: [newDecoration isLocal]]! !

WAComponent subclass: #WAWalkback
	instanceVariableNames: 'exception'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:08'!
renderStackFrame: aContext on: html
	html li: [
		html text: aContext fullPrintString.
		html blockquote: [ html table: [
			self renderObject: aContext receiver labelled: 'self' on: html.
			aContext tempNames withIndexDo:
			[:name :index |
			self renderObject: (aContext tempAt: index) labelled: name on: html].
		]]
	]! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:54'!
debug
	self answer! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:09'!
renderObject: anObject labelled: aString on: html
	| objectString |
	[objectString _ anObject printStringLimitedTo: 100]
		on: Error
		do: [objectString _ '<font color="FF0000">&lt;error in printStringLimitedTo:&gt;</font>'].
	html tableRowWithLabel: aString column: objectString.! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:52'!
exception: anException
	exception _ anException! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 1/14/2004 23:16'!
renderWalkbackOn: html
	|context|
	html heading: exception description.
	html ul: [
		context _ thisContext. 
		[context receiver isKindOf: Exception] whileFalse: [context _ context sender].
		[context receiver isKindOf: Exception] whileTrue: [context _ context sender].
		[context notNil] whileTrue: [
			self renderStackFrame: context on: html.
			context _ context sender].
	]! !

!WAWalkback methodsFor: 'as yet unclassified' stamp: 'avi 11/10/2003 01:09'!
renderContentOn: html
	html anchorWithAction: [self debug] text: 'Debug'.
	self renderWalkbackOn: html.! !

WAComponent subclass: #WAInspector
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAInspector methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:34'!
children
	^ Array with: path! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:28'!
renderMembersOn: html 
	| members |
	members := self object inspectorFields.
	members isEmpty ifTrue: [^self].
	html bold: 'Members: '.
	html attributeAt: 'border' put: 1.
	html table: 
			[members associationsDo: 
					[:assoc | 
					self 
						renderRowForObject: assoc value
						named: assoc key
						on: html]]! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:11'!
object: anObject 
	path pushSegment: anObject name: anObject printString! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:11'!
initialize
	path _ WAPath new! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:37'!
canInspect: anObject
	^ anObject isNumber or: [(Array with: nil with: true with: false) includes: anObject]! !

!WAInspector class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 00:21'!
on: anObject
	^ self new object: anObject! !

!WAInspector methodsFor: 'state variables' stamp: 'ab 5/31/2003 15:12'!
object
	^ path currentSegment! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:12'!
renderRowForObject: anObject named: aString on: html
	html tableRow: [
		html tableData: [ 
			(self canInspect: anObject)
				ifTrue: [html text: aString]
				ifFalse: [html anchorWithAction: [self chooseObject: anObject named: aString] text: aString ]
		].
		html tableData: [ html text: (anObject printStringLimitedTo: 100) ]
	]
	! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:32'!
renderContentOn: html 
	html render: path.
	html heading: (self object printStringLimitedTo: 50).
	html text: 'Identity Hash: ', self object identityHash asString; break; break.
	self renderMembersOn: html.! !

!WAInspector methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 15:13'!
chooseObject: anObject named: aString
	path pushSegment: anObject name: aString! !

WAComponent subclass: #WAFrameComponent
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Frames'!

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 4/14/2004 23:56'!
contents: aComponent
	contents _ aComponent! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 19:58'!
contents
	^ contents! !

!WAFrameComponent class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 20:01'!
on: aComponent
	^ self new contents: aComponent! !

WAFrameComponent subclass: #WAAllTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAAllTests methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:56'!
initialize
	self contents:
	 (WASimpleNavigation new
		add: WAInputTest new label: 'Input';
		add: WAHtmlTest new label: 'Html';
		add: WAEncodingTest new label: 'Encoding';
		add: WAErrorTest new label: 'Error';
		add: WAExceptionTest new label: 'Exception';
		add: WAClosureTest new label: 'Closure';
		add: WATransactionTest new label: 'Transaction';
		add: WAUploadTest new label: 'Upload';
		add: (WAParentTest new parent: self) label: 'Parent';
		add:  WAPathTest new label: 'Path';
		add: WATaskTest new label: 'Task';
		add: WACookieTest new label: 'Cookies';
		yourself)! !

!WAAllTests class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:58'!
canBeRoot
	^ true! !

!WAAllTests methodsFor: 'as yet unclassified' stamp: 'avi 5/8/2004 13:38'!
renderContentOn: html
	html heading: 'Test Components'.
	html render: contents! !

WAFrameComponent subclass: #WAProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAProfiler methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:14'!
renderContentOn: html
	| data |
	data _ SeasidePlatformSupport profileSendsDuring: [html render: contents].
	html horizontalRule.
	html preformatted: data.! !

WAFrameComponent subclass: #WAToolFrame
	instanceVariableNames: 'showHalos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'jf 5/8/2004 13:26'!
renderToolbarOn: html 
	html paragraph.
	html 
		divNamed: 'toolbar'
		with: 
			[html anchorWithUrl: self session application baseUrl do: [html text: 'New Session']; space.
			self actions do:
				[:ea |
				html anchorOn: ea of: self; space].
			self tools do:
				[:ea |
				html anchorWithAction: [self openTool: ea] text: ea linkText; space]]! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 22:22'!
toggleHalos
	showHalos contents: showHalos contents not! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:13'!
openTool: aToolClass
	self call: (aToolClass new
				root: contents;
				addDecoration: (WAWindowDecoration new title: aToolClass title))! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'jf 5/8/2004 13:23'!
actions
	^ #(configure toggleHalos)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 22:24'!
renderChildOn: html
	showHalos contents ifTrue: [html context debugMode].
	html render: contents.
	html context clearMode.! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 7/3/2003 12:52'!
tools
	^ WATool allSubclasses! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:20'!
configure
	self call: (WAApplicationEditor new application: self session application)! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/20/2004 18:54'!
style
^'
	#toolbar {position: fixed; bottom: 0; left: 0; right: 0; margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	#toolbar-profile {margin-top: 40px; padding: 3px; clear: both; background: #d3d3d3; font-size: 10pt}
	.halo {border-style: solid; border-width: 1px; margin: 4px; border-color: #aaaaaa}
	.halo-header {font-size: 10pt; background-color: #cccccc; margin-bottom: 4px}
	.halo-mode {float: right}
	.halo-icons: {float: left}
	.halo-contents: {clear: both} 
'
! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 22:21'!
initialize
	showHalos _ WAStateHolder new contents: false! !

!WAToolFrame class methodsFor: 'as yet unclassified' stamp: 'ab 9/28/2002 11:26'!
on: aComponent
	^ self new contents: aComponent! !

!WAToolFrame methodsFor: 'as yet unclassified' stamp: 'avi 3/13/2004 22:21'!
renderContentOn: html 
	html divNamed: 'frameContent' with: [self renderChildOn: html].
	self renderToolbarOn: html.! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 19:58'!
renderContentOn: html
	html render: contents! !

!WAFrameComponent methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 19:58'!
children
	^ Array with: contents! !

WAFrameComponent subclass: #WAPathTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAPathTest methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 00:58'!
initialize
	self contents: WACounter new! !

!WAPathTest methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 12:03'!
updateUrl: aUrl
	aUrl addToPath: contents count asString.
	aUrl fragment: contents count asString.! !

!WAPathTest methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 12:06'!
renderContentOn: html
	html anchorWithName: contents count.
	html render: contents.! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 21:07'!
removeDecoration: aDecoration
	| decoration |
	decoration _ self decoration.
	decoration = aDecoration ifTrue:
		[self decoration: decoration owner.
		^ self].
	
	[decoration notNil] whileTrue:
		[decoration owner = aDecoration
			ifTrue: [decoration owner: aDecoration owner.  ^ self]
			ifFalse: [decoration _ decoration owner]]! !

WAComponent subclass: #WAConfigurationEditor
	instanceVariableNames: 'configuration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 4/13/2004 21:56'!
visitBooleanAttribute: anAttribute with: html
	html
		booleanMenuWithValue:  (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v forAttribute: anAttribute]
		labels: #(true false)! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:35'!
renderAttribute: anAttribute on: html
	html tableRow: [
		html tableData: (html labelForSelector: anAttribute key).
		html tableData: [
			(configuration valueForAttribute: anAttribute)
				ifNil: [self renderUnspecifiedAttribute: anAttribute on: html]
				ifNotNil: 
					[(configuration hasLocalValueForAttribute: anAttribute)
						ifTrue: [self renderOverridenAttribute: anAttribute on: html]
						ifFalse: [self renderInheritedAttribute: anAttribute on: html]]
		].
		self renderInheritanceForAttribute: anAttribute on: html]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 15:08'!
renderInheritanceForAttribute: anAttribute on: html
	configuration inheritedValueAndSourceAt: anAttribute key do:
		[:value :source |
		(configuration hasLocalValueForAttribute: anAttribute)
			ifTrue:
				[html tableData: [
					html anchorWithAction: [configuration clearValueForAttribute: anAttribute] text: 'revert'.
					html text: ' to: ', value printString].
				html tableData: [
					html text: 'overriden from ', source name]]
			ifFalse:
				[html tableData: [html anchorWithAction: [configuration overrideAttribute: anAttribute] text: 'override'].
				html tableData: [html text: 'inherited from ', source name]].
		^ self].
	(configuration hasLocalValueForAttribute: anAttribute)
		ifTrue: [html tableData: [html anchorWithAction: [configuration clearValueForAttribute: anAttribute] text: 'clear']]
		ifFalse:
		[html tableData: [
			html attributes style: 'color: #ff0000'.
			html span: [html text: '(unspecified)']
		]]! !

WAConfigurationEditor subclass: #WAApplicationEditor
	instanceVariableNames: 'application'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAApplicationEditor methodsFor: 'actions' stamp: 'avi 3/24/2004 11:59'!
select: aConfiguration
	self call: (WAConfigurationBrowser new
				pool: (WASystemConfigurationPool default);
				select: aConfiguration;
				yourself)! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 14:37'!
renderFormOn: html
		html text: 'Base Path: '.
		html textInputOn: #basePath of: application.
		html break; break.
		
		super renderFormOn: html! !

!WAApplicationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 14:37'!
renderContentOn: html
	html heading: 'Application: ', application name.

	super renderContentOn: html.! !

!WAApplicationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:32'!
application: anApplication
	application _ anApplication.
	configuration _ application configuration.! !

!WAApplicationEditor methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 20:02'!
children
	^ Array with: configEditor! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 1/30/2004 17:14'!
visitStringAttribute: anAttribute with: html
	html
		textInputWithValue: (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v forAttribute: anAttribute]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:35'!
renderUnspecifiedAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:35'!
renderInheritedAttribute: anAttribute on: html
	html text: (configuration valueForAttribute: anAttribute) printString! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 13:11'!
renderAncestryListFor: aConfiguration seen: aSet on: html
	html list: aConfiguration ancestors do:
		[:ea |
		self renderParent: ea on: html.
		(aSet includes: ea) ifFalse:
			[aSet add: ea.
			self renderAncestryListFor: ea seen: aSet on: html]].
! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:30'!
configuration
	^ configuration! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 3/23/2004 14:40'!
trailName
	^ configuration name! !

!WAConfigurationEditor methodsFor: 'initialization' stamp: 'avi 1/30/2004 16:46'!
initialize
	configuration _ WAConfiguration new! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:34'!
renderOverrideForAttribute: anAttribute on: html
	html anchorWithAction: [configuration overrideAttribute: anAttribute] text: 'edit'! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 4/13/2004 21:03'!
visitPasswordAttribute: anAttribute with: html
	html
		passwordInputWithCallback: [:v | configuration takeValue: v forAttribute: anAttribute]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 3/23/2004 17:01'!
visitListAttribute: anAttribute with: html
	html
		selectFromList: (Array with: nil), anAttribute options asArray
		selected: (configuration valueForAttribute: anAttribute)
		callback: [:v | (configuration takeValue: v forAttribute: anAttribute)]
		labels: [:ea | ea ifNil: ['None'] ifNotNil: [ea asString]]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 13:06'!
renderLinkToAncestor: aConfiguration on: html
	"html anchorWithAction: [self call: (WAConfigurationEditor new configuration: aConfiguration)] text: aConfiguration"
	html text: aConfiguration! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 11:53'!
renderParentSelectorOn: html
	|selectedAncestor|
	selectedAncestor _ ValueHolder new.
	html
		selectFromList: configuration potentialAncestors
		selected: nil
		callback: [:v | selectedAncestor contents: v]
		labels: [:ea | ea name].
	html
		submitButtonWithAction: [configuration addAncestor: selectedAncestor contents]
		text: 'Add'. ! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:36'!
save! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 15:12'!
renderAncestryOn: html
	html attributes style: 'border: 1px solid black; background: lightgrey'.
	html div: [
		html table: [
			html heading: 'Configuration Ancestors' level: 2.

			configuration potentialAncestors isEmpty ifFalse:
				[html text: 'Add ancestor: '.
				self renderParentSelectorOn: html].
			self renderAncestryListFor: configuration seen: Set new on: html]].! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 17:02'!
renderParent: aConfiguration on: html
	aConfiguration isMutable
		ifTrue: [html anchorWithAction: [self select: aConfiguration] text: aConfiguration name]
		ifFalse: [html text: aConfiguration name].
	html space.
	(configuration hasMutableAncestry and: [configuration ancestors includes: aConfiguration]) ifTrue:
		[html
			anchorWithAction: [configuration removeAncestor: aConfiguration] 
			text: '(remove)']! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 15:12'!
renderFormOn: html
	self renderAncestryOn: html.
	html break.
	html attributes style: 'border: 1px solid black'.
	html div: [
		html table: [
			configuration groupedAttributes
				do: [:assoc |
					html tableRowWith: [html heading: (html labelForSelector: assoc key) level: 3] span: 2.
					assoc value do:
						[:attr | self renderAttribute: attr on: html]]]]! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 15:06'!
done
	self answer! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:34'!
renderRevertForAttribute: anAttribute on: html
	html anchorWithAction: [configuration clearValueForAttribute: anAttribute] text: 'clear'! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 14:36'!
renderContentOn: html
	html form: [
		self renderFormOn: html.
		
		html attributes alignCenter.
		html break.
		html submitButtonOn: #save of: self.
		html submitButtonOn: #done of: self.
	]! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'jf 2/8/2004 16:13'!
renderInheritedValueForAttribute: anAttribute on: html
	| inheritedValue |
	inheritedValue _ (configuration lookupValueAt: anAttribute key).
	inheritedValue
		ifNil: 
			[html attributes style: 'color: #ff0000'.
			html span: [html text: '(unspecified)']]
		ifNotNil: [html text: inheritedValue printString]! !

!WAConfigurationEditor methodsFor: 'rendering visitors' stamp: 'avi 1/31/2004 12:25'!
visitNumberAttribute: anAttribute with: html
	html attributes size: 5.
	html
		textInputWithValue: (configuration valueForAttribute: anAttribute)
		callback: [:v | configuration takeValue: v asNumber forAttribute: anAttribute]! !

!WAConfigurationEditor methodsFor: 'accessing' stamp: 'avi 1/31/2004 12:02'!
configuration: aConfiguration
	configuration _ aConfiguration! !

!WAConfigurationEditor methodsFor: 'actions' stamp: 'avi 3/23/2004 14:34'!
select: aConfiguration
	self call: (WAConfigurationEditor new configuration: aConfiguration)! !

!WAConfigurationEditor methodsFor: 'rendering' stamp: 'avi 3/23/2004 12:34'!
renderOverridenAttribute: anAttribute on: html
	anAttribute accept: self with: html! !

WAComponent subclass: #WAMemoryUse
	instanceVariableNames: 'instances sizes table root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:41'!
totalSize
	^ sizes detectSum: [:ea | ea]! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 18:36'!
buildTable
	^ WATableReport new
			rowPeriod: 1;
			rowColors: #('lightgrey' 'white');
			rows: sizes keys asSortedCollection;
			columns: 
				(Array with: (WAReportColumn selector: #yourself title: 'Class')
				with: ( WAReportColumn new
					title: 'Instances';
					valueBlock: [:ea | instances at: ea])
				with:
				 (WAReportColumn new
					title: 'Total Size';
					valueBlock: [:ea | sizes at: ea]))
! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:58'!
totalSizeString
	|size unit|
	size _ self totalSize.
	unit _ 'bytes'.
	size > 1024 ifTrue:
		[size _ size / 1024.
		unit _ 'kB'.
		size > 1024 ifTrue:
			[size _ size / 1024.
			unit _ 'MB']].
	^ (size printShowingDecimalPlaces: 1), ' ', unit! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:57'!
renderContentOn: html
	html bold: self totalInstances asString, ' instances in ', self totalSizeString.
	html render: table.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/19/2003 02:18'!
root: anObject
	|segment results|
	root _ anObject.
	segment _ ImageSegment new copyFromRoots: (Array with: root) sizeHint: 100000.
	results _ segment doSpaceAnalysis.
	instances _ results first.
	sizes _ results second.
	table _ self buildTable.! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'avi 2/10/2004 16:15'!
children
	^ Array with: table! !

!WAMemoryUse methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:42'!
totalInstances
	^ instances detectSum: [:ea | ea]! !

WAComponent subclass: #WAStoreCartView
	instanceVariableNames: 'cart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store'!

!WAStoreCartView commentStamp: 'avi 1/1/2004 09:57' prior: 0!
A component for displaying and modifying a WAStoreCart.  Intended to be embedded rather than called.  The parent must provide a cart instance with #cart:.  Displays a list of items in the cart, and allows individual items to be removed.  Used by WAStoreFillCart.!

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:03'!
renderContentOn: html
	cart hasItems ifFalse: [^ self].
	html divNamed: 'cart' with: [
		html small: [html bold: 'Your cart:'].
		html table: [
			cart countsAndItems do:
				[:assoc | self renderRowForCount: assoc key of: assoc value on: html ].
			html spacerRow.
			html
				tableRowWith: ''
				with: ''
				with: [html bold: cart totalPrice printStringAsCents].
		]
	]! !

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:40'!
renderRowForCount: aNumber of: anItem on: html 
	| countString |
	countString _ (aNumber = 1) ifTrue: [''] ifFalse: ['(', aNumber asString, ') '].
	html
		tableRowWith: [html anchorWithAction: [cart remove: anItem] text: '-']
		with: countString, anItem title 
		with: (aNumber * anItem price) printStringAsCents! !

!WAStoreCartView methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:18'!
cart: aCart
	cart _ aCart! !

WAComponent subclass: #WAUploadTest
	instanceVariableNames: 'file'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Test'!

!WAUploadTest methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:14'!
renderContentOn: html
	html heading: 'Upload File'.
	
	html attributeAt: 'enctype' put: 'multipart/form-data'.
	html form: [
		html fileUploadWithCallback: [:f | file _ f].
		html submitButton.
	].

	file ifNotNil:
		[html anchorWithDocument: file contents mimeType: file contentType fileName: file fileName text:file fileName.
		html preformatted: file contents contents].! !

!WAComponent class methodsFor: 'as yet unclassified' stamp: 'avi 4/15/2004 00:08'!
registerAsAuthenticatedApplication: appName
	| app user password |
	app _ self registerAsApplication: appName.
	app configuration addAncestor: WAAuthConfiguration localConfiguration.
	
	[user _ FillInTheBlank
		request: ('Please choose an administrator\username for the application ''', appName asString , '''') withCRs.
	user = ''] whileTrue.
		
	[password _ FillInTheBlank
		request: 'Please enter a password for ', user printString.
	password = ''] whileTrue.
		
	app preferenceAt: #login put: user.
	app preferenceAt: #password put: password.
	
	^ app
	! !

WAComponent subclass: #WAScreenshot
	instanceVariableNames: 'button text zoom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools-Squeak'!

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:42'!
offset
	^ zoom ifTrue: [self topWindow position] ifFalse: [0@0]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 02:01'!
toggleUIProcess
	Project uiProcess isSuspended
		ifTrue: [Project uiProcess resume]
		ifFalse: [Project uiProcess suspend]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:48'!
click: aPoint
	|evt|
	evt _ Sensor createMouseEvent.
	evt at: 3 put: aPoint x.
	evt at: 4 put: aPoint y.
	evt at: 5 put: self buttonCode.
	Sensor processEvent: evt.	
	evt at: 5 put: 0.
	Sensor processEvent: evt.
	button _ #red.! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:48'!
buttonCode
	^ button = #red ifTrue: [4] ifFalse: [button = #blue ifTrue: [2] ifFalse: [1]]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:15'!
toggleZoomText
	^ zoom ifTrue: ['Zoom out'] ifFalse: ['Zoom in']! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:15'!
toggleZoom
	zoom _ zoom not! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:18'!
form
	^ zoom ifFalse: [Display copy] ifTrue: [self topWindow imageForm]! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 1/21/2004 02:01'!
toggleUIText
	^ Project uiProcess isSuspended
		ifFalse: ['Suspend UI Process']
		ifTrue: ['Resume UI Process']! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:42'!
renderContentOn: html
	| group |
	html table: [
		html tableRow: [
		html tableData: [
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'Button: '.
	
				group _ html radioGroup.
				#(red yellow blue) do:
					[:ea |
					html attributes at: 'bgcolor' put: ea.
					html tableData: [
						html radioButtonInGroup: group selected: (button = ea) callback: [button _ ea].
					]].
				html tableData: [html submitButtonWithText: 'Set']
			]
		]
	].
	].
	html tableData: [
	html anchorWithAction: [self toggleZoom] text: self toggleZoomText.	
	].
	html tableData: [
	html anchorWithAction: [self toggleUIProcess] text: self toggleUIText.
	]]].
	html imageMapWithAction: [:pt | self click: pt + self offset] form: self form.
	html horizontalRule.
	! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:16'!
initialize
	button _ #red.
	zoom _ false! !

!WAScreenshot methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 14:18'!
topWindow
	^ SystemWindow classPool at: #TopWindow! !

!WAScreenshot class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:57'!
canBeRoot
	^ true! !

!WAComponent methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 00:55'!
authenticateWith: anAuthenticator during: aBlock
	^ self decorateWith: (WABasicAuthentication new authenticator: anAuthenticator) during: aBlock
! !

!WAComponent methodsFor: 'convenience' stamp: 'avi 3/27/2004 00:56'!
isolate: aBlock
	|txn val |
	txn _ WATransaction new.
	val _ self decorateWith: txn during: aBlock.
	txn close.
	^ val! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 4/22/2004 14:51'!
visiblePresentersDo: aBlock
	self decorationChainDo: [:ea | ea withNextPresentersDo: aBlock]! !

WAPresenter subclass: #WADecoration
	instanceVariableNames: 'next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

WADecoration subclass: #WABasicAuthentication
	instanceVariableNames: 'authenticator realm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 00:04'!
realm
	^ realm ifNil: [self session application basePath]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:52'!
realm: aString
	realm _ aString! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:42'!
verifyRequest: aRequest
	^ authenticator verifyPassword: aRequest password  forUser: aRequest user! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'jf 5/8/2004 13:03'!
renderContentOn: html
	(self verifyRequest: html request)
		ifTrue: [self renderOwnerOn: html]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'jf 5/8/2004 13:03'!
processRequest: aRequest do: aBlock
	(self verifyRequest: aRequest)
		ifTrue: [aBlock value]
		ifFalse: [self respondWithChallenge]! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 5/19/2004 14:16'!
respondWithChallenge
	self session returnResponse: (WAResponse basicAuthWithRealm: self realm)! !

!WABasicAuthentication methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 13:03'!
authenticator: anAuthenticator
	authenticator _ anAuthenticator! !

WADecoration subclass: #WAValidationDecoration
	instanceVariableNames: 'message validationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:06'!
processRequest: aRequest do: aBlock
	aBlock on: WAAnswerNotification do: [:n | (self validate: n value) ifTrue: [n pass]]! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:05'!
renderContentOn: html
	message contents ifNotNilDo:
		[:msg |
		html divClass: 'validation-error' with: msg].
	self renderOwnerOn: html.! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:49'!
validateWith: aBlock
	validationBlock _ aBlock! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:07'!
validate: anObject
	[validationBlock value: anObject.
	^ true]
		on: Error
		do: [:e | message contents: e messageText].
	^ false! !

!WAValidationDecoration methodsFor: 'as yet unclassified' stamp: 'avi 12/10/2003 12:50'!
initialize
	message _ WAStateHolder new! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 21:07'!
nextPresentersDo: aBlock
	super nextPresentersDo: aBlock.
	aBlock value: self owner! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:13'!
component
	^ self owner isDecoration
		ifTrue: [self owner component]
		ifFalse: [self owner]! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:48'!
isGlobal
	^ false! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:20'!
owner: aPresenter
	next ifNil: [next _ WAStateHolder new].
	next contents: aPresenter! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:23'!
isDelegation
	^ false! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:20'!
owner
	^ next ifNotNil: [next contents]! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:49'!
isLocal
	^ (self isGlobal or: [self isDelegation]) not! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ true! !

WADecoration subclass: #WAFormDecoration
	instanceVariableNames: 'buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:36'!
buttons
	^ buttons! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:34'!
renderButtonsOn: html
	html divClass: 'dialog-buttons' with: [
		self buttons do:
			[:ea |
			html spanNamed: ea with: [self renderButtonForSelector: ea on: html]]
	]! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 21:07'!
renderButtonForSelector: aSymbol on: html
	html submitButtonOn: aSymbol of: self owner! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:34'!
buttons: selectorArray
	buttons _ selectorArray! !

!WAFormDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/16/2004 13:36'!
renderContentOn: html
	html form: [
		self renderOwnerOn: html.
		self renderButtonsOn: html.
	]! !

WADecoration subclass: #WAMessageDecoration
	instanceVariableNames: 'message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAMessageDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 00:49'!
renderContentOn: html
	html heading: message level: 3.
	self renderOwnerOn: html.! !

!WAMessageDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 00:43'!
message: aString
	message _ aString! !

WADecoration subclass: #WAContainerDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAContainerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 19:53'!
processRequest: aRequest do: aBlock
	WAActiveContainer use: self component during: aBlock! !

!WAContainerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 13:18'!
isGlobal
	^ true! !

WADecoration subclass: #WATransaction
	instanceVariableNames: 'active'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
initialize
	active _ true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 15:14'!
processRequest: aRequest do: aBlock
	^ active
		ifTrue: [aBlock value]
		ifFalse: [self session pageExpired].
	! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:51'!
isGlobal
	^ true! !

!WATransaction methodsFor: 'as yet unclassified' stamp: 'ab 1/15/2003 21:55'!
close
	active _ false! !

WADecoration subclass: #WAWindowDecoration
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 21:04'!
style
	^ '.window-titlebar {background-color: #aaaaaa; padding: 5px; margin-bottom: 5px}
	    .window-close {float: right}
	   .window-title {}
	    .window-content {clear: both}
	'! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:12'!
renderCloseButtonOn: html
	html anchorWithAction: [self component answer] text: 'close'! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 12:51'!
title: aString
	title _ aString! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/28/2004 20:52'!
isGlobal
	^ true! !

!WAWindowDecoration methodsFor: 'as yet unclassified' stamp: 'cds 4/21/2004 09:29'!
renderContentOn: html
	html linkWithStyle: self style.
	html title: title.
	html divClass: 'window-titlebar' with: [
		html spanClass: 'window-close' with: [self renderCloseButtonOn: html].		
		html spanClass: 'window-title' with: title.
	].
	html divClass: 'window-content' with: [self renderOwnerOn: html].! !

WADecoration subclass: #WAAnswerDecoration
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 16:10'!
processRequest: aRequest do: aBlock
	aBlock on: WAAnswerNotification do: [:n | self answer: n value]! !

!WAAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/26/2004 16:27'!
block: aBlock
	block _ aBlock! !

!WAAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 5/12/2004 17:21'!
renderContentOn: html
	[super renderContentOn: html] on: WAAnswerNotification do: [:n | self answer: n value]! !

!WAAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 16:10'!
answer: anObject
	block value: anObject! !

WAAnswerDecoration subclass: #WADelegation
	instanceVariableNames: 'delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 3/27/2004 22:26'!
isDelegation
	^ true! !

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:18'!
delegate: aComponent
	delegate _ aComponent! !

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 4/22/2004 14:51'!
nextPresentersDo: aBlock
	delegate decorationChainDo: aBlock! !

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 16:10'!
answer: anObject
	self remove.
	super answer: anObject! !

!WADelegation methodsFor: 'as yet unclassified' stamp: 'avi 3/12/2004 20:18'!
delegate
	^ delegate! !

!WAAnswerDecoration methodsFor: 'as yet unclassified' stamp: 'avi 4/14/2004 23:55'!
showHalo
	^ false! !

!WADecoration methodsFor: 'rendering' stamp: 'avi 3/27/2004 21:07'!
renderOwnerOn: html
	self owner ifNotNilDo: [:owner | owner renderWithContext: html context]! !

!WADecoration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 16:10'!
remove
	self component removeDecoration: self! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 2/2/2004 20:04'!
children
	^ #()! !

!WAPresenter methodsFor: 'convenience' stamp: 'avi 4/13/2004 19:48'!
session
	^ WACurrentSession value! !

!WAPresenter methodsFor: 'decoration' stamp: 'avi 3/27/2004 19:55'!
isDecoration
	^ false! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 17:25'!
rendererClass
	^ WAHtmlRenderer! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 20:59'!
renderContentOn: aRenderer
	self nextPresentersDo: [:ea | ea renderWithContext: aRenderer context]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/27/2004 17:27'!
showHalo
	^ true! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 5/12/2004 16:55'!
processRequestActions: aRequest context: aRenderingContext
	(aRenderingContext callbacksFor: self) processRequestActions: aRequest.
	self nextPresentersDo:
		[:ea |
		self processRequest: aRequest do:
			[ea processRequestActions: aRequest context: aRenderingContext]]
! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 5/12/2004 16:55'!
processRequestInputs: aRequest context: aRenderingContext
	(aRenderingContext callbacksFor: self) processRequestInputs: aRequest.
	self nextPresentersDo:
		[:ea |
		self processRequest: aRequest do:
			 [ea processRequestInputs: aRequest context: aRenderingContext]]! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 2/6/2004 17:48'!
childrenDo: aBlock
	self children do: [:ea | ea ifNotNil: [aBlock value: ea]]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 5/22/2004 12:57'!
findParent
	| context |
	context _ thisContext.
	[context notNil and: [context homeReceiver == self or: [(context homeReceiver isKindOf: WAComponent) not]]]
		whileTrue: [context _ context sender].
	^ context ifNotNil: [context homeReceiver]! !

!WAPresenter methodsFor: 'path' stamp: 'avi 3/22/2004 01:00'!
updateUrl: aUrl
! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/28/2004 20:57'!
style
	^ nil! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 4/22/2004 15:59'!
checkParent
	| parent |
	(self session application preferenceAt: #deploymentMode) ifFalse:
		[parent _ self findParent.
		(parent children includes: self)
			ifFalse: [self error: parent asString, ' does not include ', self asString, ' in #children']]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 4/22/2004 15:57'!
renderOn: aRenderer
	self checkParent.
	self decorationChainDo: [:ea | ea renderWithContext: aRenderer context]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/28/2004 20:57'!
script
	^ nil! !

!WAPresenter class methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:14'!
new
	^ self basicNew initialize! !

!WAPresenter methodsFor: 'tree' stamp: 'avi 3/27/2004 20:59'!
withNextPresentersDo: aBlock
	aBlock value: self.
	self nextPresentersDo: [:ea | ea withNextPresentersDo: aBlock]! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 4/13/2004 17:19'!
renderAllOn: aRenderer
	self script ifNotNilDo: [:script | aRenderer linkWithScript: script].
	self style ifNotNilDo: [:ea | aRenderer linkWithStyle: ea].
	
	self renderContentOn: aRenderer.! !

!WAPresenter methodsFor: 'initialization' stamp: 'ab 2/13/2003 01:10'!
initialize! !

!WAPresenter methodsFor: 'rendering' stamp: 'avi 3/28/2004 20:54'!
renderWithContext: aRenderingContext
	| html callbacks |
	callbacks _ aRenderingContext callbacksFor: self.
	html _ self rendererClass context: aRenderingContext callbacks: callbacks.
	(self showHalo and: [aRenderingContext isDebugMode])
		ifTrue: [(WAHalo for: self) renderAllOn: html]
		ifFalse: [self renderAllOn: html].! !

!WAPresenter methodsFor: 'request processing' stamp: 'avi 3/22/2004 14:22'!
processRequest: aRequest do: aBlock
	aBlock value! !

Object subclass: #WAModelProxy
	instanceVariableNames: 'cache model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAModelProxy methodsFor: 'accessing' stamp: 'ab 11/26/2002 17:22'!
model
	^ model! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
value
	^ model value! !

!WAModelProxy class methodsFor: 'as yet unclassified' stamp: 'ab 11/26/2002 17:21'!
on: anObject
	^ self new setModel: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:53'!
doesNotUnderstand: aMessage
	^ aMessage selector isUnary
		ifTrue: [self performRead: aMessage selector]
		ifFalse:
			[(aMessage selector isKeyword and: [aMessage arguments size = 1])
				ifTrue: [self performWrite: aMessage selector allButLast with: aMessage argument]
				ifFalse: [super doesNotUnderstand: aMessage]]! !

!WAModelProxy methodsFor: 'initializing' stamp: 'ab 12/12/2002 00:18'!
setModel: anObject
	model _ anObject.
	cache _ Dictionary new.! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 12/12/2002 00:18'!
commit
	cache keysAndValuesDo:
		[:key :value |
		self performRealWrite: key with: value].

	cache _ Dictionary new.
! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:50'!
performRead: aSymbol
	^ cache at: aSymbol ifAbsent: [model perform: aSymbol]! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:51'!
performWrite: aSymbol with: anObject
	cache at: aSymbol put: anObject! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 17:24'!
name
	^ model name! !

!WAModelProxy methodsFor: 'forwarding' stamp: 'ab 11/26/2002 18:39'!
performRealWrite: aSymbol with: anObject
	model perform: (aSymbol,':') asSymbol with: anObject! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HtmlBuilder'!

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 15:18'!
printOpenTagOn: aStream 
	aStream
		nextPut: $<;
		nextPutAll: self name.
	attributes writeOn: aStream.
	self shouldPrintCloseTag ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:49'!
initializeWithName: aString attributes: anAttributes
	name _ aString.
	attributes _ anAttributes.
	isClosed _ true.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 3/29/2003 00:10'!
childrenDo: aBlock
	children ifNotNil: [children do: aBlock]! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString
	^ self named: aString attributes: (WAHtmlAttributes new)! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:47'!
name
	^ name asLowercase! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:49'!
beClosed
	isClosed _ true! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:51'!
shouldPrintCloseTag
	^ isClosed! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString attributes: anAttributes
	^ self new initializeWithName: aString attributes: anAttributes! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:14'!
attributeAt: aString put: anObject
	attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 15:17'!
printHtmlOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea writeOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/22/2004 15:18'!
writeOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea writeOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'ab 1/11/2003 13:47'!
add: anElement
	children ifNil: [children _ OrderedCollection new].
	children add: anElement.! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:50'!
notClosed
	isClosed _ false! !

!WAHtmlElement methodsFor: 'as yet unclassified' stamp: 'JF 6/11/2003 14:44'!
printCloseTagOn: aStream 
	aStream
		nextPutAll: '</';
		nextPutAll: self name;
		nextPut: $>! !

Object subclass: #WAStoreItem
	instanceVariableNames: 'title subtitle description price'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

!WAStoreItem commentStamp: 'avi 1/1/2004 09:34' prior: 0!
Models a single item of inventory - stores a title, subtitle, fill description, and price.  The only real behavior is #matches:, which is used for search.!

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price
	^ price! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description: aString
	description _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:17'!
subtitle: aString
	subtitle_ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'avi 12/9/2003 13:17'!
printString
	^ self title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 23:17'!
subtitle
	^ subtitle! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title
	^ title! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:28'!
price: cents
	price _ cents! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
description
	^ description! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:27'!
title: aString
	title _ aString! !

!WAStoreItem methodsFor: 'as yet unclassified' stamp: 'ab 5/25/2003 13:30'!
matches: aString
	^ (title includesSubstring: aString caseSensitive: false)
		or: [description includesSubstring: aString caseSensitive: false]! !

Object subclass: #WACallbackStore
	instanceVariableNames: 'context inputs actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Rendering'!

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 18:47'!
registerDispatchCallback
	^ self registerCallback: (MessageSend receiver: self selector: #dispatch:)! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 18:31'!
initializeWithContext: aRenderingContext
	inputs _ OrderedCollection new.
	actions _ OrderedCollection new.
	context _ aRenderingContext! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 18:40'!
registerCallback: aBlock
	^ self storeCallback: aBlock in: inputs! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 18:42'!
registerActionCallback: aBlock
	^ self storeCallback: aBlock in: actions! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 19:00'!
processRequestActions: aRequest
	actions do:
		[:assoc |
		(aRequest fields includesKey: assoc key)
			ifTrue: [assoc value value]]! !

!WACallbackStore methodsFor: 'private' stamp: 'avi 3/22/2004 19:19'!
dispatch: keyString
	(inputs detect: [:ea | ea key = keyString]) value valueWithPossibleArgs: #(nil)! !

!WACallbackStore class methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 12:18'!
context: aRenderingContext
	^ self basicNew initializeWithContext: aRenderingContext! !

!WACallbackStore methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 19:02'!
processRequestInputs: aRequest
	inputs do:
		[:assoc |
		aRequest fields at: assoc key ifPresent:
			[:v |
			assoc value valueWithPossibleArgs: (Array with: (self valueForField: v))]]! !

!WACallbackStore methodsFor: 'private' stamp: 'avi 3/22/2004 19:16'!
storeCallback: aBlock in: aCollection
	|key|
	key _ context nextKey.
	aBlock fixTemps.
	aCollection add: key -> aBlock.
	context increaseKey.
	^ key
! !

!WACallbackStore methodsFor: 'private' stamp: 'ab 10/2/2002 00:19'!
valueForField: field 
	^ field
		ifNil: ['']
		ifNotNil:
			[(field isCollection and: [field isString not])
					ifTrue: [field isEmpty
								ifTrue: ['']
								ifFalse: [field first]]
					ifFalse: [field]]! !

Object subclass: #WAStoreInventory
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Examples-Store-Model'!

WAStoreInventory class
	instanceVariableNames: 'default'!

!WAStoreInventory commentStamp: 'avi 1/1/2004 09:33' prior: 0!
The list of inventory items.  In a real application, this would probably have to deal with persistence, maintaining inventory counts, etc.  In this example, it just builds a collection of WAStoreItems from a hardcoded data set, and provides #allItems and #findItem: for accessing these.!

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
allItems
	^ items! !

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:17'!
new
	^ self basicNew initialize! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
findItem: searchString
	^ items select: [:ea | ea matches: searchString]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'avi 9/18/2003 16:43'!
itemSpecs
"adapted from http://www.thaddeus.com/ftp/database/sushi.zip"
	^ #(
#('Akami Maguro' 'Red Tuna' 'The lean meat near the spine of the tuna fish.  It comes in various shades of red--with the lighter, shinier varieties being the best.  For dieters, however, the redder the better.  Easy on the palatte.  The least expensive of the three types of maguro.' 150)
#('Chutoro Maguro' 'Fatty Tuna' 'The moderately fatty part of the tuna belly.  It''s pink, but not the faint pink of ohtoro.  Soft, butter-like texture.  Moderately expensive.' 275)
#('Geso Ika' 'Cuttlefish Tentacles' 'White in color, geso is boiled and brushed with thick teriyaki sauce before serving as sushi.  Its texture is chewy, and its mild flavor is complemented by the sweet-salty teriyaki.' 200)
#('Himo Akagai' 'Ark Shell Filaments' 'This is the thread-like edges which connect the flesh to the shell.  A delicious, soft texture and mild taste.' 200)
#('Hotategai' 'Scallop' 'The part of the scallop that is eaten is the edible adductor muscle that opens the animal''s shell.  It''s pale beige-yellow in color with a brown, crusty edging.  The taste is delicate, and melts in your mouth. ' 250)
#('Iwashi' 'Sardine' 'Shiny, slippery, and ''fishy,'' the taste of sardine sushi is slightly oily.  Sardine must be eaten shortly after it has been caught if it''s to be used in Sushi.  Often eaten with soy sauce mixed with ginger and onion.' 175)
#('Kazunoko' 'Herring Roe' 'An expensive delicacy which is also known as ''yellow diamonds'' (because of the color and expense).  Revered in Japan, it''s usually eaten on special occasions.  An acquired taste for Westerners.' 475)
#('Kisu' 'Sillago' 'A fresh Sillago has bright-gold skin. The taste is mild and delicate.' 225)
#('Ohtoro Maguro' 'Fattiest Tuna' 'Fattiest part of the fatty tuna belly.  It is light pink in color and melts in your mouth.  Mild with a rich texture.  This is the most expensive of the three types of Maguro sushi.' 325)
#('Shima-Aji' 'Yellow Jack' 'A slice of white silvery shima-aji eaten with beef-steak plant and fresh ginger is delicious.  The flavor is delicate and the texture of good, fresh yellow jack is smooth and slides down easily.' 180)
#('Aji' 'Horse Mackerel' 'This fish is pink-grey and shiny.  When it''s fresh, the flesh is almost transparent.  The texture is slippery and easy on the tongue--it should melt in your mouth.  Aji is often eaten with soy sauce containing onion, ginger and garlic.' 250)
#('Inarizushi' 'Stuffed Bean Curd Rolls' '' 200)
#('Kappa Maki' 'Cucumber Rolls' '' 150)
#('Sakura Denbu' 'Shredded Cod Fish' 'Seasoned shredded cod fish.' 200)
#('California Roll' '' 'Rice, cucumber, crab meat, & avacado.' 250)
#('Futo-Maki' 'Fat Rolls' 'Kampyo gourd, oboro or denbu pink powder, tamago omelet, and shiitake mushrooms. May also include bamboo shoots, cucumbers, cooked eel, cooked carrots, and cooked spinach or other greens.' 275)
#('Tekkamaki' 'Tuna Roll' 'Tuna wrapped in rice and nori.' 225)
#('Chakinzushi' 'Omelet-wrapped Sushi' 'Sushi rice in a thin omelet wrapper shaped and tied like a lady''s drawstring purse.  Sometimes a single pea or small shrimp decorates the ruffled part of the wrapper.' 300)
#('Shiro Maguro' 'Albacore Tuna' '' 300)
#('Hamachi' 'Yellowtail' '' 325)
#('Kohada' 'Gizzard Shad' 'This Japanese shad is a member of the herring family, and is a small silver-grey fish, with a black spotted back.  Marinated in vinegar and cross- hatched before serving.  The taste is strong, and a favorite for herring fans.' 275)
#('Katsuo' 'Bonito' '' 275)
#('Saba' 'Mackerel' '' 200)
#('Sake' 'Salmon' '' 250)
#('Tai' 'Red Snapper' '' 250)
#('Hirame' 'Flounder' 'Good hirame is a sushi gourmet''s delight.  Since it''s cut from such a small part of the fish, it''s scarce and expensive.  In appearance, it''s pale pink and smooth, with no markings.  The taste is delicate and buttery.' 350)
#('Suzuki' 'Sea Bass' '' 300)
#('Unagi' 'Freshwater Eel' '' 300)
#('Ika' 'Cuttlefish' 'When fresh, cuttlefish is almost transparent.  It''s butter-like and melts in your mouth.  The texture is sticky.  Cuttlefish is smoky white and glistens. Also popular grilled and mixed with ginger soy sauce.  Also good with lemon for Western palettes.' 325)
#('Awabi' 'Abalone' 'Abalone or ''sea snail'' is another sushi favorite.  The color ranges from beige-grey to pinkish yellow.  Fresh abalone is not too rubbery, and is very subtle in flavor.' 300)
#('Mirugai' 'Horse Clam' 'Also known as Geoduck.  This is a large, hard-shelled clam which is yellowish-white in color.  It has a slight ''shellfish'' taste and an elastic type texture. The part used in sushi is the long muscular siphon which projects from the shell.' 350)
#('Akagai' 'Ark Shell Clam' 'The softest texture of any shellfish. Akagai has an attractive pink-orange color.  The taste is delicate and slightly sweet.' 300)
#('Kobashira' 'Trough Shell (Small) Scallop' 'The edible adductor muscle that opens the shell of the aoyagi.  More prized than the aoyagi itself.' 500)
#('Kani' 'Crab' '' 250)
#('Ebi' 'Cooked Prawn' '' 225)
#('Ikura' 'Salmon Roe' 'Appealing to the eye with its bright red color.  Very appetizing with a delicate taste.' 325)
#('Tobiko ' 'Flying-Fish Roe' '' 350)
#('Masago ' 'Capelin Roe' '' 350)
#('Anago' 'Conger Eel' 'Anago is one of the few pre-cooked sushi.  It is grilled and basted with a thick teriyaki sauce.  The soft, slighty warm eel, the sweet soy sauce, and the vinegared rice make a particularly delicious sushi.' 300)
#('Uni' 'Sea Urchin Roe' 'A prized delicacy with its oily, rich texture.  Mustard color, paste-like topping is held in place by a band of nori seaweed.' 400)
) asSortedCollection: [:a :b | a first <= b first]! !

!WAStoreInventory class methodsFor: 'as yet unclassified' stamp: 'avi 12/8/2003 14:26'!
default
	^ default ifNil: [default _ self new]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
initialize
	items _ OrderedCollection new.
	self itemSpecs do:
		[:row |
		items add: (self itemFromSpec: row)]! !

!WAStoreInventory methodsFor: 'as yet unclassified' stamp: 'ab 8/15/2003 17:19'!
itemFromSpec: anArray
	^ WAStoreItem new
		title: anArray first;
		subtitle: anArray second;
		description: anArray third;
		price: anArray fourth! !

Object subclass: #WAWebTreeNode
	instanceVariableNames: 'wrappedObject subnodes isExpanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Contrib'!

!WAWebTreeNode commentStamp: 'TBn 4/28/2004 20:12' prior: 0!
This class represents a tree item for a web tree. It's a simple
wrapper for your objects.

!

!WAWebTreeNode methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:30'!
hasSubnodes
	"the first test is necessary to avoid the lazy initialization in the getter"

	^subnodes notNil and: [self subnodes isEmpty not]! !

!WAWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:28'!
wrappedObject

	^wrappedObject! !

!WAWebTreeNode methodsFor: 'printing' stamp: 'TBn 4/28/2004 17:29'!
printOn: aStream
	"prints the receiver on aStream"

	aStream nextPutAll: '##('.
	self wrappedObject printOn: aStream.
	aStream nextPut: $)! !

!WAWebTreeNode class methodsFor: 'instance creation' stamp: 'TBn 4/28/2004 17:31'!
for: anObject

	^self new
		wrappedObject: anObject;
		yourself! !

!WAWebTreeNode class methodsFor: 'instance creation' stamp: 'avi 5/18/2004 13:19'!
new
	^ self basicNew initialize! !

!WAWebTreeNode methodsFor: 'operations' stamp: 'TBn 4/28/2004 17:29'!
collapse

	self isExpanded: false! !

!WAWebTreeNode class methodsFor: 'instance creation' stamp: 'TBn 4/28/2004 17:32'!
for: rootObject childBlock: aOneArgumentBlock 
	"self for: Object childBlock: [:each | each subclasses]"
	| coll node |
	coll := aOneArgumentBlock value: rootObject.
	node := self for: rootObject.
	coll isEmpty
		ifTrue: [^ node].
	coll
		do: [:child | node
				addChild: (self for: child childBlock: aOneArgumentBlock)].
	^ node! !

!WAWebTreeNode methodsFor: 'operations' stamp: 'TBn 4/28/2004 17:29'!
expand

	self isExpanded: true! !

!WAWebTreeNode methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:30'!
isExpanded
	"Returns true if the node is expanded. Note that leaf node always return false"

	^isExpanded and: [self hasSubnodes]! !

!WAWebTreeNode methodsFor: 'initialize-release' stamp: 'TBn 4/28/2004 17:29'!
initialize
	super initialize.
	self collapse! !

!WAWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:28'!
wrappedObject: anObject

	wrappedObject := anObject! !

!WAWebTreeNode methodsFor: 'private-accessing' stamp: 'TBn 4/28/2004 17:30'!
isExpanded: aBoolean
	
	isExpanded := aBoolean! !

!WAWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:27'!
addChild: aChildNode
	self subnodes add: aChildNode! !

!WAWebTreeNode class methodsFor: 'examples' stamp: 'TBn 4/28/2004 20:14'!
smalltalkHierarchy
	"Returns an instance of the receiver wrapping the smalltalk class 
	hierarchy using Object as root node"
	^ self
		for: Object
		childBlock: [:each | each subclasses]! !

!WAWebTreeNode methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:30'!
isCollapsed
	"Returns true if the node is a leaf node or the node is collapsed"

	^self isExpanded not! !

!WAWebTreeNode methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:27'!
subnodes

	subnodes isNil ifTrue: [subnodes := OrderedCollection new].
	^subnodes! !

Object subclass: #WAConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:59'!
valueForAttribute: anAttribute
	^ self valueAt: anAttribute key! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:44'!
isMutable
	^ false! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:53'!
allAttributes
	^ Array streamContents:
		[:s | 
		self withAllAncestorsDo: [:ea | s nextPutAll: ea attributes]]
! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
localValueAt: aSymbol ifAbsent: absentBlock
	self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestors
	| temp linear |
	temp _ OrderedCollection new.
	linear _ OrderedCollection new.
	self addAncestorsTo: temp linearization: linear.
	^ linear allButFirst asArray! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:20'!
writeUserConfigurationsOn: aStream
	| ini |
	ini _ INIFile new.
	self registry keysAndValuesDo:
		[:key :value | (ini section: key) addAll: value localValues].
	ini writeOn: aStream! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 1/30/2004 16:32'!
attributesAndValuesDo: keyValueBlock
	^ self allAttributes do:
		[:ea |
		keyValueBlock value: ea value: (self valueForAttribute: ea)]! !

WAConfiguration subclass: #WAMutableConfiguration
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues
	| dict |
	dict _ Dictionary new.
	self allAttributes do:
		[:attr | (self localValueAt: attr key ifAbsent: [nil])
			ifNotNilDo: [:value | dict at: attr key put: (attr stringForValue: value)]].
		
	^ dict! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 15:21'!
takeValue: anObject forAttribute: anAttribute
	^ anObject ifNotNil: [values at: anAttribute key put: anObject]! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
overrideAttribute: anAttribute
	self takeValue: (self valueForAttribute: anAttribute) forAttribute: anAttribute! !

WAMutableConfiguration subclass: #WALocalConfiguration
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WALocalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:54'!
ancestors
	^ Array with: parent! !

!WALocalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:54'!
name
	^ parent localConfigurationName! !

!WALocalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:54'!
initializeWithParent: aSystemConfiguration
	parent _ aSystemConfiguration.
	self initialize! !

!WALocalConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:55'!
parent: aSystemConfiguration
	^ self basicNew initializeWithParent: aSystemConfiguration! !

WAMutableConfiguration subclass: #WAUserConfiguration
	instanceVariableNames: 'name ancestors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 17:06'!
isDeletable
	^ true! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:55'!
name: aString
	name _ aString! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:34'!
addAncestor: aConfiguration
	(self inheritsFrom: aConfiguration)
		ifFalse: [ancestors add: aConfiguration]! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:52'!
initialize
	super initialize.
	ancestors _ OrderedCollection new.! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ ancestors! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:57'!
allPotentialAncestors
	^ WASystemConfigurationPool default configurations! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ true! !

!WAUserConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:02'!
named: aString
	^ self new name: aString! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:35'!
removeAncestor: aConfiguration
	ancestors remove: aConfiguration ifAbsent: []! !

!WAUserConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:55'!
name
	^ name ifNil: ['Anonymous']! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clearValueForAttribute: anAttribute
	values removeKey: anAttribute key ifAbsent: []! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
valueAt: aSymbol put: anObject
	^ self takeValue: anObject forAttribute: (self attributeNamed: aSymbol)! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
clear
	values _ Dictionary new.! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
isMutable
	^ true! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValueAt: aSymbol ifAbsent: errorBlock
	^ values at: aSymbol ifAbsent: errorBlock! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
initialize
	super initialize.
	values _ Dictionary new! !

!WAMutableConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/23/2004 14:51'!
localValues: aDictionary
	self allAttributes do:
		[:attr | (aDictionary at: attr key ifAbsent: [nil])
			ifNotNilDo: [:string | self valueAt: attr key put: (attr valueFromString: string)]]! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/1/2004 14:54'!
attributeNamed: aSymbol
	^ self allAttributes
		detect: [:ea | ea key = aSymbol]
		ifNone: [self error: 'No attribute named ', aSymbol printString]
! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 17:06'!
isDeletable
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 2/3/2004 22:58'!
valueAt: aSymbol
	^ self localValueAt: aSymbol ifAbsent: [self lookupValueAt: aSymbol]! !

!WAConfiguration class methodsFor: 'instance creation' stamp: 'avi 1/30/2004 16:39'!
new
	^ self basicNew initialize! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
lookupValueAt: aSymbol
	^ self inheritedValueAndSourceAt: aSymbol do: [:value :source | value]! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/2/2004 14:43'!
ancestors
	^ #()! !

!WAConfiguration methodsFor: 'testing' stamp: 'jf 2/1/2004 18:03'!
inheritsFrom: aConfiguration
	^ self allAncestors anySatisfy: [:ea | ea = aConfiguration]
	
	! !

!WAConfiguration methodsFor: 'attributes' stamp: 'jf 2/1/2004 17:34'!
attributes
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/23/2004 14:47'!
potentialAncestors
	^ self allPotentialAncestors reject: [:ea | ea = self or: [(self inheritsFrom: ea) or: [ea inheritsFrom: self]]]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 3/23/2004 14:53'!
hasMutableAncestry
	^ false! !

!WAConfiguration methodsFor: 'values' stamp: 'avi 3/23/2004 12:40'!
inheritedValueAndSourceAt: aSymbol do: aBlock
	self allAncestorsDo:
		[:ea |
		(ea localValueAt: aSymbol ifAbsent: [])
			ifNotNilDo: [:val | ^ aBlock value: val value: ea]].
	^ nil! !

!WAConfiguration class methodsFor: 'as yet unclassified' stamp: 'jf 2/9/2004 19:46'!
readUserConfigurationsFrom: aStream
	| ini |
	ini _ INIFile readFrom: aStream.
	self registeredConfigurationsDo:
		[:config |
		(ini includesSection: config name) ifTrue:
			[config clear.
			(ini section: config name) associationsDo:
				[:assoc | assoc value ifNotNil:
					[(config hasAttributeNamed: assoc key)
						ifTrue: [config valueAt: assoc key put: assoc value]]]]]! !

!WAConfiguration methodsFor: 'initializing' stamp: 'avi 2/2/2004 14:34'!
initialize
	! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 17:16'!
allAncestorsDo: aBlock
	self allAncestors do: aBlock! !

WAConfiguration subclass: #WASystemConfiguration
	instanceVariableNames: 'local'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WASystemConfiguration class
	instanceVariableNames: 'instance'!

WASystemConfiguration subclass: #WARenderLoopConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:09'!
rootComponents
	^ (WAComponent allSubclasses select: [:ea | ea canBeRoot]) asSortedCollection: [:a :b | a name <= b name]! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 19:09'!
attributes
	^ Array
		with: ((WAListAttribute key: #rootComponent) options: self rootComponents)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:31'!
ancestors
	^ Array with: (WASessionConfiguration localConfiguration)! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:24'!
mainClass
	^ WARenderLoopMain! !

!WARenderLoopConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 17:02'!
errorHandler
	^ WAWalkbackErrorHandler! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/3/2004 23:00'!
localValueAt: aSymbol ifAbsent: absentBlock
	^ (self respondsTo: aSymbol)
		ifTrue: [self perform: aSymbol]
		ifFalse: [absentBlock value]! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:54'!
name
	^ self localConfigurationName, ' defaults'! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:53'!
localConfiguration
	^ self instance localConfiguration! !

!WASystemConfiguration class methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:58'!
instance
	^ instance ifNil: [instance _ self new]! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 14:01'!
attributes
	self subclassResponsibility ! !

WASystemConfiguration subclass: #WAGlobalConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverPort
	^ 80! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 18:20'!
attributes
	^ Array 
		with: ((WAListAttribute key: #serverProtocol) options: #(http https))
		with: (WAStringAttribute key: #serverHostname)
		with: (WANumberAttribute key: #serverPort)
		with: (WABooleanAttribute key: #deploymentMode)! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:00'!
serverProtocol
	^ #http! !

!WAGlobalConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/6/2004 18:20'!
deploymentMode
	^ false! !

WASystemConfiguration subclass: #WASessionConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:31'!
ancestors
	^ Array with: WAGlobalConfiguration localConfiguration! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionClass
	^ WASession! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 20:10'!
errorHandler
	^ WASimpleErrorHandler! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
alwaysRedirect
	^ true! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/7/2004 13:59'!
errorHandlerClasses
	^ WAErrorHandler allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:20'!
mainClasses
	^ WAMain allSubclasses! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:05'!
sessionExpirySeconds
	^ 600! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 12:43'!
attributes
	^ Array
		with: (WABooleanAttribute key: #alwaysRedirect)
		with: (WANumberAttribute key: #sessionExpirySeconds)
		with: ((WAListAttribute key: #sessionClass) options: self sessionClasses)
		with: ((WAListAttribute key: #mainClass) options: self mainClasses)
		with: ((WAListAttribute key: #errorHandler) options: self errorHandlerClasses)! !

!WASessionConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 2/2/2004 15:04'!
sessionClasses
	^ WASession withAllSubclasses! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 11:54'!
localConfigurationName
	^ self class name! !

WASystemConfiguration subclass: #WAAuthConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:08'!
ancestors
	^ Array with: (WARenderLoopConfiguration localConfiguration)! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:07'!
mainClass
	^ WAAuthMain! !

!WAAuthConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:12'!
attributes
	^ Array
		with: (WAStringAttribute key: #login group: #authentication)
		with: (WAStringAttribute key: #password group: #authentication)
		
! !

!WASystemConfiguration methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:03'!
localConfiguration
	^ local ifNil: [local _ WALocalConfiguration parent: self]! !

!WAConfiguration methodsFor: 'accessing' stamp: 'avi 3/24/2004 11:55'!
name
	^ self subclassResponsibility! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:28'!
withAllAncestorsDo: aBlock
	aBlock value: self.
	^ self allAncestorsDo: aBlock! !

!WAConfiguration methodsFor: 'attributes' stamp: 'avi 2/5/2004 13:21'!
groupedAttributes
	| dict sorted |
	dict _ Dictionary new.
	sorted _ SortedCollection sortBlock: [:a :b | a key <= b key].
	self allAttributes do:
		[:ea |
		(dict at: ea group ifAbsentPut: [SortedCollection sortBlock: [:a :b | a key <= b key]])
			add: ea].
	dict associationsDo:
		[:assoc |
		sorted add: assoc].
	^ sorted
		! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 1/30/2004 16:21'!
hasAttributeNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea key = aSymbol]! !

!WAConfiguration methodsFor: 'testing' stamp: 'avi 2/3/2004 22:59'!
hasLocalValueForAttribute: anAttribute
	self localValueAt: anAttribute key ifAbsent: [^ false].
	^ true! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 3/24/2004 11:59'!
allPotentialAncestors
	^ #()! !

!WAConfiguration methodsFor: 'ancestry' stamp: 'avi 2/5/2004 16:27'!
addAncestorsTo: tempCollection linearization: linearCollection
	(linearCollection includes: self)
		ifTrue: [tempCollection do: [:ea | linearCollection add: ea before: self].
				tempCollection removeAllSuchThat: [:ea | true]]
		ifFalse: [tempCollection add: self.
				self ancestors isEmpty
					ifTrue: [linearCollection addAll: tempCollection.
							tempCollection removeAllSuchThat: [:ea | true]]
					ifFalse: [self ancestors do: [:ea | ea addAncestorsTo: tempCollection linearization: linearCollection]]]! !

Object subclass: #Amb
	instanceVariableNames: 'failureContinuation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:12'!
deny: aBoolean
	self assert: aBoolean not! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:15'!
fail
	^ failureContinuation value: nil! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo or: blockThree
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo with: blockThree)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:29'!
maybe
	^ self oneOf: (Array with: true with: false)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 5/29/2003 22:30'!
valueOf: blockOne or: blockTwo
	^ self valueOfOneOf: (Array with: blockOne with: blockTwo)! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
allValues: aBlock
	|kPrev results|
	kPrev _ failureContinuation.
	results _ OrderedCollection new.
	(Continuation currentDo:
		[:kRetry |
		failureContinuation _ [:v | kRetry value: false].
		results add: aBlock value.
		kRetry value: true])
			ifTrue: [self fail].
	failureContinuation _ kPrev.
	^ results asArray	 ! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:09'!
oneOf: aCollection
	^ self valueOfOneOf: (aCollection collect: [:ea | [ea] fixTemps])! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
valueOfOneOf: blockCollection
	|kPrev|
	kPrev _ failureContinuation.
	^ Continuation currentDo:
		[:kEntry |
		blockCollection do:
			[:ea |
			Continuation currentDo:
				[:kNext |
				failureContinuation _
					[:v | failureContinuation _ kPrev. kNext value: v] fixTemps.
				kEntry value: ea value]].
		kPrev value: nil]
			 ! !

!Amb class methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 01:59'!
new
	^ super new initialize! !

!Amb methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:11'!
assert: aBoolean
	aBoolean ifFalse: [self fail]! !

!Amb methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:28'!
initialize
	failureContinuation _ [:v | self error: 'Amb tree exhausted'].! !

Object subclass: #WACookie
	instanceVariableNames: 'key value path expiry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
key: aString
	key _ aString! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:53'!
expiry
	^ expiry! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
value: aString
	value _ aString! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:05'!
valueWithExpiry
	^ expiry
		ifNil: [self value]
		ifNotNil: [self value, '; expires=', self expiryString]! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:53'!
path: aString
	path _ aString! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
key
	^ key! !

!WACookie class methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:59'!
key: keyString value: valueString
	^ self new
		key: keyString;
		value: valueString;
		yourself! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:13'!
expireIn: aDuration
	self expiry: DateAndTime now + aDuration! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 22:53'!
path
	^ path ifNil: ['/']! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:21'!
value
	^ value! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:15'!
expiryString
	^ String streamContents:
		[:s |
		s
			nextPutAll: (expiry dayOfWeekName first: 3);
			nextPutAll: ', ';
			nextPutAll: expiry dayOfMonth asString;
			nextPut: $-;
			nextPutAll: expiry monthName;
			nextPut: $-;
			nextPutAll: expiry year asString;
			space;
			nextPutAll: expiry hour24 asString;
			nextPut: $:;
			nextPutAll: expiry minute asString; 
			nextPut: $:;
			nextPutAll: expiry second asString;
			nextPutAll: ' GMT']! !

!WACookie methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 23:12'!
expiry: aDateTime
	expiry _ aDateTime asUTC! !

Object subclass: #WAConfigurationAttribute
	instanceVariableNames: 'key group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAConfigurationAttribute subclass: #WAListAttribute
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:25'!
valueFromString: aString
	^ self options
		detect: [:ea | ea asString = aString]
		ifNone: [self error: 'No matching list option']! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitListAttribute: self with: anObject! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
options: aCollection
	options _ aCollection! !

!WAListAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:12'!
options
	^ options! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
initializeWithKey: keySymbol group: groupSymbol
	key _ keySymbol.
	group _ groupSymbol! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:14'!
key: keySymbol group: groupSymbol
	^ self basicNew initializeWithKey: keySymbol group: groupSymbol! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:21'!
group
	^ group ifNil: [#general]! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:07'!
stringForValue: anObject
	^ anObject asString! !

!WAConfigurationAttribute class methodsFor: 'as yet unclassified' stamp: 'avi 2/5/2004 13:15'!
key: aSymbol
	^ self key: aSymbol group: nil! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:07'!
valueFromString: aString
	self subclassResponsibility ! !

WAConfigurationAttribute subclass: #WABooleanAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:11'!
accept: aVisitor with: anObject
	^ aVisitor visitBooleanAttribute: self with: anObject! !

!WABooleanAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:42'!
valueFromString: aString
	^ aString = 'true'
		ifTrue: [true]
		ifFalse: [aString = 'false'
				 ifTrue: [false]
				 ifFalse: [self error: 'Invalid value for boolean attribute']]
! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 16:40'!
key
	^ key! !

WAConfigurationAttribute subclass: #WANumberAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 12:13'!
accept: aVisitor with: anObject
	^ aVisitor visitNumberAttribute: self with: anObject! !

!WANumberAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:10'!
valueFromString: aString
	^ Number readFrom: aString! !

WAConfigurationAttribute subclass: #WAStringAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

WAStringAttribute subclass: #WAPasswordAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAPasswordAttribute methodsFor: 'as yet unclassified' stamp: 'avi 4/13/2004 21:02'!
accept: aVisitor with: anObject
	^ aVisitor visitPasswordAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	^ aVisitor visitStringAttribute: self with: anObject! !

!WAStringAttribute methodsFor: 'as yet unclassified' stamp: 'jf 2/8/2004 17:09'!
valueFromString: aString
	^ aString! !

!WAConfigurationAttribute methodsFor: 'as yet unclassified' stamp: 'avi 1/30/2004 17:12'!
accept: aVisitor with: anObject
	self subclassResponsibility ! !

Object subclass: #WALRUCache
	instanceVariableNames: 'table ageTable max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 00:37'!
at: key put: val
	|removals|
	table at: key put: val.
	ageTable at: val put: 0.
	removals _ OrderedCollection new.
	ageTable associationsDo:
		[:assoc |
		assoc value > max ifTrue: [removals add: assoc key].
		assoc value: assoc value + 1].
	removals do: [:ea | self remove: ea].
	! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
capacity: aNumber
	max _ aNumber! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:55'!
nextKey
	|key|
	[table includesKey: (key _ WAExternalID new asString)] whileTrue.
	^ key! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:23'!
store: anObject
	|key|
	key _ self nextKey.
	self at: key put: anObject.
	^ key! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'avi 1/31/2004 17:45'!
isEmpty
	^ table isEmpty! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
at: key
	^ self at: key ifAbsent: [self error: 'No entry for ', key]! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 7/10/2003 11:48'!
remove: anObject
	ageTable removeKey: anObject.
	table removeKey: (table keyAtValue: anObject)! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:28'!
at: key ifAbsent: errorBlock
	|val|
	val _ table at: key ifAbsent: [^ errorBlock value].
	ageTable at: val put: 0.
	^ val.! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 21:18'!
new
	^ super new initialize! !

!WALRUCache methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 19:07'!
initialize
	max _ 20.
	table _ Dictionary new.
	ageTable _ Dictionary new.! !

!WALRUCache class methodsFor: 'as yet unclassified' stamp: 'ab 7/15/2002 00:10'!
new: max
	^ self new capacity: max! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'associations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-HtmlBuilder'!

!WAHtmlAttributes methodsFor: 'private' stamp: 'jf 1/12/2004 16:37'!
associations
	^ associations ifNil: [associations _ OrderedCollection new]! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'ab 5/12/2003 22:08'!
alignCenter
	self at: 'align' put: 'center'! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'avi 2/7/2004 02:17'!
alignBottom
	self at: 'valign' put: 'bottom'! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 3/12/2004 17:25'!
submitOnChange
	self at: 'onChange' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'avi 5/22/2004 14:56'!
writeAttribute: assoc on: aStream
	assoc value = false ifFalse:
		[aStream nextPut: $ .
		aStream nextPutAll: assoc key asLowercase.
		aStream nextPutAll: '="'.
		assoc value = true
			ifFalse: [aStream nextPutAll: (WAAbstractHtmlBuilder encode: assoc value asString)]
			ifTrue: [aStream nextPutAll: assoc key asLowercase].
		aStream nextPut: $"]! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'avi 2/3/2004 20:05'!
writeOn: aStream
	associations ifNotNil:
		[associations do:
			[:assoc |
			self writeAttribute: assoc on: aStream]].! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 2/7/2004 02:18'!
submitOnClick
	self at: 'onClick' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:42'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast put: aMessage argument].
	^ super doesNotUnderstand: aMessage! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'jf 1/12/2004 16:38'!
at: keyString put: valueString
	self associations add: keyString -> valueString.! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'jf 1/12/2004 16:40'!
at: keyString ifAbsentPut: valueString
	^ self associations
		detect: [:ea | ea key = keyString]
		ifNone: [self associations add: keyString -> valueString. valueString]! !

Object subclass: #WAPluggableSelectBox
	instanceVariableNames: 'changeSelected model selected size list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Tools'!

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:25'!
size: aNumber
	size _ aNumber! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:27'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector size: aNumber
	^ self new
		model: anObject;
		list: listSelector;
		selected: selectedSelector;
		changeSelected: changeSelectedSelector;
		size: aNumber! !

!WAPluggableSelectBox class methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:28'!
on: anObject list: listSelector selected: selectedSelector changeSelected: changeSelectedSelector
	^ self 
		on: anObject
		list: listSelector
		selected: selectedSelector
		changeSelected: changeSelectedSelector
		size: 10! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/15/2003 18:24'!
model: anObject
	model _ anObject! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 2/16/2003 00:34'!
renderOn: html
	|array|
	array _ (model perform: list) asArray.
	html divClass: 'column-choice' with:	
		[html form:
			[html attributeAt: 'size' put: size.
			html attributeAt: 'onChange' put: 'submit()'.
			html
				selectFromList: array
				selected: (array at: (model perform: selected) ifAbsent: [])
				callback: [:item | model perform: changeSelected with: (array indexOf: item)]]].	! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
changeSelected: aSymbol
	changeSelected _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
list: aSymbol
	list _ aSymbol! !

!WAPluggableSelectBox methodsFor: 'as yet unclassified' stamp: 'ab 10/1/2002 14:16'!
selected: aSymbol
	selected _ aSymbol! !

Object subclass: #WARequest
	instanceVariableNames: 'url fields headers cookies method nativeRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey
	^ self headerAt: aKey ifAbsent: []! !

!WARequest methodsFor: 'accessing' stamp: 'ab 8/26/2003 19:33'!
method
	^ method! !

!WARequest methodsFor: 'accessing' stamp: 'ab 11/12/2002 00:04'!
cookies
	^ cookies! !

!WARequest methodsFor: 'private' stamp: 'avi 3/19/2004 13:52'!
setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	method _ methodString.
	url _ urlString.
	headers _ headDict.
	fields _ fieldDict.
	cookies _ cookieDict! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
user
	^ self authorization ifNotNilDo: [:auth | auth copyUpTo: $:]! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest: aRequest
	nativeRequest _ aRequest! !

!WARequest methodsFor: 'accessing' stamp: 'avi 4/28/2004 13:43'!
nativeRequest
	^ nativeRequest! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 13:37'!
at: key
	^ fields at: key! !

!WARequest methodsFor: 'accessing' stamp: 'ab 12/30/2002 17:42'!
password
	^ self authorization ifNotNilDo: [:auth | auth copyAfter: $:]! !

!WARequest methodsFor: 'private' stamp: 'ab 1/13/2003 22:40'!
authorization
	^ (self headerAt: 'Authorization' ifAbsent: [self headerAt: 'authorization'])
		ifNotNilDo: [:auth | self decodeAuthorization: auth]! !

!WARequest methodsFor: 'accessing' stamp: 'ab 5/26/2003 00:54'!
url
	^ url! !

!WARequest methodsFor: 'testing' stamp: 'avi 3/22/2004 12:58'!
isGet
	^ self method asUppercase = 'GET'! !

!WARequest methodsFor: 'accessing' stamp: 'ab 7/3/2002 12:51'!
fields
	^ fields! !

!WARequest methodsFor: 'private' stamp: 'avi 9/21/2003 18:28'!
decodeAuthorization: aString
	^ SeasidePlatformSupport base64Decode: (aString findTokens: ' ') last! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:16'!
headers
	^ headers! !

!WARequest methodsFor: 'accessing' stamp: 'JF 11/18/2002 16:18'!
headerAt: aKey ifAbsent: aBlock
	^ headers at: aKey ifAbsent: aBlock! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 19:34'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict
	^ self new setMethod: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict! !

!WARequest methodsFor: 'accessing' stamp: 'JF 5/16/2003 09:40'!
at: key ifAbsent: aBlock
	^ fields at: key ifAbsent: aBlock! !

!WARequest class methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 10:57'!
method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict nativeRequest: anObject
	^ (self method: methodString url: urlString headers: headDict fields: fieldDict cookies: cookieDict)
		nativeRequest: anObject;
		yourself! !

Object subclass: #WARequestHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

WARequestHandler subclass: #WADocumentHandler
	instanceVariableNames: 'document mimeDocument mimeType fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:43'!
isActive
	^ true! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 4/14/2004 23:52'!
initializeWithDocument: anObject mimeType: mimeString fileName: fileString
	document _ anObject.
	mimeType _ mimeString.
	fileName _ fileString.! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:16'!
response
	| response |
	response _ WAResponse new.
	response contents: self mimeDocument contentStream text.
	response contentType: (mimeType ifNil: [self mimeDocument contentType]).
	response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT'.
	fileName ifNotNil: 
		[response headerAt: 'Content-Disposition' put: 'attachment; filename=' , fileName].
	^ response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 2/12/2003 13:41'!
document
	^ document! !

!WADocumentHandler class methodsFor: 'as yet unclassified' stamp: 'avi 11/3/2003 12:23'!
document: anObject mimeType: mimeString fileName: fileString
	^ self basicNew initializeWithDocument: anObject mimeType: mimeString fileName: fileString! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'avi 4/14/2004 23:51'!
mimeDocument
	^ mimeDocument ifNil: [mimeDocument _ document asMIMEDocument ]! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:43'!
handleRequest: aRequest
	^ self response! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/24/2003 18:48'!
mimeType
	^ mimeType! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:42'!
hash
	^ self document hash bitXor: self mimeType hash! !

!WADocumentHandler methodsFor: 'as yet unclassified' stamp: 'ab 8/17/2003 12:41'!
= other
	^ (other species = self species
		and: [other document = self document])
		and: [other mimeType = self mimeType]! !

!WARequestHandler methodsFor: 'as yet unclassified' stamp: 'ab 5/18/2003 12:33'!
handleRequest: aRequest
	self subclassResponsibility! !

WARequestHandler subclass: #WANotFoundHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WANotFoundHandler methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:16'!
handleRequest: aRequest
	^ WAResponse notFound: aRequest url! !

WARequestHandler subclass: #WAEntryPoint
	instanceVariableNames: 'basePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath: aString
	basePath _ aString! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:08'!
basePath
	^ basePath! !

!WAEntryPoint methodsFor: 'printing' stamp: 'JF 9/22/2003 20:06'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', self basePath, ')'! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
isAbstract
	^ self description isNil! !

WAEntryPoint subclass: #WADispatcher
	instanceVariableNames: 'entryPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

WADispatcher class
	instanceVariableNames: 'default'!

!WADispatcher methodsFor: 'public' stamp: 'ab 7/10/2003 11:48'!
removeEntryPoint: anObject
	entryPoints removeKey: (entryPoints keyAtValue: anObject)! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'JF 9/15/2003 14:40'!
default
	default ifNil: [default _ self new].
	default basePath ifNil: [default basePath: '/seaside'].
	
	^ default! !

!WADispatcher methodsFor: 'public' stamp: 'ab 5/26/2003 00:10'!
handleRequest: aRequest
	^ (self handlerForRequest: aRequest) handleRequest: aRequest! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Subdirectory'! !

!WADispatcher methodsFor: 'private' stamp: 'ab 8/26/2003 21:55'!
handlerForRequest: aRequest
	| path name |
	path _ aRequest url.
	(path beginsWith: basePath)
		ifTrue: [name _ ((path allButFirst: basePath size) findTokens: '/') at: 1 ifAbsent: [].
				entryPoints at: name ifPresent: [:n | ^ n]].
	^ WANotFoundHandler new! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:53'!
configurationComponent
	^ WADispatcherEditor new dispatcher: self! !

!WADispatcher class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:09'!
new
	^ super new initialize! !

!WADispatcher methodsFor: 'private' stamp: 'ab 8/26/2003 21:08'!
initialize
	entryPoints _ Dictionary new! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:11'!
registerEntryPoint: entryPoint at: aString
	entryPoints at: aString put: entryPoint.
	entryPoint basePath: basePath, '/', aString.! !

!WADispatcher methodsFor: 'public' stamp: 'ab 8/26/2003 21:35'!
entryPoints
	^ entryPoints! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:14'!
description
	^ nil! !

WAEntryPoint subclass: #WARegistry
	instanceVariableNames: 'keysByHandler handlersByKey mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:59'!
registerRequestHandler: anObject
	|key|
	key _ WAExternalID new: 16.
	self shouldCollectHandlers ifTrue: [self unregisterExpiredHandlers].
	self mutex critical:
		[handlersByKey at: key put: anObject.
		keysByHandler at: anObject put: key].
	^ key! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
shouldCollectHandlers
	^ 10 atRandom = 1! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/6/2004 13:17'!
unregisterExpiredHandlers
	"This method is a little ugly, but using #associationsDo: to build a new
	dictionary is 200 times faster than iterating over them with #removeKey:
	or even using #keysAndValuesRemove:"

	| expired newHandlersByKey newKeysByHandler |
	self mutex critical:
		[expired _ OrderedCollection new.
		newHandlersByKey _ Dictionary new.
		handlersByKey associationsDo:
			[:assoc |
			assoc value isActive
				ifTrue: [newHandlersByKey add: assoc]
				ifFalse: [expired add: assoc value]].
		newKeysByHandler _ Dictionary new.
		keysByHandler associationsDo: [:assoc | assoc key isActive ifTrue: [newKeysByHandler add: assoc]].
		handlersByKey _ newHandlersByKey.
		keysByHandler _ newKeysByHandler].
	
	"Send #unregistered to each in expired"! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
expiredHandlerForRequest: aRequest
	^ self createHandlerForRequest: aRequest! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:26'!
initialize
	self clearHandlers.! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
isSeasideField: aString
	^ aString first  = $_! !

!WARegistry methodsFor: 'private' stamp: 'ab 5/18/2003 12:29'!
handleDefaultRequest: aRequest
	self subclassResponsibility! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 19:06'!
keyOrNilForHandler: anObject
	^ self mutex critical: [keysByHandler at: anObject ifAbsent: [nil]]! !

!WARegistry methodsFor: 'private' stamp: 'avi 5/18/2004 16:16'!
handleExpiredRequest: aRequest
	| url |
	url _ WAUrl new.
	url addToPath: aRequest url.
	aRequest isGet ifTrue:
		[aRequest fields keysAndValuesDo:
			[:k :v |
			(self isSeasideField: k) ifFalse: [url addParameter: k value: v]]]. 
	
	^ WAResponse
		refreshWithMessage: 'That page has expired.'
		location: url asString
		delay: 3! !

!WARegistry methodsFor: 'public' stamp: 'avi 3/22/2004 21:48'!
urlForRequestHandler: anObject
	|key url |
	key _ (self keyOrNilForHandler: anObject) ifNil: [self registerRequestHandler: anObject].
	url _ self baseUrl.
	url addParameter: self handlerField value: key asString.
	^ url! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:48'!
mutex
	^ mutex ifNil: [mutex _ Semaphore forMutualExclusion]! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'JF 9/22/2003 20:15'!
clearAllHandlers
	self allSubInstances do: [:ea | ea clearHandlers]! !

WARegistry subclass: #WAApplication
	instanceVariableNames: 'configuration sessionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol
	^ self configuration valueAt: aSymbol! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 4/13/2004 20:24'!
defaultAncestor
	"yes, breaking layering"
	^ WARenderLoopConfiguration localConfiguration! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
path: pathString
	^ self new basePath: pathString! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 8/26/2003 21:34'!
configurationComponent
	^ WAApplicationEditor new application: self! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 1/31/2004 12:34'!
preferenceAt: aSymbol put: anObject
	^ self configuration valueAt: aSymbol put: anObject! !

!WAApplication methodsFor: 'accessing' stamp: 'ab 5/26/2003 01:22'!
name
	^ (basePath findTokens: '/') last! !

!WAApplication methodsFor: 'accessing' stamp: 'avi 3/22/2004 00:48'!
baseUrl
	^ super baseUrl
		port: (self preferenceAt: #serverPort);
		hostname: (self preferenceAt: #serverHostname);
		scheme: (self preferenceAt: #serverProtocol);
		yourself! !

!WAApplication class methodsFor: 'as yet unclassified' stamp: 'ab 8/27/2003 00:47'!
description
	^ 'Seaside Application'! !

!WAApplication methodsFor: 'basic configuration' stamp: 'avi 1/31/2004 18:19'!
sessionClass
	^ configuration valueAt: #sessionClass! !

!WAApplication methodsFor: 'request handling' stamp: 'avi 3/22/2004 13:06'!
handleDefaultRequest: aRequest
	|session|
	session _ self sessionClass application: self.
	^ session handleRequest: aRequest! !

!WAApplication methodsFor: 'preferences' stamp: 'avi 2/2/2004 15:17'!
configuration
	^ configuration ifNil: [configuration _ WAUserConfiguration new addAncestor: self defaultAncestor]! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/22/2004 13:04'!
handlerField
	^ '_s'! !

!WARegistry methodsFor: 'private' stamp: 'jf 3/4/2004 14:58'!
clearHandlers
	self mutex critical:
		[handlersByKey _ Dictionary new.
		keysByHandler _ Dictionary new].! !

!WARegistry methodsFor: 'public' stamp: 'avi 3/19/2004 13:52'!
handleRequest: aRequest
	^ (aRequest fields includesKey: self handlerField)
		ifTrue: [self handleKeyRequest: aRequest]
		ifFalse: [self handleDefaultRequest: aRequest]
! !

!WARegistry methodsFor: 'private' stamp: 'avi 3/19/2004 13:51'!
handleKeyRequest: aRequest
	|key handler|
	key _ [WAExternalID fromString: (aRequest at: self handlerField)] on: Error do: [nil].
	handler _ handlersByKey at: key ifAbsent: [nil].
	^ (handler notNil and: [handler isActive])
		ifTrue: [handler handleRequest: aRequest]
		ifFalse: [self handleExpiredRequest: aRequest]! !

!WARegistry class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:45'!
new
	^ super new initialize! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'avi 3/22/2004 00:48'!
baseUrl
	^ WAUrl new
		addToPath: basePath;
		yourself! !

!WAEntryPoint methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:48'!
configurationComponent
	^ nil! !

!WAEntryPoint class methodsFor: 'as yet unclassified' stamp: 'ab 8/26/2003 21:51'!
concreteSubclasses
	^ self allSubclasses reject: [:ea | ea isAbstract]! !

WARequestHandler subclass: #WAExpiringHandler
	instanceVariableNames: 'lastAccess expired timeout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Base'!

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:08'!
incomingRequest: aRequest
	self subclassResponsibility ! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
isActive
	^ self expired not and: [self secondsSinceLastAccess < self timeoutSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds
	^ timeout ifNil: [self defaultTimeoutSeconds]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
defaultTimeoutSeconds
	^ 600! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
expire
	expired _ true! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:19'!
lastAccess
	^ lastAccess ifNil: [lastAccess _ Time totalSeconds]! !

WAExpiringHandler subclass: #WASession
	instanceVariableNames: 'continuations application escapeContinuation monitor state currentRequest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

!WASession methodsFor: 'responding' stamp: 'avi 3/26/2004 14:25'!
respond: responseBlock
	|request snapshotHolder response |
	snapshotHolder _ ValueHolder new.
	request _ 
	Continuation currentDo:
		[:cc ||url|
		url _ self actionUrlForContinuation: cc.
		response _ responseBlock value: url.
		snapshotHolder contents: state snapshot.
		self returnResponse: response].
	state restoreSnapshot: snapshotHolder contents.
	^ request ! !

!WASession class methodsFor: 'as yet unclassified' stamp: 'ab 5/26/2003 01:53'!
application: anApplication
	^ self new initializeWithApplication: anApplication! !

!WASession methodsFor: 'state' stamp: 'ab 2/18/2003 18:51'!
registerObjectForBacktracking: anObject
	state registerObject: anObject! !

!WASession methodsFor: 'printing' stamp: 'avi 3/22/2004 00:49'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: '(', (application urlForRequestHandler: self) asString, ')'! !

!WASession methodsFor: 'cookies' stamp: 'avi 5/18/2004 23:15'!
checkForCookies
	| check |
	check _ WAExternalID new asString.
	self redirectWithCookie: 
		(WACookie new
			key: check;
			value: 'yes';
			expireIn: (Duration seconds: 2);
			yourself).
	^ currentRequest cookies includesKey: check! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 01:54'!
withEscapeContinuation: aBlock
	^ Continuation currentDo:
			[:cc |
			escapeContinuation := cc.
			aBlock value.
			self pageIntentionallyLeftBlank]! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/31/2004 17:45'!
unknownRequest: aRequest
	self pageExpired! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
redirectTo: urlString
	self returnResponse: (WAResponse redirectTo: urlString)! !

!WASession methodsFor: 'request handling' stamp: 'avi 1/23/2004 14:21'!
incomingRequest: aRequest
	^ monitor critical: [self responseForRequest: aRequest]! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/28/2004 11:46'!
responseForRequest: aRequest
	currentRequest _ aRequest.
	^ self withEscapeContinuation:
		[WACurrentSession use: self during: [self withErrorHandler: [self performRequest: aRequest]]]! !

!WASession methodsFor: 'request handling' stamp: 'cwp 3/26/2004 23:23'!
performRequest: aRequest
	| key continuation |
	key _ aRequest fields at: self actionField ifAbsent: [^ self start: aRequest].
	continuation _ continuations at: key ifAbsent: [^ self unknownRequest: aRequest].
	continuation value: aRequest
! !

!WASession methodsFor: 'accessing' stamp: 'avi 2/5/2004 12:21'!
mainClass
	^ application preferenceAt: #mainClass! !

!WASession methodsFor: 'responding' stamp: 'avi 3/22/2004 00:49'!
actionUrlForKey: aString
	^ (application urlForRequestHandler: self)
		addParameter: self actionField value: aString;
		yourself! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/13/2004 21:47'!
currentRequest
	^ currentRequest! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/13/2004 20:30'!
start: aRequest
	self mainClass new start: aRequest! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
redirect
	^ self respond: [:url | WAResponse redirectTo: url asString]! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
closePopup
	^ self respond:
		[:url |
		WAResponse new
			nextPutAll: '<html><script>';
			nextPutAll: 'self.close();';
			nextPutAll: 'self.opener.location=',url asString printString;
			nextPutAll:'</script></html>';
			yourself]! !

!WASession methodsFor: 'request handling' stamp: 'avi 3/22/2004 13:04'!
actionField
	^ '_k'! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
redirectWithMessage: aString delay: aNumber
	self respond:
		[:url |
		WAResponse
			refreshWithMessage: aString
			location: url asString
			delay: aNumber].
! !

!WASession methodsFor: 'initializing' stamp: 'avi 4/13/2004 20:29'!
initializeWithApplication: anApplication
	application _ anApplication.
	continuations _ WALRUCache new.
	monitor _ WAProcessMonitor new.
	state _ WAStateRegistry new.
	self initialize.! !

!WASession methodsFor: 'request handling' stamp: 'avi 2/2/2004 16:52'!
errorHandler
	^ application preferenceAt: #errorHandler! !

!WASession methodsFor: 'cookies' stamp: 'avi 5/18/2004 22:57'!
redirectWithCookie: aCookie
	self redirectWithCookies: (Array with: aCookie)! !

!WASession methodsFor: 'initializing' stamp: 'ab 5/26/2003 01:53'!
initialize! !

!WASession methodsFor: 'expiring' stamp: 'avi 4/27/2004 14:25'!
pageExpired
	state restoreLastSnapshot.
	self redirectWithMessage: 'That page has expired.' delay: 3.
	WAPageExpired raiseSignal! !

!WASession methodsFor: 'responding' stamp: 'avi 3/13/2004 01:21'!
script: aString
	self redirectWithMessage: '<script>', aString, '</script>' delay: 0! !

!WASession methodsFor: 'request handling' stamp: 'avi 4/27/2004 14:25'!
withErrorHandler: aBlock
	^ [aBlock
		on: Error
		do: [:e | self errorHandler handleError: e. WAPageExpired raiseSignal]]
		on: Warning
		do: [:w | self errorHandler handleWarning: w. WAPageExpired raiseSignal]! !

!WASession methodsFor: 'cookies' stamp: 'avi 5/18/2004 22:57'!
redirectWithCookies: aCollection
	| response |
	self respond:
		[:url |
		response _ WAResponse redirectTo: url asString.
		aCollection do: [:ea | response addCookie: ea].
		response]! !

!WASession methodsFor: 'responding' stamp: 'avi 2/3/2004 00:43'!
actionUrlForContinuation: aContinuation
	^ self actionUrlForKey: (continuations store: aContinuation)! !

!WASession methodsFor: 'responding' stamp: 'avi 5/18/2004 16:16'!
pageIntentionallyLeftBlank
	self returnResponse: WAResponse new! !

!WASession methodsFor: 'responding' stamp: 'ab 6/15/2003 19:25'!
returnResponse: aResponse
	escapeContinuation value: aResponse! !

!WASession methodsFor: 'accessing' stamp: 'ab 3/20/2003 11:43'!
application
	^ application! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:18'!
expired
	^ expired ifNil: [false]! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:19'!
secondsSinceLastAccess
	^ Time totalSeconds - self lastAccess! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 14:08'!
handleRequest: aRequest
	lastAccess _ Time totalSeconds.
	^ self incomingRequest: aRequest! !

!WAExpiringHandler methodsFor: 'as yet unclassified' stamp: 'avi 1/23/2004 12:20'!
timeoutSeconds: aNumber
	timeout _ aNumber! !

Object subclass: #Continuation
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!Continuation methodsFor: 'private' stamp: 'avi 4/24/2004 12:39'!
initializeFromContext: aContext
	| valueStream context |
	valueStream _ WriteStream on: (Array new: 20).
	context _ aContext.
	[context notNil] whileTrue:
		[valueStream nextPut: context.
		1 to: context class instSize do: [:i | valueStream nextPut: (context instVarAt: i)].
		1 to: context localSize do: [:i | valueStream nextPut: (context localAt: i)].
		context _ context sender].
	values _ valueStream contents! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:13'!
value
	self value: nil! !

!Continuation methodsFor: 'private' stamp: 'ab 6/15/2003 19:13'!
terminate: aContext
	| context |
	context _ aContext.
	[context notNil] whileTrue: [context _ context swapSender: nil]
! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:12'!
value: v
	self terminate: thisContext.
	self restoreValues.
	thisContext swapSender: values first.
	^v! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:22'!
valueWithArguments: v
	v size == 1 ifFalse: [^self error: 'continuations can only be resumed with one argument'].
	self value: v first! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
fromContext: aStack
	^self new initializeFromContext: aStack! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
current
	^ self fromContext: thisContext sender! !

!Continuation class methodsFor: 'instance creation' stamp: 'ab 6/15/2003 19:13'!
currentDo: aBlock
	^ aBlock value: (self fromContext: thisContext sender)! !

!Continuation methodsFor: 'invocation' stamp: 'ab 6/15/2003 19:18'!
numArgs
	^ 1! !

!Continuation methodsFor: 'as yet unclassified' stamp: 'avi 4/24/2004 12:39'!
restoreValues
	| valueStream context |
	valueStream _ values readStream.
	[valueStream atEnd] whileFalse:
		[context _ valueStream next.
		1 to: context class instSize do: [:i | context instVarAt: i put: valueStream next].
		1 to: context localSize do: [:i | context localAt: i put: valueStream next]]! !

Object subclass: #WAProcessMonitor
	instanceVariableNames: 'timeout responseSem mutex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:54'!
timeoutSeconds: aNumber
	timeout _ aNumber! !

!WAProcessMonitor class methodsFor: 'as yet unclassified' stamp: 'ab 9/26/2002 19:53'!
new
	^ super new initialize! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'ab 5/6/2003 14:50'!
timeout
	^ timeout! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 16:16'!
critical: aBlock
	|value|
	mutex critical:
		[responseSem _ Semaphore new.
		[[value _ aBlock
			on: Error do: [:e | WAResponse internalError: e]]
				ensure: [responseSem signal]] fork.
		responseSem wait].
	^ value! !

!WAProcessMonitor methodsFor: 'as yet unclassified' stamp: 'jf 3/4/2004 00:49'!
initialize
	timeout _ 5.
	mutex _ Semaphore forMutualExclusion.! !

!Date class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:29'!
newDay: dayNumber monthNumber: monthNumber year: yearNumber
	^ self newDay: dayNumber month: monthNumber year: yearNumber! !

!Color methodsFor: '*seaside2' stamp: 'avi 4/29/2004 13:06'!
asHTMLColor
	^ '#', self hex! !

!Exception class methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:42'!
raiseSignal
	^ self signal! !

!Exception methodsFor: '*seaside2-squeak' stamp: 'ab 3/28/2003 17:36'!
reactivateHandler 
  handlerContext ifNotNil: [handlerContext tempAt: 3 put: true].
! !

TestCase subclass: #WAColorExtensionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Contrib'!

!WAColorExtensionTest commentStamp: 'TBn 4/28/2004 20:16' prior: 0!
This class tests extensions on the class Color!

!WAColorExtensionTest methodsFor: 'testing' stamp: 'TBn 4/28/2004 18:55'!
testAsHTMLString
	self 
		assert: Color white asHTMLColor = '#FFFFFF';
		assert: Color blue asHTMLColor = '#0000FF';
		assert: Color green asHTMLColor = '#00FF00';
		assert: Color red asHTMLColor = '#FF0000';
		assert: Color black asHTMLColor = '#000001';
		assert: (Color fromString: '10BACE') asHTMLColor = '#10BACE'! !

TestCase subclass: #WAWebTreeNodeTest
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Contrib'!

!WAWebTreeNodeTest commentStamp: '<historical>' prior: 0!
This is the SUnit test class for testing the web tree node!

!WAWebTreeNodeTest class methodsFor: 'test data' stamp: 'TBn 4/28/2004 17:39'!
webTree1
 
	^ OrderedCollection new
		add: (self simpleTreeFor: #('A' 'D' 'E' ));
		
		add: (self simpleTreeFor: #('B' 'F' 'G' ));
		
		add: (self nodeFor: 'Z');
		
		add: (self simpleTreeFor: #('C' 'H' 'I' ));
		 yourself! !

!WAWebTreeNodeTest methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:37'!
testInstanceCreationWithWrappedObject

	|object|
	object := 'Test'.
	instance := self defaultTestClass for: object.
	self 
		assert: (instance wrappedObject == object);
		assert: (instance isKindOf: self defaultTestClass);
		assert: instance isCollapsed;
		deny: instance isExpanded! !

!WAWebTreeNodeTest methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:37'!
testExpandingCollapsing

	self instance: self class treeNodeWithTwoSubnodes.
	
	self 
		assert: instance isCollapsed;
		deny: instance isExpanded.
	
	instance expand.

	self 
		deny: instance isCollapsed	;
		assert: instance isExpanded

	
! !

!WAWebTreeNodeTest class methodsFor: 'attributes' stamp: 'TBn 4/28/2004 19:46'!
defaultTestClass
	^ WAWebTreeNode! !

!WAWebTreeNodeTest methodsFor: 'accessing' stamp: 'TBn 4/28/2004 17:38'!
instance: aTestInstance

	instance := aTestInstance! !

!WAWebTreeNodeTest methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:37'!
testAddingChildNodes

	self deny: instance hasSubnodes.
	
	instance addChild: self createNewWebTreeNode.

	self assert: instance hasSubnodes
! !

!WAWebTreeNodeTest methodsFor: 'running' stamp: 'TBn 4/28/2004 17:36'!
setUp
	super setUp.
	self instance: self createNewWebTreeNode.! !

!WAWebTreeNodeTest class methodsFor: 'private' stamp: 'TBn 4/28/2004 19:47'!
nodeFor: anObject 
	^ self defaultTestClass for: anObject! !

!WAWebTreeNodeTest class methodsFor: 'test data' stamp: 'TBn 4/28/2004 17:40'!
webTree3
 
	
	^OrderedCollection 
		with: (self simpleTreeFor: #('A' 'D' 'E')) 		 
	 

	
	
	! !

!WAWebTreeNodeTest class methodsFor: 'test data' stamp: 'TBn 4/28/2004 17:40'!
webTree4
 
	|node|
	node := self simpleTreeFor: #('B' 'F' 'G').	
	node addChild: (self simpleTreeFor: #('J' 'K' 'L')).
	^OrderedCollection new
		add: (self simpleTreeFor: #('A' 'D' 'E'));
		add: node;
		add: (self nodeFor: 'Z');
		add: (self simpleTreeFor: #('C' 'H' 'I'));
		yourself


	
	! !

!WAWebTreeNodeTest class methodsFor: 'test data' stamp: 'TBn 4/28/2004 17:39'!
webTree2
 
	^OrderedCollection new
		add: (self simpleTreeFor: #('A' 'D' 'E'));
		add: (self simpleTreeFor: #('B' 'F' 'G'));		
		add: (self simpleTreeFor: #('C' 'H' 'I'));
		add: (self nodeFor: 'Z');
		yourself! !

!WAWebTreeNodeTest methodsFor: 'utilities' stamp: 'TBn 4/28/2004 17:36'!
createNewWebTreeNode

	^self defaultTestClass new! !

!WAWebTreeNodeTest class methodsFor: 'private' stamp: 'TBn 4/28/2004 17:40'!
simpleTreeFor: anArray

	^(self nodeFor: anArray first)
		addChild: (self nodeFor: anArray second);
		addChild: (self nodeFor: anArray last);
		yourself
	! !

!WAWebTreeNodeTest methodsFor: 'testing' stamp: 'TBn 4/28/2004 17:37'!
testDefaultInstanceCreation

	self 
		assert: instance isCollapsed;
		deny: instance isExpanded;
		deny: instance hasSubnodes! !

!WAWebTreeNodeTest class methodsFor: 'test data' stamp: 'TBn 4/28/2004 20:14'!
webTree5
 
	^ OrderedCollection with: self defaultTestClass
				smalltalkHierarchy! !

!WAWebTreeNodeTest methodsFor: 'attributes' stamp: 'TBn 4/28/2004 19:46'!
defaultTestClass
	^ self class defaultTestClass! !

!WAWebTreeNodeTest class methodsFor: 'test data' stamp: 'TBn 4/28/2004 17:38'!
treeNodeWithTwoSubnodes

	^self simpleTreeFor: #('A' 'D' 'E')
! !

TestCase subclass: #WAStateRegistryTest
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-StateRegistry'!

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
assertSnapshot: x isIdenticalTo: y
	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:23'!
testConsecutiveSnapshots
	|a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	snap2 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap2).
	a contents: 2.
	snap3 _ registry snapshot.
	self deny: (self snapshot: snap3 isIdenticalTo: snap2).
	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:16'!
setUp
	registry _ WAStateRegistry new! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:21'!
testGarbageCollection
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	Smalltalk garbageCollect.
	self assert: registry size = 1.
	a _ nil.
	Smalltalk garbageCollect.
	self assert: registry size = 0.! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:17'!
testRevert
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1	! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 18:22'!
testRevertTwice
	|a snap1|
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	self assert: a contents = 2.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	a contents: 3.
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:24'!
testNoChangeAfterRestore
	| a snap1 snap2 snap3 |
	a _ ValueHolder new contents: 1.
	registry registerObject: a.
	snap1 _ registry snapshot.
	a contents: 2.
	snap2 _ registry snapshot.
	self deny: (self snapshot: snap1 isIdenticalTo: snap2).
	registry restoreSnapshot: snap1.
	self assert: a contents = 1.
	snap3 _ registry snapshot.
	self assert: (self snapshot: snap1 isIdenticalTo: snap3).! !

!WAStateRegistryTest methodsFor: 'as yet unclassified' stamp: 'ab 2/18/2003 20:22'!
snapshot: x isIdenticalTo: y
	^ ((IdentitySet withAll: x values) includesAllOf: y values).! !

TestCase subclass: #WAConfigurationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Configuration'!

!WAConfigurationTest methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:43'!
testLinearization
	"from http://www.webcom.com/haahr/dylan/linearization-oopsla96.html"
	| root boat dayBoat wheelBoat engineLess pedalWheelBoat smallMultihull smallCatamaran pedalo |
	root _ WAUserConfiguration new.
	boat _ WAUserConfiguration new addAncestor: root.
	dayBoat _ WAUserConfiguration new addAncestor: boat.
	wheelBoat _ WAUserConfiguration new addAncestor: boat.
	engineLess _ WAUserConfiguration new addAncestor: dayBoat.
	pedalWheelBoat _ WAUserConfiguration new addAncestor: engineLess; addAncestor: wheelBoat.
	smallMultihull _ WAUserConfiguration new addAncestor: dayBoat.
	smallCatamaran _ WAUserConfiguration new addAncestor: smallMultihull.
	pedalo _ WAUserConfiguration new addAncestor: pedalWheelBoat; addAncestor: smallCatamaran.

	self assert: pedalWheelBoat allAncestors = (Array with: engineLess with: dayBoat with: wheelBoat with: boat with: root).
	self assert: smallCatamaran allAncestors = (Array with: smallMultihull with: dayBoat with: boat with: root).
	self assert: pedalo allAncestors = ((Array with: pedalWheelBoat with: engineLess with: smallCatamaran with: smallMultihull), (Array with: dayBoat with: wheelBoat with: boat with: root)).! !

TestCase subclass: #ContinuationTest
	instanceVariableNames: 'tmp tmp2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockEscape
	|x|
	tmp _ 0.
	x _ [tmp _ tmp + 1. tmp2 value].
	self callcc: [:cc | tmp2 _ cc. x value].
	tmp2 _ [].
	x value.
	self assert: tmp = 2.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockTemps
	|y|
	#(1 2 3) do:
		[:i ||x|
			x _ i.
			tmp ifNil: [tmp2 _ (self callcc: [:cc | tmp _ cc. [:q]])].
			tmp2 value: x.
			x _ 17].
	y _ (self callcc: [:cc | tmp value: cc. 42]).
	self assert: y = 1.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testBlockVars
	|continuation|
	tmp _ 0.
	tmp _ (self callcc: [:cc | continuation _ cc. 0]) + tmp.
	tmp2 
		ifNotNil: [tmp2 value]
		ifNil:
			[#(1 2 3) do:
				[:i |
				self callcc: [:cc | tmp2 _ cc. continuation value: i]]].
	self assert: tmp = 6.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testMethodTemps
	|i continuation|
	i _ 0.
	i _ i + (self callcc: [:cc | continuation _ cc. 1]).
	self assert: i ~= 3.
	i = 2 ifFalse: [continuation value: 2].! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 2/14/2003 01:17'!
testComprehension
	"What should this print out?
	
	|yin yang|
	yin := [:x | Transcript cr. x] value: Continuation current.
	yang := [:x | Transcript nextPut: $*. x] value: Continuation current.
	yin value: yang."! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:27'!
testSimplestCallCC
	|x|
	x _ self callcc: [:cc | cc value: true].
	self assert: x.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 17:26'!
testSimpleCallCC
	|x continuation|
	x _ self callcc: [:cc | continuation _ cc. false].
	x ifFalse: [continuation value: true].
	self assert: x.! !

!ContinuationTest methodsFor: 'as yet unclassified' stamp: 'ab 6/15/2003 19:23'!
callcc: aBlock
	^ Continuation currentDo: aBlock! !

TestCase subclass: #AmbTest
	instanceVariableNames: 'amb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Continuations'!

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/13/2002 01:15'!
setUp
	amb _ Amb new! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblemFaster
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"
	
	|baker cooper fletcher miller smith|
	fletcher _ amb oneOf: (1 to: 5).
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.

	smith _ amb oneOf: (1 to: 5).
	amb deny: (smith - fletcher) abs = 1.

	cooper _ amb oneOf: (1 to: 5).
	amb deny: cooper = 1.
	amb deny: (fletcher - cooper) abs = 1.

	miller _ amb oneOf: (1 to: 5).
	amb assert: miller > cooper.

	baker _ amb oneOf: (1 to: 5).
	amb deny: baker = 5.
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'avi 4/28/2004 11:31'!
testMaybe
	|x y z|
	x _ amb maybe.
	y _ amb maybe.
	z _ amb maybe not.

	amb deny: x = y.
	amb deny: x = z.
	
	self assert: x.
	self deny: y.
	self deny: z.! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumber
	^ self pickANumberGreaterThan: 0! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'avi 4/26/2004 14:45'!
testSicpLogicProblem
	"Baker, Cooper, Fletcher, Miller, and Smith live on different floors of an apartment house that contains only five floors. Baker does not live on the top floor. Cooper does not live on the bottom floor. Fletcher does not live on either the top or the bottom floor. Miller lives on a higher floor than does Cooper. Smith does not live on a floor adjacent to Fletcher's. Fletcher does not live on a floor adjacent to Cooper's. Where does everyone live?"

"This implementation is too slow - uncomment to actually run it."
	
"	|baker cooper fletcher miller smith|
	baker _ amb oneOf: (1 to: 5).
	cooper _ amb oneOf: (1 to: 5).
	fletcher _ amb oneOf: (1 to: 5).
	miller _ amb oneOf: (1 to: 5).
	smith _ amb oneOf: (1 to: 5).
	
	amb assert: (Set new add: baker; add: cooper; add: fletcher; add: miller; add: smith; size) = 5.
	
	amb deny: baker = 5.
	amb deny: cooper = 1.
	amb deny: fletcher = 5.
	amb deny: fletcher = 1.
	amb assert: miller > cooper.
	amb deny: (smith - fletcher) abs = 1.
	amb deny: (fletcher - cooper) abs = 1.
	
	self assert: baker = 3.
	self assert: cooper = 2.
	self assert: fletcher = 4.
	self assert: miller = 5.
	self assert: smith = 1.
"	! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumberAboveFive
	|x|
	x _ self pickANumber.
	amb assert: (x > 5).
	self assert: x = 6.
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:20'!
pickANumberGreaterThan: aNumber
	^ amb valueOf: [aNumber + 1] or: [self pickANumberGreaterThan: aNumber + 1]! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:43'!
testAllValuesAboveFive
	|x results|
	results _ amb allValues:
				[x _ amb oneOf: (1 to: 10).
				amb assert: (x > 5).
				x].			
	self assert: results = #(6 7 8 9 10).
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 02:27'!
testSolveAnEquation
	|x y|
	x _ amb oneOf: (1 to: 10).
	y _ amb oneOf: (1 to: 10).
	amb assert: (y * x) = 42.
	self assert: x = 6.
	self assert: y = 7.
! !

!AmbTest methodsFor: 'as yet unclassified' stamp: 'ab 12/6/2002 12:21'!
testPickANumber
	self assert: self pickANumber = 1.! !

!Stream methodsFor: '*seaside2-squeak' stamp: 'avi 8/31/2003 15:48'!
closed
	^false! !

!UndefinedObject methodsFor: '*seaside2' stamp: 'ab 11/11/2002 12:06'!
renderOn: html
! !

!Morph methodsFor: '*seaside2-squeak' stamp: 'ab 5/28/2003 23:31'!
asMIMEDocument
	^ self imageForm asMIMEDocument! !

!Dictionary methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:48'!
inspectorFields
	^ self! !

Notification subclass: #WADynamicVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Utilities'!

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:25'!
value
	^ self raiseSignal! !

WADynamicVariable subclass: #WAActiveContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Components-Decorations'!

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:13'!
use: anObject during: aBlock
	^ aBlock
		on: self
		do: [:n | n resume: anObject]! !

!WADynamicVariable class methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:12'!
defaultValue
	^ nil! !

!WADynamicVariable methodsFor: 'as yet unclassified' stamp: 'avi 3/29/2004 14:12'!
defaultAction
	self resume: self class defaultValue! !

WADynamicVariable subclass: #WACurrentSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

Notification subclass: #WARenderNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-RenderLoop'!

Notification subclass: #WAAnswerNotification
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Component'!

!WAAnswerNotification methodsFor: 'as yet unclassified' stamp: 'avi 3/26/2004 16:23'!
value
	^ value! !

!WAAnswerNotification class methodsFor: 'as yet unclassified' stamp: 'avi 4/27/2004 14:24'!
answer: anObject
	(self new value: anObject) raiseSignal! !

!WAAnswerNotification methodsFor: 'as yet unclassified' stamp: 'avi 3/26/2004 16:23'!
value: anObject
	value _ anObject! !

Notification subclass: #WAPageExpired
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Session'!

PackageInfo subclass: #SeasideVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/24/2003 23:10'!
packageName
	^ 'SeasideVW'! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW3
	VW3PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW3.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 6/14/2003 17:46'!
externalName
	^ 'Seaside'! !

!SeasideVWInfo class methodsFor: 'as yet unclassified' stamp: 'ab 5/31/2003 17:00'!
fileOutVW5
	VW5PackageExporter fileOutPackage: self default on: (FileStream forceNewFileNamed: 'SeasideVW5.st')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'avi 3/20/2004 17:55'!
ignoredCategories
	^ #('Platform' 'Base-Connections' 'Rendering-Buttons' 'Components-Tools-Squeak')! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'avi 3/20/2004 17:55'!
includesSystemCategory: aString
	^ (aString beginsWith: 'Seaside-') and: [(self ignoredCategories includes: (aString copyAfter: $-)) not]! !

!SeasideVWInfo methodsFor: 'as yet unclassified' stamp: 'ab 5/28/2003 23:13'!
isYourClassExtension: aString
	^ (self category: aString asLowercase matches: '*seaside2')
		and: [(aString endsWith: 'squeak') not]! !

PackageInfo subclass: #Seaside2Info
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Platform'!

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'cwp 4/25/2004 18:40'!
systemCategoryPrefix
	^ 'Seaside'! !

!Seaside2Info class methodsFor: 'as yet unclassified' stamp: 'avi 3/24/2004 12:19'!
initialize
	[self new register] on: MessageNotUnderstood do: ["must be an old version of PackageInfo"]! !

!Seaside2Info methodsFor: 'as yet unclassified' stamp: 'ab 10/26/2002 15:41'!
packageName
	^ 'Seaside2'! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'avi 4/14/2004 23:39'!
asMIMEDocument
	^ MIMELocalFileDocument contentType: 'text/plain' contentStream:  self! !

!PositionableStream methodsFor: '*seaside2-squeak' stamp: 'ab 7/11/2003 00:10'!
upToAndSkipThroughAll: aCollection
	^ self upToAll: aCollection! !

!BlockContext methodsFor: '*seaside2' stamp: 'ab 2/11/2003 20:09'!
handleRequest: aRequest
	^ self value: aRequest! !

!BlockContext methodsFor: '*seaside2' stamp: 'ac 5/16/2003 16:30'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

!Parser methodsFor: '*seaside2-squeak-override' stamp: 'ab 2/21/2003 02:00'!
interactive

	^ (requestor == nil or: [requestor isKindOf: SyntaxError] or: [requestor isKindOf: WAMethodEditor]) not! !

!Form methodsFor: '*seaside2-squeak' stamp: 'avi 4/29/2004 13:00'!
asMIMEDocument 
	| aStream |
	aStream _ (RWBinaryOrTextStream on: '').
	GIFReadWriter putForm: (self asFormOfDepth: 8) onStream: aStream.
	^MIMEDocument contentType: 'image/gif' content: aStream contents! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 7/10/2003 11:40'!
value: anObject
	^ self evaluateWithArguments: (Array with: anObject)! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 7/10/2003 11:40'!
evaluateWithArguments: anArray
	^ self valueWithArguments: anArray! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 10/10/2002 01:40'!
fixTemps! !

!MessageSend methodsFor: '*seaside2' stamp: 'ab 3/5/2003 18:30'!
numArgs
	^ selector numArgs! !

!MessageSend methodsFor: '*seaside2-squeak' stamp: 'ab 8/24/2003 16:38'!
valueWithPossibleArgs: anArray 

	self numArgs = 0 ifTrue: [^self value].
	self numArgs = anArray size ifTrue: [^self valueWithArguments: anArray].
	self numArgs > anArray size ifTrue: [
		^self valueWithArguments: anArray,
				(Array new: (self numArgs - anArray size))
	].
	^self valueWithArguments: (anArray copyFrom: 1 to: self numArgs)

! !

!Collection methodsFor: '*seaside2' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|i|
	i _ 0.
	^ self asArray collect: [:each | i _ i + 1. i -> each]! !

!String methodsFor: '*seaside2' stamp: 'ab 1/11/2003 12:46'!
printHtmlOn: aStream
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'ab 7/3/2003 13:04'!
asMIMEDocument 
	^ SeasidePlatformSupport mimeDocumentClass contentType: 'text/plain' content: self! !

!String methodsFor: '*seaside2' stamp: 'avi 3/16/2004 16:33'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words _ WriteStream on: String new.
	read _ ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord _ WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x _ read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord _ currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord _ capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents ! !

!String methodsFor: '*seaside2' stamp: 'ab 3/29/2003 00:15'!
prettyPrintHtmlOn: aStream indentLevel: aNumber
	aStream nextPutAll: self! !

!String methodsFor: '*seaside2' stamp: 'jf 2/18/2004 15:21'!
renderOn: html indentLevel: level
	html text: self! !

!Integer methodsFor: '*seaside2' stamp: 'ab 6/3/2003 00:58'!
printStringAsCents
	^ '$', (self // 100) asString, '.', (self \\ 100) asTwoCharacterString! !

!Array methodsFor: '*seaside2' stamp: 'ab 10/26/2002 21:26'!
renderOn: html
	self do: [:ea | ea renderOn: html]! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber put: anObject
	^ self at: aNumber put: anObject! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 5/22/2004 12:57'!
homeReceiver
	^ self home receiver! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localSize
	^ self size! !

!ContextPart methodsFor: '*seaside2-squeak' stamp: 'avi 4/24/2004 12:27'!
localAt: aNumber
	^ self at: aNumber! !
WAExternalID initialize!
WAConfigurationPool initialize!
WAAbstractHtmlBuilder initialize!
WAKom initialize!
WAMultiCounter initialize!
WAStore initialize!
WADispatcherEditor initialize!
WAWebTreeExample initialize!
WACounter initialize!
Seaside2Info initialize!
